angular.module('stwo.dashboard', ["stwo.core"])
    .config(function($stateProvider, $urlRouterProvider, moduleStoreProvider) {

        moduleStoreProvider.registerModule({
            name: "dashboard",
            links: [{
                    name:"DASHBOARD",
                    category: "navigation",
                    icon: "fa fa-map-marker",
                    sref: "secure.dashboard",
                    sort: 5,
                    color: "success"
                }]
        });

        $stateProvider
            .state("secure.dashboard",
                {
                    url: "/dashboard",
                    templateUrl: "aktive-spor/dashboard/dashboard.html",
                    controller: "DashboardController"
                })
    });
	
	
angular.module('stwo.dashboard').controller('DashboardController', function ($scope, $controller, $state, notificationService, moduleStore) {
    $controller('BaseListContentController', {$scope: $scope});
        $scope.pagination.max = 14;
    $scope.super({clazz: 'asset', downloadUrl: '/asset?select=name+tags+type+tracked+image+icon+lastValidPosition&sort=name&order=asc'});

    $scope.assetClicked = function(asset) {
        $state.go("secure.content.asset.detail", {id:asset.id});
    }
	
	$scope.$watch("items.length", function() {
		if ($scope.items && $scope.items.length == 1) {
			$state.go("secure.content.asset.detail", {id:$scope.items[0].id});
		}
	});
});