﻿angular.module('stwo.core',['stwo.core', 'stwo.glue', 'angular-google-gapi'])
        .factory('googleService', ['$rootScope', 'GAuth',function($http, $location, $translate, $q, moduleStore, pushService,Gauth) {
    // change these URLs accordingly
    var baseUrlApi = 'api3/';
    var baseUrl = stwoGlobal.smarttrackerUrl;//'https://stage.smarttracker.no/web/';
    var clientId = gAuthInfor.clientId;
    var user = null;
    var token = null;
    var customer = null;
    var availableCustomers = [];
    var provider = null;
    var availableProviders = [];
    var accessRights = {};

    //example user {username: 'brukernavn', token: 'TOKENTOKEN'}
    var tokens = [];
    
    var _language = stwoGlobal.defaultLanguage;

    //restoring previously stored tokens
    if (localStorage["tokens"] && localStorage["tokens"] !== null) {
        var storedTokens = JSON.parse(localStorage["tokens"]);
        for (var n = 0; n < storedTokens.length; n++) {
                tokens.push(storedTokens[n]);
        }
    }
    
    
    var deferredLoginData = {login: {started: false, done: false, promises: []}}
    var i = {};
    
    i.url = function() {
        return baseUrl;
    }
    
    i.language = function(languageCode) {
        if (languageCode) {
            localStorage["language"] = languageCode;
            $translate.use(languageCode);
            _language = languageCode;
        }
        return _language;
    }
    
    i.isLoggedInDelayed = function() {
        var defer = $q.defer();
        
        if (i.isLoggedIn()) {
            defer.resolve();
            return defer.promise;
        }
        
        if (deferredLoginData.login.done) {
            if (i.isLoggedIn()) {
                defer.resolve();
            } else {
                defer.reject();
            }
            return defer.promise;
        }
        
        if (!deferredLoginData.login.started) {
            if (localStorage["lastUsername"] && localStorage["lastUsername"] !== "" && localStorage["lastUsername"] !== "null") {
                deferredLoginData.login.started = true;
                deferredLoginData.login.promises.push(defer);
                i.selectUser(localStorage["lastUsername"], null, true).then(function() {
                    deferredLoginData.login.done = true;
                    for (var n = 0; n < deferredLoginData.login.promises.length; n++) {
                        deferredLoginData.login.promises[n].resolve();
                    }
                    
                    i.language(localStorage["language"] ? localStorage["language"] : stwoGlobal.defaultLanguage); //TODO get user language and map provider here
                }, function() {
                    deferredLoginData.login.done = true;
                    for (var n = 0; n < deferredLoginData.login.promises.length; n++) {
                        deferredLoginData.login.promises[n].reject();
                    }
                })
            } else {
                deferredLoginData.login.started = true;
                deferredLoginData.login.done = true;
                defer.reject();
            }
        } else {
            deferredLoginData.login.promises.push(defer);
        }
        
        return defer.promise;
    }
    


    i.persistUsers = function() {
        var tokensToPersist = [];
        for (var n = 0; n < tokens.length; n++) {
            if (tokens[n].persist) {
                tokensToPersist.push(tokens[n]);
            }
        }
        localStorage["tokens"] = JSON.stringify(tokensToPersist);
    }

    i.addUser = function(userInfo) {
            i.removeUser(userInfo.username);
            tokens.push(userInfo);
            i.persistUsers();
    }
    i.removeUser = function(username) {
            for (var n = tokens.length - 1; n >= 0; n--) {
                    if (tokens[n].username === username) {
                            tokens.splice(n, 1);
                    }
            }
            i.persistUsers();
    }
    i.getUsers = function() {
            return tokens;
    }

    i.isLoggedIn = function() {
            return user && token;
    }

    i.getLoggedInUser = function() {
            return user;
    }

    i.getCustomerId = function() {
            return customer;
    }

    i.getProviderId = function() {
            return provider;
    }

    i.getAvailableCustomers = function() {
            return availableCustomers;
    }

    i.getAccessRights = function() {
            return accessRights;
    }

    i.getAvailableProviders = function() {
            return availableProviders;
    }

    i.changeProvider = function(newProviderId) {
            return $http({
                    method : 'PUT',
                    url : baseUrl + "api2/index",
                    data : {
                            provider : newProviderId
                    },
                    headers : {
                            "X-Auth-Token" : token
                    }
            }).then(function(response) {
                    $http.get(baseUrl + baseUrlApi, {
                            headers : {
                                    "X-Auth-Token" : token
                            }
                    }).then(function(response) {
                            moduleStore.serviceRepository()["notificationService"].clear();
                            i.updateUserData(response.data);
                            return response;
                    });
            });
    }

    i.changeCustomer = function(newCustomerId) {
        return $http({
                    method : 'PUT',
                    url : baseUrl + "api2/index",
                    data : {
                            customer : newCustomerId
                    },
                    headers : {
                            "X-Auth-Token" : token
                    }
            }).then(function(response) {
                    $http.get(baseUrl + baseUrlApi, {
                            headers : {
                                    "X-Auth-Token" : token
                            }
                    }).then(function(response) {
                            moduleStore.serviceRepository()["notificationService"].clear();
                            i.updateUserData(response.data);
                            return response;
                    });
            });
    }

    i.login = function(user) {
            var xsrf = $.param({
                    token : "true",
                    username : escape(user.username),
                    password : escape(user.password)
            });
            return $http({
                    method : 'POST',
                    url : baseUrl + "api2/login",
                    data : xsrf,
                    headers : {
                            'Content-Type' : 'application/x-www-form-urlencoded'
                    }
            }).then(function(response) {
                    console.log(response);
                    console.log(response.headers("X-Auth-Token"));
                    console.log(response.data.token);
                    
                    i.addUser({
                            username : user.username,
                            token : response.data.token,
                            persist: user.persist
                    });
                    
                    return response;
            });
    }

    i.selectUser = function(username, suppliedToken, doNotRedirect) {
        if (!suppliedToken) {
            for (var n = tokens.length - 1; n >= 0; n--) {
                if (tokens[n].username === username) {
                    token = tokens[n].token;
                }
            }
        } else {
            token = suppliedToken;
        }

        localStorage["lastUsername"] = username;
        
        return $http.get(baseUrl + baseUrlApi, {
                headers : {
                        "X-Auth-Token" : token
                }
            }).then(function(response) {
                i.updateUserData(response.data);
                return response;
            }, function(response) {
                if (!doNotRedirect) {
                    if (user) {
                        $location.path('/logout');
                    } else {
                        $location.path('/login');
                    }
                    $location.replace();
                    return;
                }
        });

    }

    i.refreshUser = function() {
            return $http.get(baseUrl + baseUrlApi, {
                    headers : {
                            "X-Auth-Token" : token
                    }
            }).then(function(response) {
                    i.updateUserData(response.data);
                    return response;
            }, function(response) {
                    if (user) {
                            $location.path('/logout');
                    } else {
                            $location.path('/login');
                    }
                    $location.replace();
                    return;
            });

    }

    i.updateUserData = function(data) {
        user = data;

        customer = data && data.customer ? data.customer.id : null;
        provider = data && data.provider ? data.provider.id : null;

        availableCustomers.splice(0, availableCustomers.length);
        if (data && data.customers) {
            for (var n = 0; n < data.customers.length; n++) {
                availableCustomers.push(data.customers[n]);
            }
        }

        availableProviders.splice(0, availableProviders.length);
        if (data && data.providers) {
            for (var n = 0; n < data.providers.length; n++) {
                availableProviders.push(data.providers[n]);
            }
        }
        
        for (var k in accessRights) {
            delete accessRights[k];
        }
        for (var k in user.access) {
            accessRights[k] = user.access[k];
        }
        
        
        moduleStore.serviceRepository()["pushService"].configure(token, user, customer, provider);
        moduleStore.serviceRepository()["pushService"].reconnect();
    }

    i.logout = function() {
        user = null;
        
        for (var n = tokens.length - 1; n >= 0; n--) {
            if (!tokens[n].persist) {
                tokens.splice(n, 1);
            }
        }
        i.persistUsers();
        
        moduleStore.serviceRepository()["notificationService"].clear();
        moduleStore.serviceRepository()["pushService"].disconnect();
    }

    i.authGet = function(url, opts) {
            if (!token) {
                    if (user) {
                            $location.path('/logout');
                    } else {
                            $location.path('/login');
                    }
                    $location.replace();
                    return;
            }

            return $http.get(baseUrl + baseUrlApi + url, {
                    headers : {
                            "X-Auth-Token" : token
                    }
            }).then(function(response) {
                    return response;
            }, function(response) {
                    if (!opts || !opts.onErrorDoNotRedirect) {
                            if (user) {
                                    $location.path('/logout');
                            } else {
                                    $location.path('/login');
                            }
                            $location.replace();
                    }
                    return;
            });
    }

    i.authPost = function(url, data) {
            if (!token) {
                    if (user) {
                            $location.path('/logout');
                    } else {
                            $location.path('/login');
                    }
                    $location.replace();
                    return;
            }

            return $http.post(baseUrl + baseUrlApi + url, data, {
                    headers : {
                            "X-Auth-Token" : token
                    }
            });
    }

    i.authPut = function(url, data) {
            if (!token) {
                    if (user) {
                            $location.path('/logout');
                    } else {
                            $location.path('/login');
                    }
                    $location.replace();
                    return;
            }

            return $http.put(baseUrl + baseUrlApi + url, data, {
                    headers : {
                            "X-Auth-Token" : token
                    }
            });
    }

    i.authDelete = function(url) {
            if (!token) {
                    if (user) {
                            $location.path('/logout');
                    } else {
                            $location.path('/login');
                    }
                    $location.replace();
                    return;
            }

            return $http.
            delete (baseUrl + baseUrlApi + url, {
                    data : {},
                    headers : {
                            "X-Auth-Token" : token
                    }
            });
    }

    moduleStore.serviceRepository()["smarttrackerService"] = i;
    return i;
}]);
