﻿angular.module('stwo.core').factory('dialogService', function($modal) {
    
    var i = {};
    
    i.prompt = function(title, text, config) {
        var cfg = {title: title, text: text};
        
        for (var k in config) {
            cfg[k] = config[k];
        }
        
        
        return $modal.open({
            templateUrl: 'core/html/prompt.html',
            controller: stwoCoreDialogPromptModalController,
            size: "md",
            resolve: {
                promptConfiguration: function() { return cfg }
            }
           
        }).result;
    }
    
    return i;
});

var stwoCoreDialogPromptModalController = function ($scope, $modalInstance, promptConfiguration) {

    $scope.title = promptConfiguration.title;
    $scope.text = promptConfiguration.text;
    $scope.multiline = true && promptConfiguration.multiline;
    $scope.disablePromptText = true && promptConfiguration.disablePromptText;
    $scope.nullAllowed = true && promptConfiguration.nullAllowed;
    $scope.prompt = {text: promptConfiguration.promptText ? promptConfiguration.promptText : ""};
    
    $scope.cancelButtonText = promptConfiguration.cancelButtonText ? promptConfiguration.cancelButtonText : "DIALOG_PROMPT_CANCEL";
    $scope.okButtonText = promptConfiguration.okButtonText ? promptConfiguration.okButtonText : "DIALOG_PROMPT_OK";
    $scope.nullButtonText = promptConfiguration.nullButtonText ? promptConfiguration.nullButtonText : "DIALOG_PROMPT_NULL";
    
    $scope.genericData = promptConfiguration.data;
    
    $scope.pickNull = function() {
        $modalInstance.close({data: $scope.genericData, promptText: null});
    }
    
    $scope.ok = function() {
        $modalInstance.close({data: $scope.genericData, promptText: $scope.prompt.text});
    }

    $scope.cancel = function () {
        $modalInstance.dismiss('cancel');
    };
};