angular.module('stwo.core').factory('favoritesService',
    function($localStorage) {


        // if favorites do not exist, create it
        if (!$localStorage.favorites) {
            $localStorage.favorites = {};
        }

        // at the end just take the favorites from the local storage
        var favorite = $localStorage.favorites;

        var i = {};

        i.favorites = function() {
            return favorite;
        }

        i.favoritesOfClazz = function(clazz) {
            if (!favorite[clazz]) {
                favorite[clazz] = {};
            }

            return favorite[clazz];
        }

        i.toggle = function(clazz, id) {
            // create any piece of favorites which does not exist
            if (!favorite[clazz]) {
                favorite[clazz] = {};
            }

            favorite[clazz][id] = !(true && favorite[clazz][id]);
        }

        i.isFavorite = function(clazz, id) {
            if (!favorite[clazz]) {
                favorite[clazz] = {};
            }

            return (true && $localStorage.favorites[clazz][id]);
        }

        //return the favorites of clazz as an array (use .join if string is needed)
        i.getListOfFavorites = function(clazz) {
            if (!favorite[clazz]) {
                favorite[clazz] = {};
            }

            var outArray = [];

            for (var k in favorite[clazz]) {
                if (favorite[clazz][k]) {
                    outArray.push(k);
                }
            }

            return outArray;
        }

        return i;
    });