﻿angular.module('stwo.core').provider('moduleStore', function() {

    var _modules = {};
    var _links = [];
    var _categories = [];
    var _rootLinks = [];
    var _states = {
            missingCustomer : "^",
            notLoggedIn : "^"
    };
    var _notificationHandlers = {};
    var _serviceRepository = {};

    var _possibleFiltersPerClazz = {};

    //	{name: "alarm", links: [{label:"ALARMS", category: "" , sref: "secure.content.alarm", sort: 15}]}
        this.registerLink = function(link) {
        if (_links.length === 0) {
                _links.push(link)
        } else {
                for (var place = 0; place < _links.length; place++) {//keep the links and rootlinks sorted according to the "sort" value
                    if (link.sort < _links[place].sort) {
                            _links.splice(place, 0, link);
                            break;
                    }
                }
                if (place === _links.length) {
                    _links.push(link);
                }
        }
        if (link.category === "navigation") {
                if (_rootLinks.length === 0) {
                        _rootLinks.push(link)
                } else {
                        for (var place = 0; place < _rootLinks.length; place++) {//keep the links and rootlinks sorted according to the "sort" value
                                if (link.sort < _rootLinks[place].sort) {
                                        _rootLinks.splice(place, 0, link);
                                        break;
                                }
                        }
                    if (place === _rootLinks.length) {
                        _rootLinks.push(link);
                    }
                }
        }
        if (!link.category || link.category == "") {//this test is temporary while I manage to change everywhere with meaningful cathegory names
                console.log("NO category was given. See moduleStoreProvider");
        }
    }
    this.registerModule = function(moduleInfo) {
      if (moduleInfo.categories) {
            for (var n = 0; n < moduleInfo.categories.length; n++) {
                if (_categories.length === 0) {
                    _categories.push(moduleInfo.categories[n])
                } else {
                    for (var place = 0; place < _categories.length; place++) {
                        if (moduleInfo.categories[n].sort < _categories[place].sort) {
                                _categories.splice(place, 0, moduleInfo.categories[n]);
                                break;
                        }
                    }
                    if (place === _categories.length) {
                        _categories.push(moduleInfo.categories[n]);
                    }
                }
            }
        };        
        if (moduleInfo.links) {
            for (var n = 0; n < moduleInfo.links.length; n++) {
                moduleInfo.links[n].module = moduleInfo.name;
                if (_links.length == 0) {
                        _links.push(moduleInfo.links[n])
                } else {
                        for (var place = 0; place < _links.length; place++) {//keep the links and rootlinks sorted according to the "sort" value
                                if (moduleInfo.links[n].sort < _links[place].sort) {
                                        _links.splice(place, 0, moduleInfo.links[n]);
                                        break;
                                }
                        }
                        if(place == _links.length){_links.push(moduleInfo.links[n])}
                }
                if (moduleInfo.links[n].category == "navigation") {
                        if (_rootLinks.length == 0) {
                                _rootLinks.push(moduleInfo.links[n])
                        } else {
                                for (var place = 0; place < _rootLinks.length; place++) {//keep the links and rootlinks sorted according to the "sort" value
                                        if (moduleInfo.links[n].sort < _rootLinks[place].sort) {
                                                _rootLinks.splice(place, 0, moduleInfo.links[n]);
                                                break;
                                        }
                                }
                        if(place == _rootLinks.length){_rootLinks.push(moduleInfo.links[n])}
                        }
                }
                if (!moduleInfo.links[n].category || moduleInfo.links[n].category == "") {//this test is temporary while I manage to change everywhere with meaningful cathegory names
                        console.log("NO category was given. See moduleStoreProvider");
                }
            }
        }
        if (moduleInfo.notificationHandlers) {
            _notificationHandlers[moduleInfo.name] = moduleInfo.notificationHandlers;
        }
        _modules[moduleInfo.name] = moduleInfo;
    }

    this.modules = function() {
        return _modules;
    };
    this.categories = function() {
        return _categories;
    };
    this.states = function() {
        return _states;
    };
    this.getPossibleFiltersForClazz = function(clazz) {
        return _possibleFiltersPerClazz[clazz];
    };
    this.addPossibleFilter = function(clazz, filter) {
        if (!_possibleFiltersPerClazz[clazz]) {
            _possibleFiltersPerClazz[clazz] = [];
        }
        _possibleFiltersPerClazz[clazz].push(filter);
        return _possibleFiltersPerClazz[clazz];
    };
    this.notificationHandlers = function() {
        return _notificationHandlers;
    };
    this.links = function() {
        return _links;
    };
    this.serviceRepository = function() {
        return _serviceRepository;
    };
    this.linksOfCategory = function(category, module) {
        var linkList = [];
        for (var n = 0; n < _links.length; n++) {
            if ( (!module || _links[n].module === module) && (!category || _links[n].category === category) ) {
                linkList.push(_links[n]);
            }
        }
        return linkList;
    };
    this.rootLinks = function() {
        return _rootLinks;
    };

    this.$get = function() {
        return this;
    };

}); 