﻿angular.module('stwo.core').factory('notificationService', function(moduleStore) {
    var i = {
        changed: {dismissed: 0, added: 0, removed: 0}
    };


    /*
        notificationService.add({
            id : "somethingunique5",
            time : "2014-10-24T15:12:51.0",
            level : "danger", //success, info, warning, danger
            name : "The roof is on fire",
            module: "alarm",
            dismissable: false,
            dismissed: false
        });
    */



    var notifications = [];

    i.add = function(notification) {
        var updated = false;

        notification.dismiss = i.dismiss;
        notification.view = i.view;

        for (var n = notifications.length - 1; n >= 0; n--) {
            if (notifications[n].id === notification.id) {
                    notifications[n] = notification;
                    updated = true;
                    break;
            }
        }
        if (!updated) {
            notifications.push(notification);
        }
        notifications.sort(function(a, b){
            return a.time > b.time ? 1 : -1;
        })
        i.changed.added++;
    }

    i.remove = function(notification) {
        for (var n = notifications.length - 1; n >= 0; n--) {
            if (notifications[n].id === notification.id) {
                notifications.splice(n, 1);
                i.changed.removed++;
            }
        }
    }

    i.clear = function() {
        notifications.splice(0, notifications.length);
        i.changed.removed++;
    }
    
    i.silentDismiss = function(notificationId) {
        for (var n = notifications.length - 1; n >= 0; n--) {
            if (notifications[n].id === notificationId) {
                notifications[n].dismissed = true;
                i.changed.dismissed++;
                break;
            }
        }
    }

    i.dismiss = function(notification) {
        var dismissFunction = function() {
            for (var n = notifications.length - 1; n >= 0; n--) {
                if (notifications[n].id === notification.id) {
                    notifications[n].dismissed = true;
                    i.changed.dismissed++;
                }
            }
        }

        var notificationsHandlers = moduleStore.notificationHandlers();

        if (notification.module && notificationsHandlers[notification.module].dismiss) {
            notificationsHandlers[notification.module].dismiss(notification, dismissFunction);
        } else {
            dismissFunction();
        }
    }

    i.view = function(notification) {
        var notificationsHandlers = moduleStore.notificationHandlers();

        if (notification.module && notificationsHandlers[notification.module].view) {
            notificationsHandlers[notification.module].view(notification);
        } else {
            alert("Viewing notifications not implemented for module " + notification.module);
        }
    }

    i.poll = function() {
        var notificationsHandlers = moduleStore.notificationHandlers();
        for(var k in notificationsHandlers) {
            if (notificationsHandlers[k].poll) {
                notificationsHandlers[k].poll();
            }
        }
    }
    i.list = function() {
        return notifications;
    }
    i.undismissed = function() {
        var out = [];
        for(var n = 0; n < notifications.length; n++) {
            if (!notifications[n].dismissed) {
                out.push(notifications[n]);
            }
        }
        return out;
    }

    moduleStore.serviceRepository()["notificationService"] = i;
    return i;
});