angular.module('stwo.core').factory('smarttrackerService', function ($http, $location, $translate, $q, moduleStore, pushService) {
    // change these URLs accordingly
    var baseUrlApi = 'api3/';
    var baseUrl = stwoGlobal.smarttrackerUrl;//'https://stage.smarttracker.no/web/';

    var fileBaseUrl = stwoGlobal.fileBaseUrl;
    var user = null;
    var token = null;
    var customer = null;
    var availableCustomers = [];
    var provider = null;
    var availableProviders = [];
    var accessRights = {};
    var formDataObject = function (data) {

        var fd = new FormData();
        angular.forEach(data, function (value, key) {
            fd.append(key, value);
        });
        return fd;
    };
    //example user {username: 'brukernavn', token: 'TOKENTOKEN'}
    var tokens = [];
    var googeToken = "";
    var _language = stwoGlobal.defaultLanguage;

    //restoring previously stored tokens
    if (localStorage["tokens"] && localStorage["tokens"] !== null) {
        var storedTokens = JSON.parse(localStorage["tokens"]);
        for (var n = 0; n < storedTokens.length; n++) {
            tokens.push(storedTokens[n]);
        }
    }


    var deferredLoginData = {login: {started: false, done: false, promises: []}}
    var i = {};

    i.url = function () {
        return baseUrl;
    }

    i.language = function (languageCode) {
        if (languageCode) {
            localStorage["language"] = languageCode;
            $translate.use(languageCode);
            _language = languageCode;
        }
        return _language;
    }
    i.getGoogleToken = function () {
        return googeToken;
    }
    i. mobileCheck = function(){
        var check = false;
        (function (a) {
            if (/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(a) || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0, 4)))
                check = true
        })(navigator.userAgent || navigator.vendor || window.opera);
        return check;        
    }

    // get stored google authentication token
    i.googleAuth = function () {


        var defer = $q.defer();
        if (i.isLoggedIn()) {
            i.authGet(i.getCustomerId() + '/asset?select=*', "testing st").then(function (response) {
                if (response.data.result[0].properties) {
                    angular.forEach(response.data.result[0].properties, function (value, key) {

                        if (value.name == "oauth") {
                            if (value.value !== "" && value.value !== null) {
                                defer.resolve(value.value);
                                googeToken = value.value;
                                return defer.promise;
                            } else {
                                defer.reject();
                                return defer.promise;
                            }
                        }
                    });
                }


            }, function (response) {
                defer.reject();
                return defer.promise;
            });
        } else {
            defer.reject();
        }
        return defer.promise;
    }
    i.googleAuthGet = function (url, opts) {


        return $http.get(baseUrl + baseUrlApi + url, {
            headers: {
                "X-Auth-Token": token
            }
        }).then(function (response) {
            return response;
        }, function (response) {
            if (!opts || !opts.onErrorDoNotRedirect) {
                if (user) {
                    $location.path('/logout');
                } else {
                    $location.path('/login');
                }
                $location.replace();
            }
            return;
        });
    }
    i.isLoggedInDelayed = function () {
        var defer = $q.defer();

        if (i.isLoggedIn()) {
            defer.resolve();
            return defer.promise;
        }

        if (deferredLoginData.login.done) {
            if (i.isLoggedIn()) {
                defer.resolve();
            } else {
                defer.reject();
            }
            return defer.promise;
        }

        if (!deferredLoginData.login.started) {
            if (localStorage["lastUsername"] && localStorage["lastUsername"] !== "" && localStorage["lastUsername"] !== "null") {
                deferredLoginData.login.started = true;
                deferredLoginData.login.promises.push(defer);
                i.selectUser(localStorage["lastUsername"], null, true).then(function () {
                    deferredLoginData.login.done = true;
                    for (var n = 0; n < deferredLoginData.login.promises.length; n++) {
                        deferredLoginData.login.promises[n].resolve();
                    }

                    i.language(localStorage["language"] ? localStorage["language"] : stwoGlobal.defaultLanguage); //TODO get user language and map provider here
                }, function () {
                    deferredLoginData.login.done = true;
                    for (var n = 0; n < deferredLoginData.login.promises.length; n++) {
                        deferredLoginData.login.promises[n].reject();
                    }
                })
            } else {
                deferredLoginData.login.started = true;
                deferredLoginData.login.done = true;
                defer.reject();
            }
        } else {
            deferredLoginData.login.promises.push(defer);
        }

        return defer.promise;
    }



    i.persistUsers = function () {
        var tokensToPersist = [];
        for (var n = 0; n < tokens.length; n++) {
            if (tokens[n].persist) {
                tokensToPersist.push(tokens[n]);
            }
        }
        localStorage["tokens"] = JSON.stringify(tokensToPersist);
    }

    i.addUser = function (userInfo) {
        i.removeUser(userInfo.username);
        tokens.push(userInfo);
        i.persistUsers();
    }
    i.removeUser = function (username) {
        for (var n = tokens.length - 1; n >= 0; n--) {
            if (tokens[n].username === username) {
                tokens.splice(n, 1);
            }
        }
        i.persistUsers();
    }
    i.getUsers = function () {
        return tokens;
    }

    i.isLoggedIn = function () {
        return user && token;
    }

    i.getLoggedInUser = function () {
        return user;
    }

    i.getCustomerId = function () {
        return customer;
    }

    i.getProviderId = function () {
        return provider;
    }

    i.getAvailableCustomers = function () {
        return availableCustomers;
    }

    i.getAccessRights = function () {
        return accessRights;
    }

    i.getAvailableProviders = function () {
        return availableProviders;
    }

    i.changeProvider = function (newProviderId) {
        return $http({
            method: 'PUT',
            url: baseUrl + "api2/index",
            data: {
                provider: newProviderId
            },
            headers: {
                "X-Auth-Token": token
            }
        }).then(function (response) {
            $http.get(baseUrl + baseUrlApi, {
                headers: {
                    "X-Auth-Token": token
                }
            }).then(function (response) {
                moduleStore.serviceRepository()["notificationService"].clear();
                i.updateUserData(response.data);
                return response;
            });
        });
    }

    i.changeCustomer = function (newCustomerId) {
        return $http({
            method: 'PUT',
            url: baseUrl + "api2/index",
            data: {
                customer: newCustomerId
            },
            headers: {
                "X-Auth-Token": token
            }
        }).then(function (response) {
            $http.get(baseUrl + baseUrlApi, {
                headers: {
                    "X-Auth-Token": token
                }
            }).then(function (response) {
                moduleStore.serviceRepository()["notificationService"].clear();
                i.updateUserData(response.data);
                return response;
            });
        });
    }

    i.login = function (user) {
        var xsrf = $.param({
            token: "true",
            username: escape(user.username),
            password: escape(user.password)
        });
        return $http({
            method: 'POST',
            url: baseUrl + "api2/login",
            data: xsrf,
            headers: {
                'Content-Type': 'application/x-www-form-urlencoded'
            }
        }).then(function (response) {
            console.log(response);
            console.log(response.headers("X-Auth-Token"));
            console.log(response.data.token);

            i.addUser({
                username: user.username,
                token: response.data.token,
                persist: user.persist
            });

            return response;
        });
    }
//    i.getFileServerToken=function(user){
//                    // get file server token  this is not needed since the token is the same as login retrived token
//                  console.log(" get file server token");  
//                  return  $http({
//                        method:'post',
//                        url:fileBaseUrl+'/files/login.php',
//                        headers:{'Content-Type' : 'application/json'},
//                        data:{"username":escape(user.username),"password":escape(user.password)}
//                    }).then(function(res){
//                       console.log("testing file server",res); 
//                       return res;
//                    });        
//    }

    i.selectUser = function (username, suppliedToken, doNotRedirect) {
        if (!suppliedToken) {
            for (var n = tokens.length - 1; n >= 0; n--) {
                if (tokens[n].username === username) {
                    token = tokens[n].token;
                }
            }
        } else {
            token = suppliedToken;
        }

        localStorage["lastUsername"] = username;

        return $http.get(baseUrl + baseUrlApi, {
            headers: {
                "X-Auth-Token": token
            }
        }).then(function (response) {
            i.updateUserData(response.data);
            return response;
        }, function (response) {
            if (!doNotRedirect) {
                if (user) {
                    $location.path('/logout');
                } else {
                    $location.path('/login');
                }
                $location.replace();
                return;
            }
        });

    }

    i.refreshUser = function () {
        return $http.get(baseUrl + baseUrlApi, {
            headers: {
                "X-Auth-Token": token
            }
        }).then(function (response) {
            i.updateUserData(response.data);
            return response;
        }, function (response) {
            if (user) {
                $location.path('/logout');
            } else {
                $location.path('/login');
            }
            $location.replace();
            return;
        });

    }

    i.updateUserData = function (data) {
        user = data;

        customer = data && data.customer ? data.customer.id : null;
        provider = data && data.provider ? data.provider.id : null;

        availableCustomers.splice(0, availableCustomers.length);
        if (data && data.customers) {
            for (var n = 0; n < data.customers.length; n++) {
                availableCustomers.push(data.customers[n]);
            }
        }

        availableProviders.splice(0, availableProviders.length);
        if (data && data.providers) {
            for (var n = 0; n < data.providers.length; n++) {
                availableProviders.push(data.providers[n]);
            }
        }

        for (var k in accessRights) {
            delete accessRights[k];
        }
        for (var k in user.access) {
            accessRights[k] = user.access[k];
        }


        moduleStore.serviceRepository()["pushService"].configure(token, user, customer, provider);
        moduleStore.serviceRepository()["pushService"].reconnect();
    }

    i.logout = function () {
        user = null;

        for (var n = tokens.length - 1; n >= 0; n--) {
            if (!tokens[n].persist) {
                tokens.splice(n, 1);
            }
        }
        i.persistUsers();

        moduleStore.serviceRepository()["notificationService"].clear();
        moduleStore.serviceRepository()["pushService"].disconnect();
    }

    i.authGet = function (url, opts) {
        if (!token) {
            if (user) {
                $location.path('/logout');
            } else {
                $location.path('/login');
            }
            $location.replace();
            return;
        }

        return $http.get(baseUrl + baseUrlApi + url, {
            headers: {
                "X-Auth-Token": token
            }
        }).then(function (response) {
            return response;
        }, function (response) {
            if (!opts || !opts.onErrorDoNotRedirect) {
                if (user) {
                    $location.path('/logout');
                } else {
                    $location.path('/login');
                }
                $location.replace();
            }
            return;
        });
    }
    i.getToken = function () {
        return token;
    }
    i.authPostFile = function (data, withToken) {
        if (!token) {
            if (user) {
                $location.path('/logout');
            } else {
                $location.path('/login');
            }
            $location.replace();
            return;
        }

        var headers = {
            "Content-Type": undefined,
            "Access-Control-Allow-Origin": "*"
        };
        if (withToken) {
            headers["X-Auth-Token"] = token;
        }
        var post = {
            method: 'POST',
            url: fileBaseUrl + "/files/resource.php",
            transformRequest: formDataObject(),
            headers: headers,
            data: data
        };
        return $http(post);
//            return $http.post(fileBaseUrl+"/files/resource0.php",data,{
//                    headers : {
//                            "X-Auth-Token" : token,
//                            "Content-Type":"multipart/form-data",  
//                            "Access-Control-Allow-Origin":"*"
//                    }                
//            });

    }
    i.authGetFile = function (parameters, withToken) {
        if (!token) {
            if (user) {
                $location.path('/logout');
            } else {
                $location.path('/login');
            }
            $location.replace();
            return;
        }
            console.log("auth get file", parameters);
            var url = fileBaseUrl + "/files/resource.php";
            console.log(parameters.type && !parameters.resourceID);
            if(parameters.type && !parameters.resourceID){
                url = url+"?type=" + parameters.type;
            } else if (!parameters.type && parameters.resourceID){
                url = url+"?resourceID=" + parameters.resourceID;
            } else if (parameters.resourceID && parameters.type){
                url = url+"?resourceID=" + parameters.resourceID +"&type=" + parameters.type;
            } 
            url = url + (parameters.assetID?"&assetID="+parameters.assetID:"");
            console.log(url);
        if (withToken) {
            return $http.get(url, {
                headers: {
                    "X-Auth-Token": token,
                    "Access-Control-Allow-Origin": "*"
                }
            });
        } else {
            return $http.get(url, {
                headers: {
//                                "X-Auth-Token" : token,  
                    "Access-Control-Allow-Origin": "*"
                }
            });
        }
    }
    i.authPost = function (url, data) {
        if (!token) {
            if (user) {
                $location.path('/logout');
            } else {
                $location.path('/login');
            }
            $location.replace();
            return;
        }

        return $http.post(baseUrl + baseUrlApi + url, data, {
            headers: {
                "X-Auth-Token": token
            }
        });
    }

    i.authPut = function (url, data) {
        if (!token) {
            if (user) {
                $location.path('/logout');
            } else {
                $location.path('/login');
            }
            $location.replace();
            return;
        }

        return $http.put(baseUrl + baseUrlApi + url, data, {
            headers: {
                "X-Auth-Token": token
            }
        });
    }

    i.authDelete = function (url) {
        if (!token) {
            if (user) {
                $location.path('/logout');
            } else {
                $location.path('/login');
            }
            $location.replace();
            return;
        }

        return $http.
                delete(baseUrl + baseUrlApi + url, {
                    data: {},
                    headers: {
                        "X-Auth-Token": token
                    }
                });
    }
    i.authDeleteFile = function (parameters, withToken) {
        if (!token) {
            if (user) {
                $location.path('/logout');
            } else {
                $location.path('/login');
            }
            $location.replace();
            return;
        }

        var assetID = parameters.assetID;
        var resourceID = parameters.resourceID;
        if (withToken) {
            return $http.
                    delete(fileBaseUrl + "/files/resource.php?assetID=" + assetID + "&resourceID=" + resourceID);
        }

        return $http.
                delete(fileBaseUrl + "/files/resource.php?assetID=" + assetID + "&resourceID=" + resourceID, {
                    headers: {
                        "X-Auth-Token": token,
                        "Access-Control-Allow-Origin": "*"
                    }
                });
    }
    moduleStore.serviceRepository()["smarttrackerService"] = i;
    return i;
});
