angular.module('stwo.dashboard', ["stwo.core"])
    .config(function($stateProvider, $urlRouterProvider, moduleStoreProvider) {

        moduleStoreProvider.registerModule({
            name: "dashboard",
            links: [{
                    name:"DASHBOARD",
                    category: "navigation",
                    icon: "fa fa-map-marker",
                    sref: "secure.dashboard",
                    sort: 5,
                    color: "success"
                }]
        });

        $stateProvider
            .state("secure.dashboard",
                {
                    url: "/dashboard",
                    templateUrl: "glue/dashboard/dashboard.html",
                    controller: "DashboardController"
                })
    });
	
	
angular.module('stwo.dashboard').controller('DashboardController', function ($scope, $state, notificationService, moduleStore) {
    $scope.notifications = notificationService.undismissed();
    $scope.notificationsChanged = notificationService.changed;

    $scope.$watch("notificationsChanged.dismissed + notificationsChanged.added + notificationsChanged.removed", function() {
        $scope.notifications = notificationService.undismissed();
    })

    $scope.allLinks = moduleStore.links();

    $scope.mainLinkPerModule = {};
    
    $scope.linkClicked = function(link) {
        if (link.stateParams) {
            $state.go(link.sref.split("(")[0], link.stateParams);
            console.log("link.stateparameters:"+link.stateParams);
            console.log("--------------------------------------");
        } else {
            $state.go(link.sref);
            console.log("link.sref:"+link.sref);
            console.log("--------------------------------------");
        }
    }
    
    $scope.filtersPerModule = {};
    for (var n = 0; n < $scope.allLinks.length; n++) {
        var l = $scope.allLinks[n];
        if (l.module !== "dashboard") {
            if (!$scope.filtersPerModule[l.module]) {
                $scope.filtersPerModule[l.module] = [];
            }
            if (!$scope.mainLinkPerModule[l.module] && l.category === "navigation") {
                $scope.mainLinkPerModule[l.module] = l;
            }
            if (l.category === "filter") {
                $scope.filtersPerModule[l.module].push(l);
            }
        }
    }
    
});