angular.module('stwo.poseidonCalendar').controller('eventEditingController', function (youtubeEmbedUtils, $q, $controller, $stateParams, $timeout, themeService, $rootScope, $locale, $scope, $http, $modal, ef, angularMomentConfig, smarttrackerService, uiCalendarConfig, contentCacheService, langService, Upload, ngAudio) {
    $scope.selectedLanguage = {code: smarttrackerService.language()};
    themeService.loadWebTheme(themeService.chosenTheme());
    $scope.popupCal = {
        startDate: new Date($rootScope.flEvent.start),
        endDate: new Date($rootScope.flEvent.end),
        startDateOpen: false,
        endDateOpen: false
    };
    $scope.modalShown = false;
    $scope.toggleModal = function () {
        $scope.modalShown = !$scope.modalShown;
    };

    $scope.dateOptions = {
        formatYear: 'yyyy',
        startingDay: 1,
        language: 'en',
        initDate: new Date()
    };
    $scope.clear = function () {
        $scope.popupCal.startDate = null;
        $scope.popupCal.endDate = null;
    };
    var tomorrow = new Date();
    tomorrow.setDate(tomorrow.getDate() + 1);
    var afterTomorrow = new Date();
    afterTomorrow.setDate(tomorrow.getDate() + 2);
    $scope.events = [{
            date: tomorrow,
            status: 'full'
        }, {
            date: afterTomorrow,
            status: 'partially'
        }];
    $scope.getDayClass = function (date, mode) {
        if (mode === 'day') {
            var dayToCheck = new Date(date).setHours(0, 0, 0, 0);

            for (var i = 0; i < $scope.events.length; i++) {
                var currentDay = new Date($scope.events[i].date).setHours(0, 0, 0, 0);

                if (dayToCheck === currentDay) {
                    return $scope.events[i].status;
                }
            }
        }
        return '';
    };
    $scope.disabled = function (date, mode) {
        //        return (mode === 'day' && (date.getDay() === 0 || date.getDay() === 6));
        return false;
    };
    navigator.mediaDevices = navigator.mediaDevices || ((navigator.mozGetUserMedia || navigator.webkitGetUserMedia) ? {
        getUserMedia: function (c) {
            return new Promise(function (y, n) {
                (navigator.mozGetUserMedia || navigator.webkitGetUserMedia).call(navigator, c, y, n);
            });
        }
    } : null);
    $rootScope.alarm.units = [{
            trans: "HOURS-en",
            value: "HOURS"
        }, {
            trans: "DAYS-en",
            value: "DAYS"
        }, {
            trans: "MINUTES-en",
            value: "MINUTES"
        }];

    $scope.setUnitLang = function () {
        console.log("set unit language:", smarttrackerService.language());
        if (smarttrackerService.language() === "no") {

            angular.forEach($rootScope.alarm.units, function (unit) {
                if (unit.value === "HOURS") {
                    unit.trans = "timer";
                }
                if (unit.value === "DAYS") {
                    unit.trans = "dager";
                }
                if (unit.value === "MINUTES") {
                    unit.trans = "minutter";
                }
            }); 
            $scope.event_youtube_link = "Lim inn YouTube-link her";
        }
        if (smarttrackerService.language() === "en") {
            angular.forEach($rootScope.alarm.units, function (item) {
                if (item.value === "HOURS") {
                    item.trans = "hours";
                }
                if (item.value === "DAYS") {
                    item.trans = "days";
                }
                if (item.value === "MINUTES") {
                    item.trans = "minutes";
                }
            })
            $scope.event_youtube_link = "Paste YouTube link here.";
        }
        ;
        if (smarttrackerService.language() === "de") {
            $scope.event_youtube_link = "Hier YouTube Link einfügen";
            angular.forEach($rootScope.alarm.units, function (item) {
                if (item.value === "HOURS") {
                    item.trans = "stunden";
                }
                if (item.value === "DAYS") {
                    item.trans = "Tage";
                }
                if (item.value === "MINUTES") {
                    item.trans = "minuten";
                }
            });
        }

    };

    $scope.setLang = function () {
        if (smarttrackerService.language() === "en") {
            moment.lang('en');
            console.log(langService);
            angular.copy(langService.setLang('en'), $locale);
            moment().startOf('isoweek').isoWeekday(0);

        } else if (smarttrackerService.language() === "no") {
            moment.lang('nb');
            angular.copy(langService.setLang('no'), $locale);
            moment().startOf('isoweek').isoWeekday(0);


        } else if (smarttrackerService.language() === "de") {
            moment.lang('de');
            angular.copy(langService.setLang('de'), $locale);
            moment().startOf('isoweek').isoWeekday(0);


        }
    };
    $scope.setLang();
    $scope.fileDropped = function (files) {
        if (files === null || files === undefined || files.length < 1) {
            return;
        }
        console.log("fileDropped called", files);
        var type = "";

        if (ef.isImage(files)) {
            type = ef.getType().eventImage;

        }
        if (ef.isVideo(files)) {
            type = ef.getType().eventVideo;
        }
        console.log("upload type", type);
        if (files && files.length > 0) {
            $scope.uploadMediaFile(files, type);
        }
    };


    $scope.recording = false;
    $scope.videoRecording = false;
    var recorder = undefined;
    var videoRecorder = undefined;
    $scope.currentTime = new Date();

    $scope.startRecording = function () {

        //$window.recordRTC.startRecording();
        getRecorder().then(function (r) {
            console.log("get recorder and starting recording");
            $scope.recording = true;
            r.startRecording();
        });
    };
    $scope.Firefox = function () {
        return   navigator.userAgent.valueOf().indexOf("Firefox") > 0;
    };

    var getRecorder = function () {
        return new Promise(function (resolve, reject) {
            if (!recorder) {
                if ($scope.Firefox()) {
                    var mediaConstraints = {video: false, audio: true};
                    navigator.mediaDevices.getUserMedia(mediaConstraints).then(
                            function (stream) {
                                console.log("running under firefox");
                                var options = {
                                    mimeType: 'audio/ogg', // or video/mp4 or audio/ogg
                                    bitsPerSecond: 128000 // if this line is provided, skip above two
                                };
                                recordRTC = RecordRTC(stream, options);
                                resolve(recorder);
                            });
                } else {
                    navigator.mediaDevices.getUserMedia({
                        audio: true,
                        video: false
                    }
                    ).then(
                            function (stream) {
                                if ($scope.Firefox()) {
                                    console.log("running under firefox");
                                    recorder = RecordRTC(stream, {
                                        type: 'audio'
                                    });

                                    resolve(recorder);
                                } else {
                                    recorder = RecordRTC(stream, {
                                        type: 'audio',
                                        recorderType: StereoAudioRecorder
                                    });
                                    console.log("audio recorder", recorder);
                                    resolve(recorder);
                                }
                            });
                }
                ;
            } else
                resolve(recorder);
        });
    };

    $scope.stopRecording = function () {
        console.log("stop recording");
        $scope.recording = false;
        getRecorder().then(function (r) {

            r.stopRecording(function (audioVideoMURL) {
                console.log('stopped recording...');
                console.log('recordrtc stop sample rate: ' + r.sampleRate);

                $scope.uploadInProgress = true;
                var file = new FormData();
                var _rr = r.getBlob();
                _rr.name = "anyname.wav";
                _rr.lastModifiedDate = new Date();
                file.append("type", "audio");
                file.append("assetID", "85190");
                file.append("file", _rr);
                $http({
                    method: 'POST',
                    headers: {
                        "Content-Type": undefined,
                        "Access-Control-Allow-Origin": "*"},
                    url: "https://ri.smarttracker.no/files/resource.php",
                    transformRequest: new FormData(),
                    data: file
                }).then(function (res) {
                    console.log(res);
                    $scope.uploadInProgress = false;
                    $scope.uploadProgress = 0;
                    $scope.currentInstruction.audio = stwoGlobal.fileBaseUrl + stwoGlobal.fileUploadPostFix + "?resourceID=" + res.data.resourceID;
                });

            });

        });
    };
    $scope.instSounds = [];
    $scope.waitUntilLoaded = function (inst) {
        var deferred = $q.defer();

        $timeout(function () {
            //        var cu = ngAudio.load(inst.audio);
            var cu = ngAudio.load(inst.audio);
            console.log(cu);
            deferred.resolve(cu);
        }, 2000);


        return deferred.promise;
    };
    var currentSound;
    $scope.startPlayback = function (inst) {
        console.log(currentSound);
        if (currentSound)
            currentSound.stop();
        currentSound = ngAudio.load(inst.audio);
        console.log(inst.audio);
        currentSound.play();
    };

    // type1 : instructionVideo, instructionImage, eventImage, eventVideo four type of upload
    $scope.uploadMediaFile = function (files, type1) {
        // type1 check if the file is a image or a video
        if (files && files.length > 0) {
            $scope.uploadInProgress = true;
            for (var i = 0; i < files.length; i++) {
                var file = files[i];
                console.log("uploading",file);
                $scope.uploadInProgress = true;
                var fd = new FormData();
                fd.append("file", file);

                var type = "image";
                if (type1.indexOf("Image") > 0)
                    fd.append("type", "images");
                else if (type1.indexOf("Video") > 0) {
                    fd.append("type", "video");
                    type = "video";
                }
                return Upload.upload({
                    method: "POST",
                    headers: {"X-Auth-Token": smarttrackerService.getToken(),
                        "Content-Type": undefined,
                        "Access-Control-Allow-Origin": "*"},
                    url: stwoGlobal.fileBaseUrl + stwoGlobal.fileUploadPostFix,
                    data: {file: files[i], type: type}
                }).progress(function (evt) {
                    var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
                    $scope.uploadProgress = progressPercentage;
                    $scope.log = 'progress: ' + progressPercentage + '% \n' + $scope.log;
                }).success(function (data, status, headers, config) {
                    console.log("uploaded File success", data, type);
                    if (type1 === ef.getType().eventImage) {
                        $scope.imageURL = stwoGlobal.fileBaseUrl + stwoGlobal.fileUploadPostFix + "?resourceID=" + data.resourceID;
                        $scope.extendeDescription.eventImage = data.resourceID;
                        console.log("inserting event image", $scope.imageURL);
                        $rootScope.flEvent.eventImage = data.resourceID;

                    }
                    else if (type1 === ef.getType().eventVideo) {

                        //update the videolist on the server
                        ef.updateVideoList({"type": "fileServer", "resourceID": data.resourceID}, $stateParams.id);

                        $scope.eventVideoTypeYoutube = false;
                        document.getElementById('eventVideoThumbnail').innerHTML = "";
                        var width = window.mobilecheck() ? 300 : 600;
                        document.getElementById('eventVideoThumbnail').innerHTML = '<video id="video" width="' + width + '" controls>' +
                                '<source src="' + stwoGlobal.fileBaseUrl + stwoGlobal.fileUploadPostFix + "?resourceID=" + data.resourceID + '" type="video/mp4">' +
                                '</video>';

                        $scope.extendeDescription.eventVideo = data.resourceID;

                        $rootScope.flEvent.eventVideo = data.resourceID;
                    }
                    else if (type1 === ef.getType().instructionImage) {
                        $scope.currentInstruction.image = data.resourceID;
                        console.log("currentInstruction.image", $scope.currentInstruction.image);
                    }
                    else if (type1 === ef.getType().instructionVideo) {
                        ef.updateVideoList({"type": "fileServer", "resourceID": data.resourceID}, $stateParams.id);
                        $scope.currentInstruction.video = data.resourceID;
                        $scope.currentInstructionVideoTypeYoutube = false;
                        $scope.currentInstructionVideoURL = "";
                        $scope.currentInstructionVideoID = "";
                        document.getElementById('instructionVideoThumbnail').innerHTML = "";
                        var width = window.mobilecheck() ? 300 : 600;
                        document.getElementById('instructionVideoThumbnail').innerHTML = '<video id="video" width="' + width + '" controls>' +
                                '<source src="' + "https://ri.smarttracker.no/files/resource.php?resourceID=" + $scope.currentInstruction.video + '" type="video/mp4">' +
                                '</video>';
                        console.log("currentInstruction.video", $scope.currentInstruction.video);
                    }
                    $scope.log = 'file uploaded. Response: ' + JSON.stringify(data) + '\n' + $scope.log;

//                    if (data.indexOf("to big") > 0) {
//                        $scope.errorFeedback = "Upload failed. Check file size";
//                    } else 
                    $scope.errorFeedback = "";
                    $scope.uploadInProgress = false;
                    $scope.uploadProgress = 0;
                });
            }
        }
    };
    if ($rootScope.flEvent.eventVideo && $rootScope.flEvent.eventVideo !== "") {
        console.log("flEvent.eventVideo", $rootScope.flEvent.eventVideo);
        if ($rootScope.flEvent.eventVideo.indexOf("youtube") > 0) {
            $scope.eventVideoTypeYoutube = true;
            $scope.eventYoutubeURL = $rootScope.flEvent.eventVideo;

            $scope.eventYoutubeVideoID = youtubeEmbedUtils.getIdFromURL($rootScope.flEvent.eventVideo);
        } else {
            $timeout(function () {
                $scope.eventVideoTypeYoutube = false;

                if (document.getElementById("eventVideoPreview")) {
                    var width = window.mobilecheck() ? 300 : 600;
                    document.getElementById("eventVideoPreview").innerHTML = '<video id="video" width="' + width + '" controls>' +
                            '<source src="https://ri.smarttracker.no/files/resource.php?resourceID=' + $rootScope.flEvent.eventVideo + '" type="video/mp4">' +
                            '</video>';
                }
                if (document.getElementById("eventVideoThumbnail")) {
                    var width = window.mobilecheck() ? 300 : 600;
                    document.getElementById("eventVideoThumbnail").innerHTML = '<video id="video" width="' + width + '" controls>' +
                            '<source src="https://ri.smarttracker.no/files/resource.php?resourceID=' + $rootScope.flEvent.eventVideo + '" type="video/mp4">' +
                            '</video>';
                }
            }, 2000);
        }
    }

    $scope.addEventYoutubeVideo = function (link) {
        console.log("addEventYoutubeVideo", link, $scope.eventYoutubeURL);
        $scope.eventYoutubeURL = link;
        $scope.eventYoutubeVideoID = youtubeEmbedUtils.getIdFromURL(link);

        $scope.eventVideoTypeYoutube = true;
        $rootScope.flEvent.eventVideo = link;
        document.getElementById("eventVideoThumbnail").innerHTML = "";
        ef.updateVideoList({"type": "youtube", "url": link}, $stateParams.id);
    };
    $scope.addInstructionYoutubeVideo = function (link) {
        console.log("addInstructionYoutubeVidoe", $scope.currentInstructionVideoURL, link);
        $scope.currentInstruction.video = link;
        $scope.currentInstructionVideoURL = link;
        $scope.currentInstructionVideoID = youtubeEmbedUtils.getIdFromURL(link);
        $scope.currentInstructionVideoTypeYoutube = true;
        document.getElementById("instructionVideoThumbnail").innerHTML = "";
        ef.updateVideoList({"type": "youtube", "url": link}, $stateParams.id);
    };
    $scope.$watch("currentInstruction.video", function () {

        if ($scope.currentInstruction.video && $scope.currentInstruction.video !== "") {

            if ($scope.currentInstruction.video.indexOf("youtube") >= 0) {
                $scope.instructionYoutubeURL = $scope.currentInstruction.video;
                currentInstructionVideoTypeYoutube = true;
                $scope.currentInstructionVideoURL = $scope.currentInstruction.video;
                $scope.currentInstructionVideoID = youtubeEmbedUtils.getIdFromURL($scope.currentInstruction.video);
                document.getElementById("instructionVideoThumbnail").innerHTML = "";
            } else {
                currentInstructionVideoTypeYoutube = false;
                var width = window.mobilecheck() ? 300 : 600;
                document.getElementById("instructionVideoThumbnail").innerHTML = '<video id="video" width="' + width + '" controls>' +
                        '<source src="https://ri.smarttracker.no/files/resource.php?resourceID=' + $scope.currentInstruction.video + '" type="video/mp4">' +
                        '</video>';
            }
        } else if ($scope.currentInstruction.video === "" || $scope.currentInstruction.video === null) {
            $scope.currentInstructionVideoURL = "";
            if(document.getElementById("instructionVideoThumbnail"))
            document.getElementById("instructionVideoThumbnail").innerHTML = '';
        }
    });

    $scope.currentInstruction = {
        image: '',
        title: '',
        audio: '',
        video: ''
    };
    $scope.instructions = [];


    if ($rootScope.flEvent.eventImage && $rootScope.flEvent.eventImage !== "") {

        $scope.imageURL = stwoGlobal.fileBaseUrl + stwoGlobal.fileUploadPostFix + "?resourceID=" + $rootScope.flEvent.eventImage;
        console.log("event image", $rootScope.flEvent.eventImage, "imageURL", $scope.imageURL);
    }
    else {
        $scope.imageURL = "";
    }

    String.prototype.endsWith = function (pattern) {
        var d = this.length - pattern.length;
        return d >= 0 && this.lastIndexOf(pattern) === d;
    };
    if ($scope.instructions.lengh > 0) {
        $scope.instructions.splice(0, $scope.instructions.length);
    }

    angular.forEach($rootScope.flEvent.instructions, function (ins) {
        $scope.instructions.push(ins);
    });
    $scope.addInstruction = function () {
        if ((!$scope.currentInstruction.image || $scope.currentInstruction.image === "") &&
                (!$scope.currentInstruction.video || $scope.currentInstruction.video === "") &&
                (!$scope.currentInstruction.audio || $scope.currentInstruction.audio === "") &&
                (!$scope.currentInstruction.title || $scope.currentInstruction.title === "")) {
            return;
        }
        console.log("add current instruction", $scope.currentInstruction);
        $scope.INSTRUCTINO_NOT_SAVED = false;
        if (!$scope.currentInstruction.title) {
            $scope.currentInstruction.title = "";
        }


        if ($scope.currentInstruction.index) {
            $scope.instructions.splice($scope.currentInstruction.index, 0, $scope.currentInstruction);
        } else {
            $scope.instructions.push($scope.currentInstruction);
        }

        $scope.currentInstruction = {
            'image': '',
            'title': '',
            'audio': '',
            'video': ''
        };


    };

    $scope.extendeDescription = {description: "", eventImage: "", eventVideo: "", instructions: []};
    $scope.instIconDropped = function (file) {
        if (file === null || file === undefined || file.length < 1) {
            return;
        }
        var type1 = "instruction";

        if (ef.isImage(file[0].name)) {
            type1 = ef.getType().instructionImage;
        }
        if (ef.isVideo(file[0].name)) {
            type1 = ef.getType().instructionVideo;

        }
        if (file && file.length > 0) {

            $scope.uploadMediaFile(file, type1);
        }
    }

    $scope.$watch("alarm.on", function () {
        if ($rootScope.alarm.on && $rootScope.alarm.items.length === 0) {
            $rootScope.alarm.items.push({
                value: 30,
                unit: $rootScope.alarm.MINUTES
            });
        }
    });
    $scope._incremental = 30;
    $scope.addAlarm = function () {
        $scope._incremental = $scope._incremental + 10;
        $rootScope.alarm.items.push({
            value: $scope._incremental,
            unit: "MINUTES"
        });
    }
    $scope.removeIndstruction = function (instruction) {
        $scope.instructions.splice($scope.instructions.indexOf(instruction), 1);
//        $rootScope.undervisninger.splice($rootScope.undervisninger.indeOf(instruction),1);

    }
    $scope.removeAlarm = function (alarmItem) {
        $rootScope.alarm.items.splice($rootScope.alarm.items.indexOf(alarmItem), 1);
        if ($rootScope.alarm.items.length === 0) {
            $rootScope.alarm.on = false;
        }
    };
    $scope.sortableOptions = {
        handle: '> .dragHandle',
    };

    $scope.editInstruction = function (instruction) {


        var index = $scope.instructions.indexOf(instruction);

        $scope.currentInstruction = $scope.instructions[index];
        $scope.currentInstruction.index = index;
        $scope.currentInstruction.video = $scope.instructions[index].video;
        $scope.currentInstruction.title = $scope.instructions[index].title;
        $scope.currentInstruction.image = $scope.instructions[index].image;
        $scope.currentInstruction.audio = $scope.instructions[index].audio;
        if ($scope.currentInstruction.video && $scope.currentInstruction.video !== "") {
            if ($scope.currentInstruction.video.indexOf("youtube") >= 0) {
                $scope.currentInstructionVideoTypeYoutube = true;
                $scope.currentInstructionVideoURL = $scope.currentInstruction.video;
                $scope.currentInstructionVideoID = youtubeEmbedUtils.getIdFromURL($scope.currentInstruction.video);
            } else {
                $scope.currentInstructionVideoTypeYoutube = false;
                var width = window.mobilecheck() ? 300 : 600;
                document.getElementById("instructionVideoThumbnail").innerHTML = '<video id="video" width' + width + '" controls>' +
                        '<source src="https://ri.smarttracker.no/files/resource.php?resourceID=' + $scope.currentInstruction.video + '" type="video/mp4">' +
                        '</video>';
            }
        }


        $scope.instructions.splice(index, 1);
        $rootScope.flEvent.instructions.splice(index, 1);
        if ($scope.currentInstruction.title !== "" || $scope.currentInstruction.audio !== "" || $scope.currentInstruction.image !== ""
                || $scope.currentInstruction.video !== "") {
            $scope.INSTRUCTINO_NOT_SAVED = true;
        } else {
            $scope.INSTRUCTINO_NOT_SAVED = false;
        }

    }

    $scope.beforeRender = function ($date) {
        console.log("beforeRander", $date);
    };
    $scope.workday = false;


    $rootScope.typeOf = function (value) {
        return typeof value;
    };
    $scope.delete = function () {
        // delete event

        ef.get("calendar", "view");

        gapi.client.load('calendar', 'v3', function () {

            var request = gapi.client.calendar.events.delete({
                'calendarId': 'primary',
                'eventId': $rootScope.flEvent.id
            });
            request.execute(function (resp) {
                if (resp.status === undefined || resp.status === null) {
                    console.log(resp);
                    ef.deleteEvent($rootScope.flEvent.id);
                    ef.deleteEventFromGoogleEventCache($rootScope.flEvent.id);
                }

            });

        });
        $rootScope.modalInstance.dismiss('cancel');
        ef.put("calendar", "view.currentDate", $rootScope.flEvent.start);
        $rootScope.modal_instance_return = true;
    };
    $rootScope.modalInstance.result.then(function (item) {
        console.log("modal instance result returned", item);

    });
    $scope.mobileCheck = function () {

        return window.mobilecheck();
    }
    $scope.edit = function () {
        for (var i = 0; i < $rootScope.root.routes.length; i++) {
            if ($rootScope.flEvent.location === $rootScope.root.routes[i]) {
                $rootScope.root.route = $rootScope.root.routes[i];
            }
        }
        //render editing event
        $rootScope.timezone = ef.getTimeZone();
        $scope.instructions = new Array();
        angular.forEach($rootScope.flEvent.instructions, function (inst) {
            $scope.instructions.push(inst);
        });
        if ($rootScope.flEvent.eventVideo && $rootScope.flEvent.eventVideo.indexOf("youtube")>0) {
            $scope.eventVideoTypeYoutube = true;
            $scope.eventYoutubeURL = $rootScope.flEvent.eventVideo;
        } else if ($rootScope.flEvent.eventVideo && $rootScope.flEvent.eventVideo !== "") {
            $scope.eventVideoTypeYoutube = false;
            // show video handled later
        }
        if ($rootScope.flEvent.eventImage && $rootScope.flEvent.eventImage !== "") {
            $scope.imageURL = $rootScope.flEvent.eventImage;
        }
        console.log("edit", $rootScope.eventsExtra);
        if ($rootScope.eventsExtra[$rootScope.flEvent.id]) {
            $rootScope.flEvent.eventImage = $rootScope.eventsExtra[$rootScope.flEvent.id].eventImage;
            $scope.imageURL = $rootScope.flEvent.eventImage;
        }



        $rootScope.modalInstance.dismiss('edit');
        $rootScope.modalInstance = $modal.open({
            templateUrl: 'modules/calendar/calendar_popup.html',
            controller: "eventEditingController",
            size: "lg"
        });

    };
    $scope.$watch("weekdays", function () {

        if ($rootScope.weekdays.MO) {
            $scope.monS = 'day-selected';
        } else
            $scope.monS = '';
    });

    $scope.$watch("weekdays.TU", function () {

        if ($rootScope.weekdays.TU) {
            $scope.tueS = 'day-selected';
        } else
            $scope.tueS = '';
    });

    $scope.$watch("weekdays.WE", function () {
        if ($rootScope.weekdays.WE) {
            $scope.wedS = 'day-selected';
        } else
            $scope.wedS = '';
    });

    $scope.$watch("weekdays.TH", function () {
        if ($rootScope.weekdays.TH) {
            $scope.thuS = 'day-selected';
        } else
            $scope.thuS = '';
    });

    $scope.$watch("weekdays.FR", function () {
        if ($rootScope.weekdays.FR) {
            $scope.friS = 'day-selected';
        } else
            $scope.friS = '';
    });

    $scope.$watch("weekdays.SA", function () {
        if ($rootScope.weekdays.SA) {
            $scope.satS = 'day-selected';
        } else
            $scope.satS = '';
    });

    $scope.$watch("weekdays.SU", function () {
        if ($rootScope.weekdays.SU) {
            $scope.sunS = 'day-selected';
        } else
            $scope.sunS = '';
    });

    $scope.formatWeekDayRules = function () {
        var days = [];
        angular.forEach($rootScope.weekdays, function (value, key) {
            if (value) {
                days.push(key);
            }
        });
        var re = "";
        for (var i = 0; i < days.length; i++) {
            if (i !== days.length - 1)
                re = re + days[i] + ",";
            else
                re = re + days[i];
        }
        console.log(re);
        return re;
    };
    $scope.formatRules = function () {
        //RRULE:FREQ=WEEKLY;COUNT=3;BYDAY=MO  EXAMPLE
        //RRULE:FREQ=DAILY;COUNT=2 EXAMPLE
        //RRULE:FREQ=WEEKLY;COUNT=2;BYDAY=SU,TU,TH,SA EXAMPLE
        var rule = "RRULE:";
        if ($rootScope.repeated.FREQ === "day") {
            rule = rule + "FREQ=DAILY;";
            if ($rootScope.repeated.INTERVAL) {
                rule = rule + "INTERVAL=" + $rootScope.repeated.INTERVAL + ";";
            }
            rule = rule + "COUNT=" + $rootScope.repeated.COUNT;

        } else if ($rootScope.repeated.FREQ === "week") {
            rule = rule + "FREQ=WEEKLY;";
            rule = rule + "COUNT=" + $rootScope.repeated.COUNT + ";";
        } else if ($rootScope.repeated.FREQ === "month") {
            rule = rule + "FREQ=MONTHLY;";
            if ($rootScope.repeated.INTERVAL) {
                rule = rule + "INTERVAL=" + $rootScope.repeated.INTERVAL + ";";
            }
            rule = rule + "COUNT=" + $rootScope.repeated.COUNT + ";";
        }

        if ($rootScope.repeated.FREQ === "week") {
            rule = rule + "BYDAY=" + $scope.formatWeekDayRules();

        }
//        console.log("rule",rule);
        if (rule.charAt(rule.length - 1) === ';') {
            rule = rule.substring(0, rule.length - 1);
//        console.log("rule",rule); 
        }
//        console.log("formating repeat rules", rule);
        return rule;
    };
    $scope.$watch(function (scope) {
        return scope.alarm;
    }, function () {
        console.log($rootScope.alarm);
    });
    $scope.cancel = function () {
        
        
        console.log("close");
        $rootScope.modalInstance.close("cancel");
    };

    var format = function (date) {
        //zero-pad a single zero if needed
        var zp = function (val) {
            return (val <= 9 ? '0' + val : '' + val);
        };
        //zero-pad up to two zeroes if needed
        var zp2 = function (val) {
            return val <= 99 ? (val <= 9 ? '00' + val : '0' + val) : ('' + val);
        };
        var d = date.getDate();
        var m = date.getMonth() + 1;
        var y = date.getFullYear();
        var h = date.getHours();
        var min = date.getMinutes();
        var s = date.getSeconds();
        return '' + y + '-' + zp(m) + '-' + zp(d) + 'T' + zp(h) + ':' + zp(min) + ':' + zp(s);
    };
    $scope.changed = function () {
//        console.log("instructionString", $rootScope.attendeesString);
        console.log("change route", $rootScope.root.route);
        $rootScope.alarm.on =true;
        if ($rootScope.alarm.on && $rootScope.alarm.items.length === 0) {
            $rootScope.alarm.items.push({
                value: 30,
                unit: $rootScope.alarm.MINUTES
            });
        }        
//        console.log("change routes", $rootScope.root.routes);
    };

    $scope.$watch('popupCal.startDate', function () {
        if (!($rootScope.flEvent.start instanceof Date)) {
            $rootScope.flEvent.start = new Date($rootScope.flEvent.start);
            $rootScope.flEvent.end = new Date($rootScope.flEvent.end);
        }
        $scope.popupCal.endDate = $scope.popupCal.startDate;
        $rootScope.flEvent.start.setDate($scope.popupCal.startDate.getDate());
        $rootScope.flEvent.start.setMonth($scope.popupCal.startDate.getMonth());

        $rootScope.flEvent.start.setFullYear($scope.popupCal.startDate.getFullYear());

    });

    $scope.dateFormat = 'dd.MM.yyyy';
    $scope.$watch('popupCal.endDate', function () {

        if (!($rootScope.flEvent.end instanceof Date)) {
            $rootScope.flEvent.start = new Date($rootScope.flEvent.start);
            $rootScope.flEvent.end = new Date($rootScope.flEvent.end);
        }
        $scope.popupCal.startDate = $scope.popupCal.endDate;
        $rootScope.flEvent.end.setDate($scope.popupCal.endDate.getDate());
        $rootScope.flEvent.end.setMonth($scope.popupCal.endDate.getMonth());
        $rootScope.flEvent.end.setFullYear($scope.popupCal.endDate.getFullYear());
    });

    $scope.openStartDate = function ($event) {
        $event.preventDefault();
        $event.stopPropagation();
        $scope.popupCal.startDateOpen = true;
    };
    $scope.INSTRUCTINO_NOT_SAVED = false;
    $scope.compareDifference = false;
    $scope.compareTime = false;
    var compareTime1 = function () {
        if (!($rootScope.flEvent.end instanceof Date))
            $rootScope.flEvent.end = new Date($rootScope.flEvent.end);
        if (!($rootScope.flEvent.start instanceof Date))
            $rootScope.flEvent.start = new Date($rootScope.flEvent.start);
        var _r = Date.UTC($scope.popupCal.startDate.getFullYear(), $scope.popupCal.startDate.getMonth(), $scope.popupCal.startDate.getDate(), $rootScope.flEvent.start.getHours(), $rootScope.flEvent.start.getMinutes()) <
                Date.UTC($scope.currentTime.getFullYear(), $scope.currentTime.getMonth(), $scope.currentTime.getDate(), $scope.currentTime.getHours(), $scope.currentTime.getMinutes());

        return _r;
    };
    var compareDifference1 = function () {
        if (!($rootScope.flEvent.end instanceof Date))
            $rootScope.flEvent.end = new Date($rootScope.flEvent.end);
        if (!($rootScope.flEvent.start instanceof Date))
            $rootScope.flEvent.start = new Date($rootScope.flEvent.start);

        var _r = Date.UTC($scope.popupCal.startDate.getFullYear(), $scope.popupCal.startDate.getMonth(), $scope.popupCal.startDate.getDate(), $rootScope.flEvent.start.getHours(), $rootScope.flEvent.start.getMinutes()) <
                Date.UTC($scope.popupCal.endDate.getFullYear(), $scope.popupCal.endDate.getMonth(), $scope.popupCal.endDate.getDate(), $scope.flEvent.end.getHours(), $scope.flEvent.end.getMinutes());

        return _r;
    };
    $scope.$watch("popupCal.startDate", function () {

        $scope.compareTime = compareTime1();
        $scope.popupCal.endDate.setDate($scope.popupCal.startDate.getDate());

        $scope.compareDifference = !compareDifference1();

    });
    $scope.$watch("popupCal.endDate", function () {

        $scope.compareTime = compareTime1();
        $scope.popupCal.startDate.setDate($scope.popupCal.endDate.getDate());

        $scope.compareDifference = !compareDifference1();

    });



    $scope.$watch('flEvent.start', function () {
        $scope.compareTime = compareTime1();
        $scope.compareDifference = !compareDifference1();

    });
    $scope.$watch('flEvent.end', function () {
        $scope.compareTime = compareTime1();
        $scope.compareDifference = !compareDifference1();
    });
    $scope.openEndDate = function ($event) {

        $event.preventDefault();
        $event.stopPropagation();

        $scope.popupCal.endDateOpen = true;

    };
    $scope.$watch("eventYoutubeURL", function () {
        if ($scope.eventYoutubeURL !== "") {
            $scope.flEvent.eventVideo = $scope.eventYoutubeURL;
            $scope.eventVideoTypeYoutube = true;

        } else {
            $scope.eventVideoTypeYoutube = false;
        }
    });
    $scope.$watch("eventYoutubeURL", function () {
        if ($scope.eventYoutubeURL !== "") {
            $scope.flEvent.eventVideo = $scope.eventYoutubeURL;
            $scope.eventVideoTypeYoutube = true;

        } else {
            $scope.eventVideoTypeYoutube = false;
        }
    });

    $scope.submitNewEvent = function () {
        $rootScope.timezone = ef.getTimeZone();

        if (!($rootScope.flEvent.start instanceof Date)) {
            $rootScope.flEvent.start = (new Date($rootScope.flEvent.start));
        }
        var _d1 = new Date($scope.popupCal.startDate);
        $rootScope.flEvent.start = (new Date($rootScope.flEvent.start));
        $rootScope.flEvent.start.setFullYear(_d1.getFullYear());



        $rootScope.flEvent.start.setMonth($scope.popupCal.startDate.getMonth());
        $rootScope.flEvent.start.setDate($scope.popupCal.startDate.getDate());

        var _d2 = new Date($scope.popupCal.endDate);
        $rootScope.flEvent.end = new Date($rootScope.flEvent.end);
        $rootScope.flEvent.end.setFullYear(_d2.getFullYear());

        $rootScope.flEvent.end.setMonth($scope.popupCal.endDate.getMonth());
        $rootScope.flEvent.end.setDate($scope.popupCal.endDate.getDate());

        var _startTime = new Date($rootScope.flEvent.start);
        var _endTime = new Date($rootScope.flEvent.end);


        var startTime = (new Date(_startTime.getFullYear(), _startTime.getMonth(), _startTime.getDate(), _startTime.getHours(), _startTime.getMinutes(), _startTime.getSeconds()));
        var endTime = (new Date(_endTime.getFullYear(), _endTime.getMonth(), _endTime.getDate(), _endTime.getHours(), _endTime.getMinutes(), _endTime.getSeconds()));

        if ($rootScope.flEvent.allDay) {
            $rootScope.gEvent.start.date = format(startTime);
            $rootScope.gEvent.end.date = format(endTime);
        } else {
            $rootScope.gEvent.start.dateTime = ef.format(startTime) + ef.getTimeZone();
            $rootScope.gEvent.end.dateTime = ef.format(endTime) + ef.getTimeZone();
            $rootScope.flEvent.start = ef.format(startTime) + ef.getTimeZone();
            $rootScope.flEvent.end = ef.format(endTime) + ef.getTimeZone();
        }

        $rootScope.gEvent.summary = $rootScope.flEvent.title;

        if (!angular.isUndefined($rootScope.root.route) && $rootScope.root.route !== "") {
            $rootScope.flEvent.location = $rootScope.root.route;
            $rootScope.gEvent.location = $rootScope.root.route;
        }
        var reminders = {
            overrides: [],
            useDefault: false
        };

        if ($rootScope.alarm.on)
            angular.forEach($rootScope.alarm.items, function (item) {
                var _obj = {
                    method: "popup",
                    minutes: item.unit === "DAYS" ? item.value * 60 * 24 : (item.unit === "HOURS" ? item.value * 60 : item.value)
                };
                reminders.overrides.push(_obj);
            });

        $rootScope.gEvent.reminders = reminders;
        $rootScope.flEvent.reminders = reminders;
        //create instructions

        if ($rootScope.gEvent.attendees.length > 0) {
            $rootScope.gEvent.attendees.splice(0, $rootScope.gEvent.attendees.length);
        }
        if ($rootScope.flEvent.attendees.length > 0) {
            $rootScope.flEvent.attendees.splice(0, $rootScope.flEvent.attendees.length);
        }
        $rootScope.flEvent.instructions = new Array();



        console.log("all instructions", $scope.instructions);
        for (var i in $scope.instructions) {

            var inst = $scope.instructions[i];
            var instructionDetail = {title: "", image: "", video: "", audio: "", index: 1};
            instructionDetail.index = i + 1;
            instructionDetail.title = inst.title;
            console.log("inst.image", inst.image, "ef.parseIDfromURL(inst.image)", ef.parseIDfromURL(inst.image));
            instructionDetail.image = inst.image.indexOf("http") >= 0 ? ef.parseIDfromURL(inst.image) : inst.image;
            instructionDetail.audio = inst.audio;
            if (inst.video.indexOf("youtube") >= 0) {
                instructionDetail.video = inst.video;
            } else
                instructionDetail.video = inst.video.indexOf("http") >= 0 ? ef.parseIDfromURL(inst.video) : inst.video;

            $rootScope.flEvent.instructions.push(instructionDetail);
            $scope.extendeDescription.instructions.push(instructionDetail);

        }
        if ($scope.currentInstructionVideoTypeYoutube) {
            $scope.extendeDescription.eventVideo = $scope.eventYoutubeURL;
        } else {
            $scope.extendeDescription.eventVideo = $rootScope.flEvent.eventVideo;
        }
        $scope.extendeDescription.eventImage = $rootScope.flEvent.eventImage;
        $scope.extendeDescription.description = $rootScope.flEvent.description;
        $rootScope.gEvent.description = JSON.stringify($scope.extendeDescription);
        console.log("extendeDescription", $scope.extendeDescription);
        $rootScope.gEvent.id = $rootScope.flEvent.id ? $rootScope.flEvent.id : undefined;

        $rootScope.gEvent.start.timeZone = angularMomentConfig.timezone;
        $rootScope.gEvent.end.timeZone = angularMomentConfig.timezone;


        if ($rootScope.flEvent.repeated) {
            if ($rootScope.gEvent.recurrence)
                $rootScope.gEvent.recurrence.splice(0, $rootScope.gEvent.recurrence.length);
            $rootScope.gEvent.recurrence = [];
            $rootScope.gEvent.recurrence.push($scope.formatRules());

            if ($rootScope.flEvent.recurrence)
                $rootScope.flEvent.recurrence.splice(0, $rootScope.flEvent.recurrence.length);
            else {
                $rootScope.flEvent.recurrence = [];
                $rootScope.flEvent.recurrence.push($scope.formatRules());
            }
        } else {
            $rootScope.gEvent.recurrence = undefined;
            if ($rootScope.flEvent.recurrence)
                $rootScope.flEvent.recurrence.splice(0, $rootScope.flEvent.recurrence.length);
            $rootScope.flEvent.recurrence = undefined;
        }


        if ($rootScope.gEvent.id !== "" && $rootScope.gEvent.id !== undefined) {
            // update event
            gapi.client.load('calendar', 'v3', function () {
                var _gEvent = ef.wrapGEvent($rootScope.gEvent);
                var request = gapi.client.calendar.events.update({
                    'calendarId': 'primary',
                    'resource': _gEvent,
                    'eventId': $rootScope.flEvent.id
                });

                request.execute(function (resp) {
                    if (resp.status == "confirmed") {
                        ef.deleteEvent($rootScope.flEvent.id);
                        if ($rootScope.flEvent.repeated) {
                            ef.createRepeatedEvent(ef.createEventFromGoogleEvents(_gEvent));
                        } else
                            ef.append($rootScope.flEvent);
                        console.log("updating event with id", $rootScope.flEvent.id, "changed event", $rootScope.flEvent);
//                        ef.updateGoogleEventtoCache(_gEvent, $rootScope.flEvent.id);
                    } else {

                    }
                    ;
                });

            });
        } else {
            // create new event
            gapi.client.load('calendar', 'v3', function () {
                $rootScope.gEvent.id = ef.makeId();
                var _gEvent = ef.wrapGEvent($rootScope.gEvent);
                var request = gapi.client.calendar.events.insert({
                    'calendarId': 'primary',
                    'resource': _gEvent
                });
                request.execute(function (resp) {
                    if (resp.status == "confirmed") {
                        $rootScope.flEvent.id = $rootScope.gEvent.id;
                        console.log("creating new event", $rootScope.gEvent, _gEvent);
                        var _tmp = ef.copy($rootScope.flEvent);
                        if ($rootScope.flEvent.repeated) {
                            ef.createRepeatedEvent(ef.createEventFromGoogleEvents(_gEvent));
                        } else {
                            ef.append(_tmp);
                            delete _tmp;
                        }
                        ;
                        ef.put("calendar", "primary", $rootScope.eventSources);
//                        ef.appendGoogleEventtoCache(_gEvent);
                        delete _gEvent;
                    }
                }, function (resp) {
                    console.log(resp);
                });

            });
        }
        ;
        $rootScope.modalInstance.close("submit");
        ef.put("calendar", "view.currentDate", $rootScope.flEvent.start);
        $rootScope.modal_instance_return = true;
    };
    smarttrackerService.isLoggedInDelayed().then(function () {
        smarttrackerService.authGet(smarttrackerService.getCustomerId() + '/asset/' + $stateParams.id + '?select=*').then(function (response) {
            $scope.asset = response.data.result[0];
            for (var i = 0; i < $scope.asset.properties.length; i++) {
                if ($scope.asset.properties[i].name === "language") {
                    smarttrackerService.language($scope.asset.properties[i].value);
                    $scope.selectedLanguage.code = smarttrackerService.language();
                }
            };
            $scope.setUnitLang();
            $scope.setLang();
            console.log("place holder",$scope.event_youtube_link);
        });
    });
})
