angular.module('stwo.poseidonCalendar', ['ngFileUpload', 'ui.sortable', 'angularLoad', 'ngTagsInput', 'stwo.core', 'stwo.glue', 'angularMoment', 'ui.calendar', 'ui.bootstrap', 'ui.bootstrap.datepicker', 'ui.bootstrap.timepicker', 'angular-google-gapi', 'ngAudio', 'ngVideo'])
.config(function ($provide, $stateProvider, $urlRouterProvider, moduleStoreProvider, $translateProvider) {
    moduleStoreProvider.registerModule({
        name: "calendar",
        links: [{
                name: "CALENDAR_TITLE",
                category: "navigation",
                icon: "fa fa-calendar",
                sref: "secure.content.asset.calendar",
                sort: 5,
                color: "success"
            }]
    });
    $stateProvider.state("secure.content.calendar", {
        url: "/calendar:id/:money",
        templateUrl: "modules/calendar/calendar_ui.html",
        controller: "CalendarController"
    });

    $stateProvider.state("secure.content.asset.calendar", {
        url: "/asset-calendar:id",
        templateUrl: "aktive-spor/dashboard/dashboard.html",
        controller: "ListCalendarController"
    });
})
.factory("ef", ['$rootScope', 'smarttrackerService', 'GAuth', 'uiCalendarConfig', function ($rootScope, smarttrackerService, $scope, GAuth, uiCalendarConfig, amDateFormat, angularMomentConfig) {
                $rootScope.debug = true;
                $rootScope.events = [];
                $rootScope.alarm = {
                    MINUTES: "MINUTES",
                    HOURS: "HOURS",
                    DAYS: "DAYS",
                    on: false,
                    items: []
                };
                
                
                // fullcalendar is not robost in keep additional information like the event video, event image, event instructions, we have to keep additional infor elsewhere
                $rootScope.eventsExtra = {
                    // "id":{instructions:[],image:"",video:""}
                    //
                };
                $rootScope.alarm.items.push({
                    value: 30,
                    unit: $rootScope.alarm.MINUTES
                });

                $rootScope.root = {
                    routes: [],
                    route: ""
                };

                var uploadType = {eventVideo: "eventVideo", eventImage: "eventImage", instructionVideo: "instructionVideo", instructionImage: "instructionImage"};
                var offset = new Date().getTimezoneOffset();
                $rootScope.gEvent = {
                    attendees: [],
                    reminders: {
                        useDefault: false,
                        overrides: [{
                                method: "",
                                minutes: ""
                            }]

                    },
                    repeated: false,
                    recurrence: [],
                    start: {
                        dateTime: (new Date()).toISOString(),
                        timeZone: (new Date()).toTimeString()
                    },
                    end: {
                        dateTime: (new Date()).toISOString(),
                        timeZone: (new Date()).toTimeString()
                    },
                    description: "default description",
                    summary: "default",
                    location: "",
                    class: "",
                    id: ""
                };
                $rootScope.repeated = {
                    INTERVAL: 1,
                    FREQ: "day",
                    COUNT: 1
                };
                $rootScope.weekdays = {
                    SU: false,
                    MO: false,
                    TU: false,
                    WE: false,
                    TH: false,
                    FR: false,
                    SA: false
                };
                $rootScope.flEvent = {
                    color: "#B5932C",
                    allDay: false,
                    repeated: false,
                    recurrence: [],
                    start: (new Date()).toISOString(),
                    end: (new Date()).toISOString(),
                    description: "default description",
                    title: "default",
                    location: "home",
                    attendees: [],
                    instructions: [],
                    reminders: {
                        useDefault: false,
                        overrides: [{
                                method: "",
                                minutes: ""
                            }]
                    },
                    class: "",
                    id: ""
                };

                var cache = {};
                var factory = {};
                factory.getType = function () {
                    return uploadType;
                },
                        factory.isVideoYoutube = function (link) {
                            if (link.indexOf("http")) {
                                return false;
                            } else if (link.indexOf("youtube")) {
                                return true;
                            }
                            return false;
                        }
                // debug method
                factory.deleteEventFromGoogleEventCache = function (id) {
                    var _array = this.get("calendar", "google");
                    for (var i = 0; i < _array.length; i++) {
                        if (_array[i].id === id) {
                            _array.splice(i, 1);
                        }
                    }
                },
                        factory.parseIDfromURL = function (urlStr) {
                            var endIndex = 0;
                            if (urlStr !== "")
                                endIndex = urlStr.indexOf("&");
                            else
                                return "";
                            if (endIndex < 0) {
                                var resourceID = urlStr.slice(urlStr.indexOf("=") + 1, urlStr.length);

                                return resourceID;
                            } else {
                                var parameters = urlStr.slice(urlStr.indexOf("?") + 1, urlStr.length);
                                var _pArray = parameters.split("&");
                                angular.forEach(_pArray, function (value) {
                                    if (value.indexOf("resourceID=") >= 0) {

                                        return value.split("=")[1];
                                    }
                                })
                            }
                            return "";
                        },
                        factory.updateGoogleEventtoCache = function (obj, id) {
                            var _array = cache["calendar"]["google"];


                            for (var i = 0; i < _array.length; i++) {
                                if (_array[i].id === id) {
                                    console.log("updateGoogleEventtoCache", _array[i]);
                                    //                _array.splice(i,1);
                                    if (obj.summary) {
                                        _array[i].summary = obj.summary;
                                    }
                                    if (obj.attendees) {
                                        var _attendees = angular.copy(_attendees, obj.attendees);
                                        _array[i].attendees = _attendees;
                                    }

                                    if (obj.reminders) {
                                        var _remainders = angular.copy(_remainders, obj.reminders);
                                        _array[i].reminders = _remainders;
                                    }
                                    if (obj.end) {
                                        var _end = angular.copy(_end, obj.end);
                                        _array[i].end = _end;
                                    }
                                    if (obj.start) {
                                        var _start = angular.copy(_start, obj.start);
                                        _array[i].start = _start;
                                    }

                                    if (obj.location) {
                                        var _location = angular.copy(_location, obj.location);
                                        _array[i].location = _location;
                                    }
                                    if (obj.description) {
                                        var _description = angular.copy(_description, obj.description);
                                        _array[i].description = _description;
                                    }
                                    console.log("updated cached google event", _array[i]);
                                    //                cache["calendar"]["google"].push(destination);
                                }
                            }
                        },
                        factory.appendGoogleEventtoCache = function (obj) {
                            cache["calendar"]["google"].push(obj);
                        }, 
                        factory.getEventByIDfromCache = function (id) {
                    var _array = [];
                    var _ob = {};
                    if (angular.isArray(this.get("calendar", "primary"))) {
                        _array = this.get("calendar", "primary");
                        for (var i = 0; i < _array.length; i++) {
                            if (_array[i].id === id) {
                                _ob = _array[i];
                                return _ob;
                            }
                        }
                    } else
                        return null;
                };
                factory.getTimeZone = function () {
                    return new Date().toString().match(/([-\+][0-9]+)\s/)[1];
                }
                factory.getExtension = function (name) {
                    var parts = name.split('.');
                    return parts[parts.length - 1];
                }
                factory.isImage = function (fileName) {
                    var ext = "";
                    console.log((typeof fileName));
                    if ((typeof fileName) === "file") {
                        ext = fileName.name;
                    } else if ((typeof fileName) === "string") {
                        ext = this.getExtension(fileName);
                    } else {
                        ext = this.getExtension(fileName[0].name);
                    }

                    switch (ext.toLowerCase()) {
                        case 'jpg':
                        case 'gif':
                        case 'bmp':
                        case 'png':
                            //etc
                            console.log("is image");
                            return true;
                    }
                    return false;
                };
                factory.isVideo = function (fileName) {
                    var ext = "";
                    if ((typeof fileName) === "file") {
                        ext = fileName.name;
                    } else if ((typeof fileName) === "string") {
                        ext = this.getExtension(fileName);
                    } else {
                        ext = this.getExtension(fileName[0].name);
                    }

                    switch (ext.toLowerCase()) {
                        case 'm4v':
                        case 'avi':
                        case 'mpg':
                        case 'mp4':
                        case 'ogg':
                            // etc
                            console.log("is video");
                            return true;
                    }
                    return false;
                }

                factory.format = function (date) {
                    //zero-pad a single zero if needed
                    var zp = function (val) {
                        return (val <= 9 ? '0' + val : '' + val);
                    };
                    //zero-pad up to two zeroes if needed
                    var zp2 = function (val) {
                        return val <= 99 ? (val <= 9 ? '00' + val : '0' + val) : ('' + val);
                    };
                    var d = date.getDate();
                    var m = date.getMonth() + 1;
                    var y = date.getFullYear();
                    var h = date.getHours();
                    var min = date.getMinutes();
                    var s = date.getSeconds();
                    return '' + y + '-' + zp(m) + '-' + zp(d) + 'T' + zp(h) + ':' + zp(min) + ':' + zp(s);
                };

                factory.find = function (regexp, str) {
                    if (str.match(regexp) !== null && str.match(regexp) !== "") {
                        return true;
                    }
                    return false;
                };

                // duplicate a repeated event on different days in a month view on the calendar. 
                factory.duplicateEvent = function (event, id, startDate, endDate, arrays) {
                    var _event = {};
                    angular.copy(event, _event);
                    _event.id = id;
                    _event._start = startDate;

                    _event.start = new Date(event.start.setDate(endDate.getDate()));


                    _event.end = new Date(event.end.setDate(endDate.getDate()));

                    array.push(_event);
                };
                factory.createRepeatedEvent = function (event, array) {
                    console.log("first event of repeated event:", event.recurrence[0]);
                    if (angular.isDefined(event.recurrence) && event.recurrence.length > 0 && event.recurrence[0] !== "") {
                        // parse repeation rule
                        //RRULE:FREQ=WEEKLY;COUNT=3;BYDAY=MO  EXAMPLE
                        //RRULE:FREQ=DAILY;COUNT=2 EXAMPLE
                        //RRULE:FREQ=DAILY;COUNT=5;INTERVAL=2 EXAMPLE
                        //RRULE:FREQ=WEEKLY;COUNT=2;BYDAY=SU,TU,TH,SA EXAMPLE
                        //RRULE:FREQ=MONTHLYY;COUNT=3;
                        //RRULE:FREQ=MONTHLY;COUNT=2
                        var rule = event.recurrence[0].substring(event.recurrence[0].indexOf(":") + 1, event.recurrence[0].length);
                        var rules = rule.split(";");
                        var interval = 1;
                        var freq = "";
                        var count = 1;
                        var byday = "";


                        console.log("rule length", rules.length);
                        for (var i = 0; i < rules.length; i++) {
                            console.log("rule", rules[i]);
                            if (this.find(/FREQ=WEEKLY/, rules[i])) {
                                freq = "WEEKLY";
                            }
                            if (this.find(/FREQ=DAILY/, rules[i])) {
                                freq = "DAILY";
                            }
                            if (this.find(/FREQ=MONTHLY/, rules[i])) {
                                freq = "MONTHLY";
                            }
                            if (this.find(/INTERVAL=[1-9]*/, rules[i])) {
                                var temp = rules[i].match(/INTERVAL=[1-9]*/)[0];

                                interval = Number(temp.substring(temp.indexOf("=") + 1, temp.length));
                                console.log(interval);
                            }
                            if (this.find(/COUNT=[0-9]*/, rules[i])) {
                                var temp = rules[i].match(/COUNT=[0-9]*/)[0];

                                count = Number(temp.substring(temp.indexOf("=") + 1, temp.length));
                            }
                            if (freq === "WEEKLY" && this.find(/BYDAY=/, rules[i])) {
                                byday = rules[i].substring(rules[i].indexOf("=") + 1, rules[i].length);
                            }

                        }
//            console.log("freq", freq);
//            console.log("count", count);
//            console.log("byday", byday);
//            console.log("interval", interval);
//            console.log("old event", event);
                        if (this.find(/DAILY/, freq)) {
                            for (var i = 0; i < count; i++) {
                                var _event = new Object();
                                _event = angular.copy(event, _event);
                                //create extra repeated event perday
                                var start = new Date(_event.start);
                                start.setDate(start.getDate() + i * interval);
                                var end = new Date(event.end);
                                end.setDate(end.getDate() + i * interval);
                                _event.end = end;
                                _event.start = start;
                                _event.className = "recurrence";
                                if (array)
                                    array.push(_event);
                                else
                                    $rootScope.eventSources.push(_event);
                            }
                        } else if (this.find(/WEEKLY/, freq)) {
                            var date_increament = 0;
                            for (var i = 0; i < count; i++) {
                                var _event = new Object();
                                _event = angular.copy(event, _event);
                                //create extra repeated event perday
                                var start = new Date(_event.start);
                                start.setDate(start.getDate() + date_increament);
                                var end = new Date(event.end);
                                end.setDate(end.getDate() + date_increament);
                                date_increament++;
                                _event.end = end;
                                _event.start = start;
                                _event.className = "recurrence";
                                if (this.matchDayOfWeek(byday, _event.start.getDay())) {
                                    if (array)
                                        array.push(_event);
                                    else
                                        $rootScope.eventSources.push(_event);
                                } else {
                                    i--;
                                }

                            }
                        } else if (this.find(/MONTHLY/, freq)) {
                            for (var i = 0; i < count; i++) {
                                var _event = new Object();
                                _event = angular.copy(event, _event);
                                //create extra repeated event perday
                                var start = new Date(_event.start);
                                start.setMonth(start.getMonth() + i * interval);
                                var end = new Date(event.end);
                                end.setMonth(end.getMonth() + i * interval);
                                _event.end = end;
                                _event.start = start;
                                _event.className = "recurrence";
                                if (array)
                                    array.push(_event);
                                else
                                    $rootScope.eventSources.push(_event);
                            }
                        }
                    }
                };
                factory.matchDayOfWeek = function (weekdays, dayNumber) {
                    switch (dayNumber) {
                        case 0:
                            return weekdays.indexOf("SU") > -1;
                        case 1:
                            return weekdays.indexOf("MO") > -1;
                        case 2:
                            return weekdays.indexOf("TU") > -1;
                        case 3:
                            return weekdays.indexOf("WE") > -1;
                        case 4:
                            return weekdays.indexOf("TH") > -1;
                        case 5:
                            return weekdays.indexOf("FR") > -1;
                        case 6:
                            return weekdays.indexOf("SA") > -1;
                        default:
                            return false;
                    }
                };

                // put calendar events to cache
                factory.getGoogleEventFromCache = function (id) {

                    var _array = [];
                    var _ob = {};
                    if (angular.isArray(this.get("calendar", "google"))) {
                        _array = this.get("calendar", "google");
                        for (var i = 0; i < _array.length; i++) {
                            console.log("get google event from cache", i, _array[i].id, "title", _array[i].summary, id, _array[i].id === id);
                            if (_array[i].id === id) {
                                _ob = _array[i];
                                return _ob;
                            }
                        }
                    } else
                        return null;

                };
                factory.put = function (clazz, id, obj) {
                    console.log("put ", clazz, id, " to the cache", obj);
                    if (!cache[clazz]) {
                        cache[clazz] = {};
                    }
                    if (cache[clazz][id]) {
                        delete cache[clazz][id];
                    }
                    cache[clazz][id] = angular.fromJson(angular.toJson(obj));

                },
                        factory.delete = function (clazz, id) {
                            if (cache[clazz][id]) {
                                delete cache[clazz][id];
                            }
                        };
                factory.get = function (clazz, id) {
                    if (cache[clazz] && cache[clazz][id]) {

                        return cache[clazz][id];
                    }
                    return null;
                },
                        // params format {resourceID:"id",type:"fileServer"} if the video file is uploaded to the server
                        // or {url:"url",type:"youtube"}     
                        //id assetID
                        factory.updateVideoList = function (params, assetID) {
                            // maintain a video list such that the videos can be pre downloaded by the andorid app
                            if (factory.get("calendar", "calendarvideolist") && factory.get("calendar", "calendarvideolist").resourceID !== "") {
                                smarttrackerService.authGetFile({resourceID: factory.get("calendar", "calendarvideolist").resourceID}).then(function (success) {
                                    console.log(" get the calendarvideolist by cached video list id", factory.get("calendar", "calendarvideolist"), success);
                                    var list = success.data;

                                    list.videos.push(params);
                                    var fd = new FormData();
                                    fd.append("type", "calendarvideolist");
                                    fd.append("resourceID", factory.get("calendar", "calendarvideolist").resourceID);
                                    var blob = new Blob([JSON.stringify(list, null, 2)], {type: 'application/json'});
                                    fd.append("file", blob);
                                    smarttrackerService.authPostFile(fd, true).then(function (res) {
                                        console.log(res);

                                    });
                                });
                            } else {
                                smarttrackerService.authGetFile({type: "calendarvideolist"}).then(function (success) {
                                    console.log("get video list by type", success);
                                    if (success.data.length > 0) {
                                        console.log("find video list, use the first one", success);
                                        var videoListID = success.data[0].resourceID;

                                        factory.put("calendar", "calendarvideolist", {"resourceID": videoListID});
                                        smarttrackerService.authGetFile({resourceID: factory.get("calendar", "calendarvideolist").resourceID}).then(function (resonse) {
                                            console.log("get the calendarvideolist", resonse);
                                            var list = resonse.data;
                                            // params format {resourceID:"id",type:"fileServer"} if the video file is uploaded to the server
                                            // or {url:"url",type:"youtube"} 
                                            list.videos.push(params);
                                            var fd = new FormData();
                                            fd.append("type", "calendarvideolist");
                                            fd.append("resourceID", factory.get("calendar", "calendarvideolist").resourceID);
                                            var blob = new Blob([JSON.stringify(list, null, 2)], {type: 'application/json'});
                                            fd.append("file", blob);
                                            smarttrackerService.authPostFile(fd, true).then(function (res) {
                                                console.log(res);

                                            });
                                        });
                                    } else {
                                        console.log("no video list create new one");
                                        var list = {assetID: assetID, videos: []};
                                        console.log("params", params);
                                        list.videos.push(params);
                                        var fd = new FormData();
                                        fd.append("type", "calendarvideolist");
                                        var blob = new Blob([JSON.stringify(list, null, 2)], {type: 'application/json'});
                                        fd.append("file", blob);
                                        smarttrackerService.authPostFile(fd, true).then(function (res) {
                                            console.log(res);

                                        });

                                    }
                                });

                            }
                        },
                        factory.clear = function (array) {
                            if (array.length > 0) {
                                array.splice(0, array.length);
                            }
                        },
                        factory.cleanEventStack = function () {
                            for (var i = 0; i < $rootScope.eventSources.length; i++) {
                                $rootScope.eventSources.splice(i, 1);
                            }
                        },
                        // cleaning and rewrapping the google event just before it is published.
                        factory.renderCalender = function (calendar) {
                            if (uiCalendarConfig.calendars[calendar]) {
                                uiCalendarConfig.calendars[calendar].fullCalendar('render');
                            }
                        }, factory.wrapGEvent = function (gEvent) {
                    var _gEvent = {};
                    console.log("unwrapped google event", gEvent);
                    if (!angular.isUndefined(gEvent.location)) {
                        _gEvent.location = gEvent.location;
                    }
                    if (!angular.isUndefined(gEvent.reminders)) {
                        _gEvent.reminders = gEvent.reminders;
                        console.log("before rewraping g event:", gEvent, true);
                        console.log("rewrapped _g event:", _gEvent, true);
                    }

                    if (gEvent.start.dateTime && gEvent.start.dateTime !== "") {
                        _gEvent.start = {
                            dateTime: gEvent.start.dateTime
                        };
                    }
                    if (gEvent.start.timeZone !== undefined && gEvent.start.timeZone !== "") {
                        _gEvent.start.timeZone = gEvent.start.timeZone;
                    }

                    if (gEvent.end.dateTime && gEvent.end.dateTime !== "") {
                        _gEvent.end = {
                            dateTime: gEvent.end.dateTime
                        };
                    }
                    if (gEvent.end.timeZone !== undefined && gEvent.end.timeZone !== "") {
                        _gEvent.end.timeZone = gEvent.end.timeZone;
                    }
                    if (!angular.isUndefined(gEvent.attendees)) {
                        _gEvent.attendees = gEvent.attendees;
                    }
                    if (gEvent.summary && gEvent.summary !== "") {
                        _gEvent.summary = gEvent.summary;
                    }
                    if (gEvent.description && gEvent.description !== "") {
                        _gEvent.description = gEvent.description;
                    }
                    if (gEvent.id && gEvent.id !== "") {
                        _gEvent.id = gEvent.id;
                        _gEvent._id = gEvent.id;
                    }
                    console.log("newly wrapped google event", _gEvent);
                    if (typeof gEvent.recurrence !== "undefined") {
                        _gEvent.recurrence = gEvent.recurrence;
                    }

                    return _gEvent;
                }, factory.copy = function (obj) {
                    var copy = new Object(null);
                    angular.copy(obj, copy);
                    return copy;
                }, factory.createEventFromGoogleEvents = function (googleEvent) {
                    console.log("events downloaded from google", googleEvent);
                    var _flEvent = {
                        allDay: false,
                        repeated: false,
                        color: '#257e4a',
                        start: new Date(),
                        end: new Date(),
                        description: "default description",
                        title: "default",
                        location: "",
                        reminders: {
                            useDefault: false,
                            overrides: [{
                                    method: "",
                                    minutes: ""
                                }]
                        },
                        instructions: [],
                        eventImage: "",
                        eventVideo: "",
                        attendees: [],
                        // email, sms, popup
                        class: "",
                        id: ""
                    };
                    if (angular.isDefined(googleEvent.recurrence) && googleEvent.recurrence !== null) {
                        _flEvent.repeated = true;
                        _flEvent.recurrence = [];
                        _flEvent.recurrence.push(googleEvent.recurrence[0]);
                    }

                    if (angular.isDefined(googleEvent.attendees)) {

                        angular.forEach(googleEvent.attendees, function (value, key) {
                            _flEvent.attendees.push(value);

                        });

                    }
                    //        console.log(googleEvent);
                    if (!(googleEvent.start === undefined) && !(googleEvent.start.date === undefined) && googleEvent.start.date) {

                        _flEvent.start = new Date(googleEvent.start.date);
                        _flEvent.allDay = true;

                    } else if (!(googleEvent.start === "undefined") && googleEvent.start && googleEvent.start.dateTime && googleEvent.start.dateTime !== "undefined") {
                        _flEvent.start = new Date(googleEvent.start.dateTime);
                    }
                    _flEvent.location = googleEvent.location;
                    if (!(googleEvent.end === undefined) && googleEvent.end.date && !(googleEvent.end.date === undefined)) {

                        _flEvent.end = new Date(googleEvent.end.date);
                        _flEvent.allDay = true;
                    } else if (typeof googleEvent.end !== "undefined" && googleEvent.end.dateTime && googleEvent.end.dateTime !== "undefined") {
                        _flEvent.end = new Date(googleEvent.end.dateTime);
                    }
                    _flEvent.reminders = googleEvent.reminders;
                    _flEvent.id = googleEvent.id;

                    _flEvent.title = googleEvent.summary;

                    // the new design encapsulate the event icon and the instruction list into a json and put it into the description 
                    //field of the google event
                    //  {description:"",eventIcon:"resourceID", instructions:[]}
                    // instructions is a array of instructions
                    // instruction object format: {index:1,title:"",image:resourceID, audio:resourceID,video:resourceID}
                    // in the js or andorid app, after you have made a request with tokens, the server can keep the token in a session
                    //  you can directly use the following format as a link for the audio, video, image src attribute:
                    //https://ri.smarttracker.no/files/resource.php?resourceID=*************

                    if (this.isJsonString(googleEvent.description)) {
                        console.log("googleEvent.description", googleEvent.description);
                        var jsonObj = JSON.parse(googleEvent.description);
                        _flEvent.description = jsonObj.description;
                        _flEvent.instructions = [];
                        _flEvent.eventVideo = jsonObj.eventVideo;
                        _flEvent.eventImage = jsonObj.eventImage;

                        angular.forEach(jsonObj.instructions, function (value) {
                            var instruction = {index: value.index,
                                title: angular.isDefined(value.title) ? value.title : "",
                                image: angular.isDefined(value.image) ? value.image : "",
                                audio: angular.isDefined(value.audio) ? value.audio : "",
                                video: angular.isDefined(value.video) ? value.video : ""};
                            _flEvent.instructions.push(instruction);
                        });
                        console.log("new format of eventImage, eventVideo,instructions", _flEvent.eventImage, _flEvent.eventVideo, _flEvent.instructions);
                    } else {
                        _flEvent.description = googleEvent.description;
                    }
                    _flEvent.repeated = (googleEvent.recurrence === undefined) ? false : true;
                    //        console.log("created full calendar event", _flEvent);
                    return _flEvent;
                },
                        factory.isJsonString = function (str) {
                            try {
                                JSON.parse(str);
                            } catch (e) {
                                return false;
                            }
                            return true;

                        };

                //get event method
                factory.getEventSource = function () {
                    var eventSource;
                    return eventSource;
                },
                        //one way of deep copy
                        factory.extendDeep = function extendDeep(dst) {
                            angular.forEach(arguments, function (obj) {
                                if (obj !== dst) {
                                    angular.forEach(obj, function (value, key) {
                                        if (dst[key] && dst[key].constructor && dst[key].constructor === Object) {
                                            extendDeep(dst[key], value);
                                        } else {
                                            dst[key] = angular.copy(value);
                                        }
                                    });
                                }
                            });
                            return dst;
                        };
                factory.authorizeFileServer = function (assetId, callback) {
                    var data = {type: "calendarvideolist", assetId: assetId};
                    smarttrackerService.authGetFile(data, true).then(function (res) {
                        console.info(res);
                        if (res.data.length === 0) {
                            var resourceID = "";
                            callback(resourceID);
                        } else {
                            callback(res.data[0].resourceID);
                        }

                    });
                };
                //another way of deep copy
                factory.deepExtend = function (destination, source) {
                    for (var property in source) {
                        if (source[property] && source[property].constructor && source[property].constructor === Object) {
                            destination[property] = destination[property] || {};
                            arguments.callee(destination[property], source[property]);
                        } else {
                            destination[property] = source[property];
                        }
                    }
                    return destination;
                };
                //add event method
                factory.append = function (event) {

                    _event = Object.create(null);
                    _event = this.deepExtend(_event, event);
                    var _ins = new Array();
                    if(event.instructions && event.instructions.length>0){
                        for(var i =0;i<event.instructions.length;i++){
                            _ins.push(event.instructions[i]);
                        }
                    }
                    var extra= {eventImage:event.eventImage,eventVideo:event.eventVideo,instructions:_ins};
                    if($rootScope.eventsExtra[event.id]){
                        $rootScope.eventsExtra[event.id] =null;
                        $rootScope.eventsExtra[event.id] = extra;
                    } else $rootScope.eventsExtra[event.id] = extra;
                    
                    console.log("event $rootScope.eventsExtra",$rootScope.eventsExtra);
                    $rootScope.eventSources.push(_event);
                    
                    this.delete("calendar", "primary");
                    this.put("calendar", "primary", $rootScope.eventSources);
                    delete _event;
                    console.log("after deleting ",$rootScope.eventSources);

                },
                        //delete event method
                        factory.deleteEvent = function (id) {
                            for (var i = $rootScope.eventSources.length - 1; i >= 0; i--) {

                                if ($rootScope.eventSources[i].id === id) {

                                    $rootScope.eventSources.splice(i, 1);
                                }
                            }
                            var array = [];
                            angular.extend(array, $rootScope.eventSources);

                            this.put("calendar", "primary", array);
                        }, factory.makeId = function () {
                    var d = new Date().getTime();
                    var uuid = 'xxxxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
                        var r = (d + Math.random() * 16) % 16 | 0;
                        d = Math.floor(d / 16);
                        return (c === 'x' ? r : (r & 0x3 | 0x8)).toString(16);
                    });
                    return uuid;
                };
                return factory;

            }]);

angular.module('stwo.poseidonCalendar').controller('ListCalendarController', function (ef, $scope, $controller, $state, notificationService, moduleStore) {
    $controller('BaseListContentController', {
        $scope: $scope
    });

    $scope.super({
        clazz: 'asset',
        downloadUrl: '/asset?select=name+tags+type+tracked+image+icon+lastValidPosition&sort=name&order=asc'
    });

    $scope.assetClicked = function (asset) {
        ef.authorizeFileServer(asset.id, function () {
            $state.go("secure.content.calendar", {
                id: asset.id
            });
        });

    }

    $scope.$watch("items.length", function () {

        if ($scope.items && $scope.items.length == 1) {
            ef.authorizeFileServer($scope.items[0].id, function () {
                $state.go("secure.content.calendar", {
                    id: $scope.items[0].id
                });
            });

        }
    });


})

angular.module('stwo.poseidonCalendar').controller('CalendarController', function (angularLoad, demoMode, smarttrackerService, themeService, contentCacheService, $rootScope, $state, $scope, $modal, GAuth, GApi, $controller, $stateParams, $compile, uiCalendarConfig, ef, angularMomentConfig, $http, $timeout) {
    $controller('uiCalendarCtrl', {
        $scope: $scope
    });
    console.log("state parameter", $stateParams);
    if ($stateParams.money && parseInt($stateParams.money) > 0) {
        $timeout(function () {
            $scope.clickCalendarDay();
        }, 3000);

    }
    themeService.loadWebTheme(themeService.chosenTheme());
    $scope.calendarAuthenticated = ef.get("calendar", "Authenticated");
    $rootScope.modal_instance_return = false;
    $scope.authed = true;

    $rootScope.flEvent.start = new Date();
    $rootScope.flEvent.end = new Date();
    $rootScope.eventSource = {
        url: "https://www.google.com/calendar/feeds/usa__en%40holiday.calendar.google.com/public/basic",
        className: 'gcal-event',
        // an option!
        currentTimezone: 'Europe/Amsterdam',
        // an option!
        className: 'gcal-event'
    };
    $scope.events = [];

    $controller('BaseListContentController', {
        $scope: $scope
    });

    $rootScope.fetchRoutes = function () {
//        $http.get(stwoGlobal.fileServerURL + "listRoutes.php?username=" + $rootScope.username).then(function (response) {
//            $rootScope.root.routes = [];
//            for (var r in response.data.result) {
//                var fn = response.data.result[r].title;
//                $rootScope.root.routes.push(fn);
//            }
//        });

        $http.get("https://ri.smarttracker.no/files/resource.php?type=route",{
                        headers: {
                "X-Auth-Token": smarttrackerService.getToken()
            }
        }).then(function (response) {
            console.log(response);

            $rootScope.root.routes = [];
            for (var r =0;r<response.data.length;r++) {
                $http.get("https://ri.smarttracker.no/files/resource.php?type=route&resourceID="+response.data[r].resourceID,{
                        headers: {
                "X-Auth-Token": smarttrackerService.getToken()
                    }
                }).then(function(res){
                    console.log(res);
                    var fn = res.data.meta.title;
                    $rootScope.root.routes.push(fn);                    
                });

            }
        });
        
    }

    $rootScope.eventSources = ef.get("calendar", "primary") ? ef.get("calendar", "primary") : [];

    $scope.date = new Date();
    $scope.datepickerOptions = {
        format: 'yyyy-mm-dd',
        language: '',
        autoclose: true,
        weekStart: 0,
    };
    var date = new Date();
    $scope.events = [{
            summary: 'Birthday Party',
            start: new Date(date.getYear(), date.getMonth(), date.getDate(), 19, 0),
            end: new Date(date.getYear(), date.getMonth(), date.getDate() + 1, 19, 0),
            allDay: false
        }];
    $scope.eventRender = function (event, element, view) {

        element.attr({
            'tooltip': event.title,
            'tooltip-append-to-body': true
        });
        $compile(element)($scope);
    };

    window.mobilecheck = function () {
        var check = false;
        (function (a) {
            if (/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(a) || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0, 4)))
                check = true
        })(navigator.userAgent || navigator.vendor || window.opera);
        return check;
    }
    $scope.mobileCheck = function () {

        return window.mobilecheck();
    }

    var gLoginTs = {};
    $scope.loginMsg = false;
    $scope.email = (ef.get("calendar", "email") === undefined || ef.get("calendar", "email") === null) ? undefined : ef.get("calendar", "email");
    $scope.authorize = function () {
        GAuth.setClient(gAuthInfor.clientId);
        GAuth.setScope(gAuthInfor.scopes);
        gLoginTs = new Date().getTime();

        GAuth.login().then(function () {
            var diff = new Date().getTime() - gLoginTs;
            if (diff < 400) {
                $scope.loginMsg = "If the calendar is wrong, please go to https://gmail.com and logout from your gmail account. Then click Change Account.";
            } else {
                $scope.loginMsg = false;
            }

            //get google oauth access token 
            var acctoken = gapi.auth.getToken();
            var data = [{
                    "properties": [{
                            "value": acctoken.access_token + "," + acctoken.expires_in + "," + acctoken.expires_at,
                            "typePropertyIdentifier": "3377bb90-8c9b-460a-a8fb-00b95909487e",
                            "propertyTypeIdentifier": "18abf295-150e-4c88-89d3-fb3e02f85724"
                        }]
                }];



            //local variables that stores the token
            loadEmail();
            // store the access token at smart tracker platform
            //            $rootScope.stored_access_token = data[0].properties[0].value;
            //            var sts = smarttrackerService.authPut(smarttrackerService.getCustomerId() + "/asset/" + $scope.asset.id, data);
            //            sts.then(function(response) {
            //                console.log("put access token response", response);
            //            }, function(res) {
            //                console.log("put access token feil:", res);
            //            });
            loadCalendar();


        }, function () {
            console.log("login feil");
        });
    };

    var loadEmail = function () {
        gapi.client.load('oauth2', 'v2', function () {
            gapi.client.oauth2.userinfo.get().execute(function (resp) {
                // Shows user email
                $scope.email = resp.email;
                ef.put("calendar", "email", $scope.email);
            });
        });
    };


    $scope.showModal = false;
    $scope.close = function () {
        $scope.showModal = false;
    };
    $scope.copy_mode = false;
    $scope.changeMode = function () {
        $scope.copy_mode = !$scope.copy_mode;
        $scope.eventSelected = "";
    }

    $scope.DropEvent = function (event, delta, revertFunc, jsEvent, ui, view) {
        $scope.copy = false;
        var smonth = event._start._d.getMonth();
        var sdate = event._start._d.getDate();
        var emonth = event._end._d.getMonth();
        var edate = event._end._d.getDate();

        revertFunc();
        if (view.type !== "month") {

            return;
        }
        var _destinationTime1 = new Date(event._start._d);
        var _destinationTime2 = new Date(event._end._d);
        _destinationTime1.setMonth(smonth);
        _destinationTime1.setDate(sdate);
        _destinationTime2.setMonth(emonth);
        _destinationTime2.setDate(edate);
        console.log("new month and date", _destinationTime1, _destinationTime2);
        if (_destinationTime1 < new Date()) {

            return;
        }
        console.log("dragged event", event);
        var nyId = ef.makeId();

        var _googleEvent = [];
        if (angular.isArray(ef.get("calendar", "google"))) {
            _googleEvent = ef.get("calendar", "google");
        }

        var _id = (event.id == undefined) ? undefined : event.id;

        var _gEvent;
        var _flEvent;
        for (var i = 0; i < $rootScope.eventSources.length; i++) {
            if ($rootScope.eventSources[i].id === _id) {
                _flEvent = $rootScope.eventSources[i];
            }
        }

        var changedStartDate = new Date(_destinationTime1);
        var changedEndDate = new Date(_destinationTime2);
        _flEvent.start.setDate(changedStartDate.getDate());
        _flEvent.end.setDate(changedEndDate.getDate());
        _flEvent.start.setMonth(changedStartDate.getMonth());
        _flEvent.end.setMonth(changedEndDate.getMonth());

        if (_googleEvent.length > 0 && _id !== undefined && _id !== "") {
            for (var i = 0; i < _googleEvent.length; i++) {
                if (_id === _googleEvent[i].id) {
                    _gEvent = _googleEvent[i];

                }
            }

        } else {

            return;
        }

        var startTime = (new Date(_gEvent.start.dateTime));
        startTime.setDate(changedStartDate.getDate());
        startTime.setMonth(changedStartDate.getMonth());
        var endTime = (new Date(_gEvent.end.dateTime));
        endTime.setDate(changedEndDate.getDate());
        endTime.setMonth(changedEndDate.getMonth());

        _gEvent.start.dateTime = ef.format(startTime) + ef.getTimeZone();
        _gEvent.end.dateTime = ef.format(endTime) + ef.getTimeZone();
        _gEvent.id = nyId;
        console.log("get original google event", _gEvent);
        gapi.client.load('calendar', 'v3', function () {
            $rootScope.gEvent.id = nyId;
            var request = gapi.client.calendar.events.insert({
                'calendarId': 'primary',
                'resource': ef.wrapGEvent(_gEvent),
            });

            request.execute(function (resp) {

                if (resp.status == "confirmed") {

                    ef.append(_flEvent);

                }
            }, function (resp) {
                console.log(resp);
            });
        });

    };

    $scope.clickCalendarEvent = function (date, jsEvent, view) {
        console.log("clickCalnedarEvent",date);

        $rootScope.fetchRoutes();
        $rootScope.flEvent.allDay = (date.allDay === undefined || date.allDay == null) ? false : date.allDay;
        if (angular.isDefined(date.recurrence) && date.recurrence.length > 0 && angular.isDefined(date.recurrence[0])) {
            console.log(date.recurrence[0], angular.isDefined(date.recurrence[0]),(typeof date.recurrence[0]) === undefined);
            $rootScope.flEvent.repeated = true;
            $rootScope.flEvent.recurrence.splice(0, $rootScope.flEvent.recurrence.length);
            $rootScope.flEvent.recurrence.push(date.recurrence[0]);

            //format the repeating rules to the editing interface.
            var _rule = $rootScope.flEvent.recurrence[0];
            _rule = _rule.split(":")[1];
            console.log("repeating rules", $rootScope.flEvent.recurrence);
            var _rules = _rule.split(";");
            for (var i = 0; i < _rules.length; i++) {
                console.log("rule", _rules[i]);

                if (ef.find(/FREQ=WEEKLY/, _rules[i])) {

                    $rootScope.repeated.FREQ = "week";
                }
                if (ef.find(/FREQ=DAILY/, _rules[i])) {
                    $rootScope.repeated.FREQ = "day";
                }
                if (ef.find(/FREQ=MONTHLY/, _rules[i])) {
                    $rootScope.repeated.FREQ = "month";
                }
                if (ef.find(/INTERVAL=[1-9]*/, _rules[i])) {
                    var temp = _rules[i].match(/INTERVAL=[1-9]*/)[0];

                    $rootScope.repeated.INTERVAL = Number(temp.substring(temp.indexOf("=") + 1, temp.length));

                }
                if (ef.find(/COUNT=[0-9]*/, _rules[i])) {
                    console.log("count", _rules[i]);
                    var temp = _rules[i].match(/COUNT=[0-9]*/)[0];

                    $rootScope.repeated.COUNT = Number(temp.substring(temp.indexOf("=") + 1, temp.length));
                }
                if (ef.find(/BYDAY=/, _rules[i])) {

                    var _byday = _rules[i].substring(_rules[i].indexOf("=") + 1, _rules[i].length);
                    if (ef.find(/MO/, _byday)) {
                        $rootScope.weekdays.MO = true;
                    } else
                        $rootScope.weekdays.MO = false;
                    if (ef.find(/TU/, _byday)) {
                        $rootScope.weekdays.TU = true;
                    } else
                        $rootScope.weekdays.TU = false;
                    if (ef.find(/WE/, _byday)) {
                        $rootScope.weekdays.WE = true;
                    } else
                        $rootScope.weekdays.WE = false;
                    if (ef.find(/TH/, _byday)) {
                        $rootScope.weekdays.TH = true;
                    } else
                        $rootScope.weekdays.TH = false;
                    if (ef.find(/FR/, _byday)) {
                        $rootScope.weekdays.FR = true;
                    } else
                        $rootScope.weekdays.FR = false;
                    if (ef.find(/SA/, _byday)) {
                        $rootScope.weekdays.SA = true;
                    } else
                        $rootScope.weekdays.SA = false;
                    if (ef.find(/SU/, _byday)) {
                        $rootScope.weekdays.SU = true;
                    } else
                        $rootScope.weekdays.SU = false;
                }

            }

        } else {
            $rootScope.flEvent.repeated = false;
        }
        $rootScope.flEvent.start = ((date._start === null || date._start._d === undefined || date._start._d == null) ? "" : new Date(date._start._d));
        $rootScope.flEvent.end = ((date._end === null || date._end._d === undefined || date._end._d == null) ? "" : new Date(date._end._d));
        $scope.dateDifference = new Date(new Date($scope.flEvent.end).getTime() - new Date($scope.flEvent.start));

        if (date) {
            console.log("clicked event", date);
            $rootScope.flEvent.title = (date.title == undefined || date.title == null) ? "" : date.title;
            $rootScope.flEvent.description = (date.description == undefined || date.description == null) ? "" : date.description;
            $rootScope.flEvent.location = (date.location != undefined || date.location == null) ? date.location : "";
            $rootScope.flEvent.eventImage = date.eventImage;

//            if (date.eventImage && date.eventImage !== "")
//                $rootScope.flEvent.eventImage = date.eventImage.indexOf("http") >= 0 ? date.eventImage : stwoGlobal.fileBaseUrl + stwoGlobal.fileUploadPostFix + "?resourceID=" + date.eventImage;
//            else
//                $rootScope.flEvent.eventImage = "";
            $rootScope.flEvent.eventVideo = date.eventVideo;


            $rootScope.flEvent.instructions.splice(0, $rootScope.flEvent.instructions.length);
            if (angular.isDefined(date.instructions) && date.instructions.length > 0) {
                $rootScope.flEvent.instructions = [];
                for (var i = 0; i < date.instructions.length; i++) {
                    $rootScope.flEvent.instructions.push(date.instructions[i]);
                }
            }
            console.log("get event instructions", date.instructions, $rootScope.flEvent.instructions);
            if (angular.isDefined(date.reminders) && angular.isDefined(date.reminders.overrides) && date.reminders.overrides.length > 0) {
                $rootScope.alarm.on = true;
                $rootScope.alarm.items.splice(0, $rootScope.alarm.items.length);

                angular.forEach(date.reminders.overrides, function (item) {
                    var _minutes = 0.0;
                    _minutes = parseFloat(item.minutes);
                    console.log("put minutes to alarm items", _minutes % 60 % 24);
                    if (_minutes % (60 * 24) === 0 && _minutes / 60 / 24 >= 1) {
                        $rootScope.alarm.items.push({
                            value: _minutes / 60 / 24,
                            unit: "DAYS"
                        });
                    } else if (_minutes % 60 === 0 && _minutes / 60 >= 1) {
                        $rootScope.alarm.items.push({
                            value: _minutes / 60,
                            unit: "HOURS"
                        });
                    } else {
                        $rootScope.alarm.items.push({
                            value: _minutes,
                            unit: "MINUTES"
                        });
                    }
                });


                console.log("updating events with alarm:", date.reminders.overrides);

            } else {
//                $rootScope.flEvent.reminders.overrides.splice(0, $rootScope.flEvent.reminders.overrides.length);
                $rootScope.alarm.on = false;

            }
            $rootScope.flEvent.id = (date.id == undefined) ? "" : date.id;
        }
        else {
            $rootScope.flEvent.title = "";
            $rootScope.flEvent.description = "";
            $rootScope.flEvent.location = "";
            $rootScope.flEvent.eventImage = "";
            $rootScope.flEvent.eventVideo ="";


            $rootScope.flEvent.instructions.splice(0, $rootScope.flEvent.instructions.length);
            $rootScope.flEvent.id = "";
        }
            console.log("$rootScope.eventsExtra",$rootScope.eventsExtra,date._id);
                if($rootScope.eventsExtra && $rootScope.eventsExtra[date._id]){
                    console.log("$rootScope.eventsExtra",$rootScope.eventsExtra);
                            if($rootScope.eventsExtra[date._id].eventImage && $rootScope.eventsExtra[date._id].eventImage!=="")
                                $rootScope.flEvent.eventImage =$rootScope.eventsExtra[date._id].eventImage;
                            if($rootScope.eventsExtra[date._id].eventVideo && $rootScope.eventsExtra[date._id].eventVideo !== "")
                                $rootScope.flEvent.eventVideo =$rootScope.eventsExtra[date._id].eventVideo;
                            if($rootScope.eventsExtra[date._id].instructions && $rootScope.eventsExtra[date._id].instructions.length>0){
                                $rootScope.flEvent.instructions = [];
                                angular.forEach($rootScope.eventsExtra[date._id].instructions,function(ins){
                                    $rootScope.flEvent.instructions.push(ins);
                                });
                            }
                        console.log("$rootScope.flEvent",$rootScope.flEvent);

                }
            

        if (angular.isUndefined(date.editable)) {
            $rootScope.modalInstance = $modal.open({
                templateUrl: 'modules/calendar/delete.html',
                controller: "eventEditingController",
                scope: $scope,
                size: "lg"
            });

        }
    };

    $scope.clickCalendarDay = function (date, jsEvent, view) {
        var todayDate = new Date();
        $rootScope.root.route = "";
        $rootScope.fetchRoutes();
        if (date === undefined) {
            $rootScope.flEvent.start = (todayDate.setHours(todayDate.getHours() + 1, 0));
            $rootScope.flEvent.end = (todayDate.setHours(todayDate.getHours() + 3, 0));
        } else {

            var _chosenDay = new Date(date._d);

            if (Date.UTC(_chosenDay.getFullYear(), _chosenDay.getMonth(), _chosenDay.getDate()) < Date.UTC(todayDate.getFullYear(), todayDate.getMonth(), todayDate.getDate()))
                return;
            $rootScope.flEvent.start = _chosenDay.setHours(todayDate.getHours() + 1, 0);

            $rootScope.flEvent.end = _chosenDay.setHours(todayDate.getHours() + 3, 0);

        }

        $rootScope.flEvent.id = "";
        $rootScope.flEvent.description = "";
        $rootScope.flEvent.eventVideo = "";
        $rootScope.flEvent.eventImage = "";
        if ($rootScope.flEvent.reminders && $rootScope.flEvent.reminders.overrides)
            $rootScope.flEvent.reminders.overrides.splice(0, $rootScope.flEvent.reminders.overrides.length);
        $rootScope.alarm.on = false;



        $rootScope.flEvent.repeated = false;
        var _title = "";
        if (smarttrackerService.language() === "en") {
            _title = $stateParams.money ? "Shopping! and don't forget to take " + $stateParams.money + " pounds with you!" : "";
        } else if (smarttrackerService.language() === "de") {
            _title = $stateParams.money ? "Einkaufen! und vergessen Sie nicht " + $stateParams.money + " eruos mit Ihnen zu nehmen.!" : "";
        } else if (smarttrackerService.language() === "no") {

            _title = $stateParams.money ? "Shopping! og ikke glem å ta " + $stateParams.money + " kroner med deg!" : "";
        }
        $rootScope.flEvent.title = $stateParams.money ? _title : "";

        ef.clear($rootScope.flEvent.instructions);
        $rootScope.modalInstance = $modal.open({
            templateUrl: 'modules/calendar/calendar_popup.html',
            controller: "eventEditingController",
            scope: $scope,
            size: "lg"
        });
    };


    var getDefaultView = function () {
        console.log("getDefaultView called");
        if ($scope.modal_instance_return)
            $scope.gotoDate();
        return ef.get("calendar", "view") ? ef.get("calendar", "view") : "month";
    };
    var getDefaultDate = function () {
        console.log("get default date called");
        return ef.get("calendar", "view.currentDate") ? moment(ef.get("calendar", "view.currentDate")) : moment(new Date());
    };
    $scope.uiConfig = {
        calendar: {
            height: 500,
            editable: true,
            header: {
                left: window.mobilecheck() ? 'title' : 'month agendaWeek agendaDay',
                center: window.mobilecheck() ? '' : 'title',
                right: 'today prev,next'
            },
            timezone: "local",
            lang: "en",
            events: new Array(),
            firstDay: 1,
            editable: true,
                    eventLimit: true,
            eventClick: $scope.clickCalendarEvent,
            dayClick: $scope.clickCalendarDay,
            //            eventDrop: $scope.DropEvent,
            eventResize: $scope.resizeEvent,
            eventRender: $scope.eventRender,
            defaultDate: getDefaultDate(),
            //            eventDragStart: $scope.eventDragStart,
            //            eventDragStop: $scope.eventDragStop,
            defaultView: getDefaultView(),
            viewDestroy: function (view, element) {

                console.log("view destroy");

            },
            viewRender: function (view, element) {
                console.log("viewRender called", view);
                if ($scope.modal_instance_return)
                    $scope.gotoDate();


                if (window.mobilecheck()) {
                    $timeout(function () {
                        $scope.changeView("agendaDay", "calendar");
                    }, 2000);
                }

                ef.put("calendar", "view", view.type);

            }
        }
    };

    $scope.getEventsFromCache = function () {
        console.log("smart tracker language setting:", smarttrackerService.language());
        //        console.log("cached events:",ef.get("calendar","primary"));
        if (smarttrackerService.language() === "en") {
            $scope.uiConfig.calendar.lang = "en";
            $scope.uiConfig.calendar.firstDay = 0;
            $scope.uiConfig.calendar.dayNamesShort = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
            //            uiCalendarConfig.calendars["calendar"].lang = "en";
            //            angularLoad.loadScript('http://code.angularjs.org/1.0.8/i18n/angular-locale_en-gb.js').then(function(){}).catch(function(){})
            console.log("english date time translation loaded");
        } else if (smarttrackerService.language() === "no") {
            //            $('#calendar').fullCalendar('destroy');
            $scope.uiConfig.calendar.lang = "nb";
            $scope.uiConfig.calendar.firstDay = 1;
            console.log("norsk");
            $scope.uiConfig.calendar.dayNamesShort = ["Søndag", "Mandag", "Tirsdag", "Onsdag", "Torsdag", "Fredag", "Lørdag"];
            //             uiCalendarConfig.calendars["calendar"].lang = "no";
            //            angularLoad.loadScript('http://code.angularjs.org/1.0.8/i18n/angular-locale_no.js').then(function(){}).catch(function(){})     
            console.log("no date time translation loaded");
        } else if (smarttrackerService.language() === "de") {
            $scope.uiConfig.calendar.lang = "de";
            $scope.uiConfig.calendar.firstDay = 1;
            //            uiCalendarConfig.calendars["calendar"].lang = "de";
            $scope.uiConfig.calendar.dayNamesShort = ["Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag"];
            //            angularLoad.loadScript('http://code.angularjs.org/1.0.8/i18n/angular-locale_de.js').then(function(){}).catch(function(){})            
            //            $('#calendar').fullCalendar('destroy');
            console.log("de date time translation loaded");
        }
        if (ef.get("calendar", "primary")) {
            $rootScope.eventSources = ef.get("calendar", "primary");
            $scope.uiConfig.calendar.events = ef.get("calendar", "primary");
        }
    }

    $scope.uiConfig.calendar.renderEvent = $scope.getEventsFromCache();
    $scope.clear = function () {
        $rootScope.flEvent.description = " ";
        $rootScope.flEvent.title = "";
        $rootScope.flEvent.end = (null);
        $rootScope.flEvent.start = (null);
        $rootScope.flEvent.eventVideo = "";
        $rootScope.flEvent.eventImage = "";
    };
    $scope.changeView = function (view, calendar) {
        if (uiCalendarConfig.calendars[calendar]) {
            uiCalendarConfig.calendars[calendar].fullCalendar('changeView', view);
        }
    };
    $scope.gotoDate = function () {
        console.log("goto date called:", ef.get("calendar", "view.start"));
        console.log(uiCalendarConfig.calendars.calendar);
        if (uiCalendarConfig.calendars.calendar) {
            if (ef.get("calendar", "view.currentDate"))
                uiCalendarConfig.calendars.calendar.fullCalendar('gotoDate', moment(ef.get("calendar", "view.currentDate")));
        }
        $rootScope.modal_instance_return = false;
    };
    //    $scope.changeView1 = function() {
    //        console.log("change view 1 ",ef.get("calendar","view"));
    //        if(ef.get("calendar","view") && ef.get("calendar","view") !== ""){
    //            $scope.changeView(ef.get("calendar","view"),"calendar");
    //        }
    //    };
    //    $scope.changeView1();
    $scope.addClicked = function () {
        $scope.clickCalendarDay();
    };
    $scope.toggleMin = function () {
        $scope.minDate = $scope.minDate ? null : new Date();
    };
    $scope.toggleMin();
    $scope.open = function ($event) {
        $event.preventDefault();
        $event.stopPropagation();
        $scope.opened = true;
    };

    $scope.formats = ['dd-MMMM-yyyy', 'yyyy/MM/dd', 'dd.MM.yyyy', 'shortDate'];
    $scope.format = $scope.formats[0];

    $scope.downloadAsset = function () {

        smarttrackerService.authGet(smarttrackerService.getCustomerId() + '/asset/' + $stateParams.id + '?select=*').then(function (response) {
            $scope.asset = response.data.result[0];
            $rootScope.username = $scope.asset.id;
            console.log("downloaded asset:", response.data.result[0]);
            if ($scope.asset) {
                ef.put("asset", $scope.asset.id, $scope.asset);
            }
        });
    }

    smarttrackerService.isLoggedInDelayed().then(function () {
        $scope.downloadAsset();
        $scope.getEventsFromCache();
    });


    smarttrackerService.googleAuth().then(function (response) {
        GAuth.checkAuth().then(function () {
            console.log("a");
            var token = response.split(",")[0];
            // gapi.auth.setToken(token);
            loadCalendar();
            loadEmail();
            $scope.loginMsg = false;
        }, function () {
            $scope.authorize();
        });
    }, function (response) {
        $scope.authorize();
    });

    $scope.changeAccount = function () {
        $scope.calendarAuthenticated = false;
        ef.put("calendar", "Authenticated", $scope.calendarAuthenticated);
        GAuth.logout().then(function () {
            $timeout(function () {
                $scope.authorize();
            }, 15000);
        });
    }

    var loadCalendar = function () {
        if (gapi && gapi.auth.getToken()) {
            gapi.client.load('calendar', 'v3', function () {
                var request = gapi.client.calendar.events.list({
                    'calendarId': 'primary'
                });
                request.execute(function (resp) {
                    ef.put("calendar", "google", resp.items);
                    console.log("google events", resp.items);
                    var array = [];
                    console.log("length of events:" + resp.items.length, resp.items);
                    for (var iterator = 0; iterator < resp.items.length; iterator++) {
                        var event = ef.createEventFromGoogleEvents(resp.items[iterator]);
                        if (event.recurrence)
                            ef.createRepeatedEvent(event, array);
                        else
                            array.push(event);
                    }
                    ;
                    $rootScope.eventSources.splice(0, $rootScope.eventSources.length);
                    $rootScope.eventSources = array;
                    $scope.uiConfig.calendar.events = array;
                    ef.put("calendar", "primary", array);
                    if (window.mobilecheck()) {
                        $timeout(function () {
                            $scope.changeView("agendaDay", "calendar");
                        }, 0);

                    } else {
                      
                        $scope.calendarView = ef.get("calendar", "view");
                        console.log(ef.get("calendar", "view"));
                        if (ef.get("calendar", "view") && ef.get("calendar", "view") !== "")
                            $timeout(function () {
                                $scope.changeView($scope.calendarView, "calendar");
                            }, 2000);
                    }
                    $scope.calendarAuthenticated = true;
                    ef.put("calendar", "Authenticated", $scope.calendarAuthenticated);
                });
            });
        }
    }
    $scope.clearLoginMsg = function () {
        $scope.loginMsg = false;
    }
})