angular.module('stwo.management.device', ["stwo.core"])
	.config(function($stateProvider, moduleStoreProvider, $translateProvider) {
		
		moduleStoreProvider.registerModule({
                    name: "device-management",
                    links: [
                        {
                            name:"MANAGEMENT_DEVICES",
                            category: "management" ,
                            sref: "secure.content.management.device",
                            access : ["device", "get"],
                            icon: 'phone',
                            sort: 20,
                            controllers: ['DeviceManagementListController', 'DeviceManagementDetailController']
                        }
                    ]
            });
		
		$stateProvider
			.state("secure.content.management.device",
				{
					url: "/device/:filter",
					templateUrl: "modules/management/device/list.html",
					controller: "DeviceManagementListController"
				})
			.state("secure.content.management.device.detail",
				{
					url: "/device-detail/:id",
					templateUrl: "modules/management/device/detail.html",
					controller: "DeviceManagementDetailController"
				})
	});
	
	
angular.module('stwo.management.device').controller('DeviceManagementListController', function ($scope, $stateParams, $state, $modal, $controller, smarttrackerService) {
	$controller('BaseListContentController', {$scope: $scope});
    
    $scope.addPredefinedFilter("timeout_3day", [{filterId: "active", label: "ACTIVE", value: "true"},{filterId: "lastSeen", label: "LAST_SEEN_3_DAY", value: "259200000"}], "&active:equals=true&lastSeen:older=259200000");
    
    $scope.super({clazz: 'device', downloadUrl: '/device?select=@&sort=name&order=asc'});
    
    $scope.deviceClicked = function(device) {
        $state.go("secure.content.management.device.detail", {id:device.id});
    }

});

angular.module('stwo.management.device').controller('DeviceManagementDetailController', function ($scope, $stateParams, smarttrackerService) {
	$scope.device = {};
           
	$scope.removeAsset = function(asserID){
		var newAssets = [];
		for(var i=0; i<$scope.device.assets.length; i++){
			if($scope.device.assets[i].id !== asserID){ newAssets.push({"name": $scope.device.assets[i].name, "id": $scope.device.assets[i].id});}
		}
		var data = [{"assets": newAssets}];
		smarttrackerService.authPut(smarttrackerService.getCustomerId() + '/device/' + $stateParams.id, JSON.stringify(data));
		
	}
	
	var promise = smarttrackerService.authGet(smarttrackerService.getCustomerId() + '/device/' + $stateParams.id + '?select=*')
	.then(function(response) {
			$scope.device = response.data.result[0];
	});
});