angular.module('stwo.management', ["stwo.core"])
	.config(function($stateProvider, moduleStoreProvider, $translateProvider) {
		
		moduleStoreProvider.registerModule({name: "management", 
            categories : [{
                    name : "MANAGEMENT",
                    icon : "fa fa-gears",
                    color: "warning",
                    sort : 81
            }],
            links: [
                {
                    name:"MANAGEMENT_NAVIGATION",
                    category: "navigation" , 
                    color: "warning",
                    access: ["asset", "put"],
                    sref: "secure.content.management",
                    icon: "wrench",
                    sort: 80
                },
                {
                    name:"MANAGEMENT",
                    category: "filter" ,
                    sref: "secure.content.management",
                    access: ["asset", "put"],
                    icon: "wrench",
                    color: "warning",
                    sort: 81
                }
            ]});
		
        $stateProvider
			.state("secure.content.management",
				{
					url: "/management",
					templateUrl: "modules/management/dashboard.html",
					controller: "ManagementDashboardController"
				})
    
        moduleStoreProvider.addPossibleFilter("type", {id: "name", label: "NAME", type: "string", field: "name", comparator: "contains"});
        moduleStoreProvider.addPossibleFilter("type", {id: "description", label: "DESCRIPTION", type: "string", field: "description", comparator: "contains"});
    
        moduleStoreProvider.addPossibleFilter("device", {id: "name", label: "NAME", type: "string", field: "name", comparator: "contains"});
        moduleStoreProvider.addPossibleFilter("device", {id: "uuid", label: "DEVICE_ID", type: "string", field: "uuid", comparator: "contains"});
        moduleStoreProvider.addPossibleFilter("device", {id: 'primaryProperties', label: "PRIMARY_PROPERTIES", type: "string", field: "primaryPropertiesString", comparator: "contains"});
        moduleStoreProvider.addPossibleFilter("device", {id: "active", label: "ACTIVE", comparator: "equals", type: "list", list: [{label: "-", value: ""}, {label: "Active", value: "true"}, {label: "Inactive", value: "false"}], field: "active"});
        moduleStoreProvider.addPossibleFilter("device", {id: "lastSeen", label: "LAST_SEEN", comparator: "older", type: "list", list: [{label: "-", value: ""}, {label: "LAST_SEEN_1_DAY", value: "86400000"}, {label: "LAST_SEEN_3_DAY", value: "259200000"}], field: "lastSeen"});
	});
	
	
angular.module('stwo.management').controller('ManagementDashboardController', function ($scope, $state, moduleStore) {
    $scope.allLinks = moduleStore.links();
    $scope.linkClicked = function(link) {
        if (link.stateParams) {
            $state.go(link.sref.split("(")[0], link.stateParams);
        } else {
            $state.go(link.sref);
        }
    }
});