angular.module('stwo.personalize', ['stwo.core','ui.bootstrap','ui.bootstrap.datepicker','ui.bootstrap.timepicker','ngAudio']).config(function($provide,$stateProvider, 
  $urlRouterProvider, moduleStoreProvider, $translateProvider) {
    
    moduleStoreProvider.registerModule({
        name: "personalize",
        links: [{
            name: "PERSONALIZE",
            category: "navigation",
            icon: "fa fa-user",
            sref: "secure.content.asset.personalize",
            sort: 5,
            color: "success"
        }]
    });
    $stateProvider
            .state("secure.content.asset.personalize",
                {
                    url: "/asset-personalize:id",
                    templateUrl: "aktive-spor/dashboard/dashboard.html",
                    controller: "PerListController"
                });
    $stateProvider.state("secure.content.personalize", {
        url: "/asset-personalize:id",
        templateUrl: "modules/personalization/detail.html",
        controller: "PerListController"
    });
}) 
angular.module('stwo.personalize').controller('PerListController', function ($scope, $controller, $state, notificationService, moduleStore,ngAudio) {
    $controller('BaseListContentController', {$scope: $scope});
    $scope.audio = ngAudio.load("http://10.3.1.114/Poseidon/angular.audio/app/audio/daniel_stern_robot_hitchiker.mp3");

    $scope.super({clazz: 'asset', downloadUrl: '/asset?select=name+tags+type+tracked+image+icon+lastValidPosition&sort=name&order=asc'});
    $scope.dateOptions = {
      formatYear: 'yyyy',
      startingDay: 1,
      language:'nb',
      initDate:new Date()
    };
  $scope.today = function() {
    $scope.startDate = new Date();
  };
  $scope.today();

  $scope.clear = function () {
    $scope.startDate = null;
  };

  // Disable weekend selection
  $scope.disabled = function(date, mode) {
      console.log(date.getDay());
    return ( mode === 'day' && ( date.getDay() === 0 || date.getDay() === 6 ) );
  };

  $scope.toggleMin = function() {
    $scope.minDate = $scope.minDate ? null : new Date();
  };
  $scope.toggleMin();

  $scope.open = function($event) {
    $event.preventDefault();
    $event.stopPropagation();

    $scope.startDateOpen = true;
  };
  $scope.open1 = function($event) {
    $event.preventDefault();
    $event.stopPropagation();

    $scope.opened1 = true;
  };
  $scope.dateOptions = {
    formatYear: 'yy',
    startingDay: 1
  };

  $scope.formats = ['dd-MMMM-yyyy', 'yyyy/MM/dd', 'dd.MM.yyyy', 'shortDate'];
  $scope.format = $scope.formats[0];

  var tomorrow = new Date();
  tomorrow.setDate(tomorrow.getDate() + 1);
  var afterTomorrow = new Date();
  afterTomorrow.setDate(tomorrow.getDate() + 2);
  $scope.events =
    [
      {
        date: tomorrow,
        status: 'full'
      },
      {
        date: afterTomorrow,
        status: 'partially'
      }
    ];

  $scope.getDayClass = function(date, mode) {
    if (mode === 'day') {
      var dayToCheck = new Date(date).setHours(0,0,0,0);

      for (var i=0;i<$scope.events.length;i++){
        var currentDay = new Date($scope.events[i].date).setHours(0,0,0,0);

        if (dayToCheck === currentDay) {
          return $scope.events[i].status;
        }
      }
    }

    return '';
  };
    $scope.assetClicked = function(asset) {
        $state.go("secure.content.personalize", {id:asset.id});
    }
	
	$scope.$watch("items.length", function() {
		if ($scope.items && $scope.items.length == 1) {
			$state.go("secure.content.personalize", {id:$scope.items[0].id});
		}
                
	});
})
angular.module('stwo.asset').controller('PerController', function($state, $scope, $modal, $controller, $stateParams, smarttrackerService, pushService, contentCacheService) {
    
     $controller('BaseDetailContentController', {$scope: $scope});
     
    $scope.super({clazz: 'asset', downloadUrl: '/asset?select=name+tags+type+tracked+image+icon+lastValidPosition&sort=name&order=asc'});
    $scope.asset = {};
    var debugz = true;
    var debug = function (message,obj, flag){
        if (debugz) {
            if(angular.isUndefined(flag))
                console.log(message);
            else console.log("-------"+message+"--------");
            if(undefined !== obj)
            console.log(obj);
        }
    }

  
    $scope.ftheme = [{code:"HIGH_CONTRAST",language:"High contrast",en:"High contrast",de:"hoher Kontrast",no:"høy kontrast"},
        {code:"POSEIDON",language:"Poseidon",en:"Poseidon",de:"Poseidon",no:"Poseidon"}];
    $scope.phone={number:""};
    $scope.option ={sTheme:""};
    $scope.putTheme = function(){
        var data = [{"properties":[{"value":"",
                        "typePropertyIdentifier": "0935c2f7-f853-4742-86b0-24ac3291ab45",
                        "propertyTypeIdentifier": "72831ff6-8d37-4fc0-9d7f-170c04d4bfdb"}]}];

        debug("put theme data:",data);
        if ($scope.option.sTheme === $scope.ftheme[0]){
      
            data[0].properties[0].value = "hc";
        } else if($scope.option.sTheme === $scope.ftheme[1]){ 
      
            data[0].properties[0].value = "pos";
        }
        var sts = smarttrackerService.authPut(smarttrackerService.getCustomerId()+"/asset/"+$scope.asset.id,data);
        sts.then(function (response){
            debug("put theme response",response);
        },function(res){
            debug("put theme feil:",res);
        });
    }
    $scope.putPhone= function(){
        var data =  [{"properties":[{"value":$scope.phone.number,"typePropertyIdentifier": "40f06fad-4267-4381-8792-5774d57ec6c8","propertyTypeIdentifier": "0b97a726-96c6-4410-b2d9-6792a439fafa"}]}];
        var sts = smarttrackerService.authPut(smarttrackerService.getCustomerId()+"/asset/"+$scope.asset.id,data);
        sts.then(function (response){
            debug("put phone response",response);
        },function(res){
            debug("error while putting phone number:",res);
        });
    };


    $scope.downloadAsset = function() {
        smarttrackerService.authGet(smarttrackerService.getCustomerId() + '/asset/' + $stateParams.id + '?select=*').then(function(response) {
            $scope.asset = response.data.result[0];
            debug("downloaded asset:",$scope.asset);
            if ($scope.asset) {
                contentCacheService.put("asset", $scope.asset.id, $scope.asset);
            }
            for(var i = 0;i<$scope.asset.properties.length;i++){
                if($scope.asset.properties[i].name === "theme"){
                    if( $scope.asset.properties[i].value === "pos"){
                        $scope.option.sTheme = $scope.ftheme[1];
                    } else if($scope.asset.properties[i].value === "hc"){
                        $scope.option.sTheme = $scope.ftheme[0];
                    }
                }
                if($scope.asset.properties[i].name === "phone")                
                $scope.phone.number = $scope.asset.properties[i].value;
        }
        });        

    }

    smarttrackerService.isLoggedInDelayed().then(function() {
        
        
     
        if(smarttrackerService.language() === "en"){
            $scope.ftheme[0].language = $scope.ftheme[0].en;
            
        } else if (smarttrackerService.language() ==="de"){
            $scope.ftheme[0].language = $scope.ftheme[0].de;
        }else if (smarttrackerService.language() ==="no"){
            $scope.ftheme[0].language = $scope.ftheme[0].no;
        }
        $scope.downloadAsset();
        $scope.putPhone();
    });
    $scope.super({clazz: 'asset'});
});