var assetApp = angular.module('stwo.route', ["stwo.core",'ui.bootstrap','ui.calendar','angular-google-gapi','ngFileUpload']).config(function($provide,$stateProvider, 
  $urlRouterProvider, moduleStoreProvider, $translateProvider) {
    
    moduleStoreProvider.registerModule({
            name : "route",
            links : [{
                    name : "ROUTES",
                    category : "navigation",
                    sref : "secure.content.route",
                    access: ["asset", "get"],
                    icon : "fa fa-picture-o",
                    color: "info",
                    sort : 11
            }]
    });

    $stateProvider.state("secure.content.route", {
            url : "/route-list/:filter",
            templateUrl : "aktive-spor/dashboard/dashboard.html",
            controller : "RoutesAssetListController"
    })
    .state("secure.content.route.details", {
            url : "/route/:id",
            templateUrl : "modules/route/list_routes.html",
            controller : "RoutesController"
    });

    // moduleStoreProvider.addPossibleFilter("asset", {id: "name", label: "ASSETS_FILTER_NAME", type: "string", field: "name", comparator: "contains"});
    // moduleStoreProvider.addPossibleFilter("asset", {id: "description", label: "ASSETS_FILTER_DESCRIPTION", type: "string", field: "description", comparator: "contains"});
    // moduleStoreProvider.addPossibleFilter("asset", {id: "tags", label: "ASSETS_FILTER_TAG", type: "string", field: "tags", comparator: "contains"});
    // moduleStoreProvider.addPossibleFilter("asset", {id: "typename", label: "ASSETS_FILTER_TYPE", type: "string", field: "type.name", comparator: "contains"});
}) 

angular.module('stwo.route').controller('RoutesAssetListController', function($scope, $state, $controller, pushService, contentCacheService) {
    $controller('BaseListContentController', {$scope: $scope});
    
    $scope.super({clazz: 'asset', downloadUrl: '/asset?select=name+tags+type+tracked+image+icon+lastValidPosition&sort=name&order=asc'});

    $scope.assetClicked = function(asset) {
        $state.go("secure.content.route.details", {id:asset.id});
    }

        $scope.$watch("items.length", function() {
        if ($scope.items && $scope.items.length == 1) {
            $state.go("secure.content.route.details", {
                id: $scope.items[0].id
            });
        }

    });
   console.log($scope.items.length);
});




angular.module('stwo.route').controller('RoutesController', function($state, $scope, $modal, $controller, $stateParams, smarttrackerService, pushService, contentCacheService, leafletData, mapService, 
    $http, Upload) {

    $controller('BaseDetailContentController', {$scope: $scope});
    var username = $stateParams.id;
    console.log("id is: " + username);

    console.log("here we go");
    $scope.sentCommands = null;
    $scope.markers = {};
    $scope.paths = {};
    $scope.mapData = {
            center : {
                    lat : 0,
                    lng : 0,
        zoom : 1            
            }
    };
    $scope.data = "fething";
    $scope.fetchData = function() {
    $http.get(stwoGlobal.fileServerURL + 'listRoutes.php?username='+username).
        success(function(data, status, headers, config) {
              $scope.data = data.result;
              console.log(data);
              console.log("Checking for data");
          });
      }
$scope.fetchData();
 $scope.$watch('files', function () {
        $scope.upload($scope.files);
    });
    $scope.log = '';
$scope.uploadInProgress = false;
$scope.uploadProgress = 0;

$scope.deleteFile = function(filename) {
    // $http.post("http://localhost/deleteFile.php", {'username':username, 'filename':filename}
    //     , {headers: {'Content-Type': 'application/json', "Access-Control-Allow-Origin":"*"}}).success(function (response, status, headers, config) {
    //             $scope.log=response;
    // });
console.log("username:" + username + " filename: " + filename);
    $http.post(stwoGlobal.fileServerURL + "deleteFile.php", {'username':username, 'filename':filename}).success(function (response){
        $scope.feedback = response;
        $scope.fetchData();
    }).
    error(function(response) {
        $scope.errorMsg = response;
    });
}

 $scope.upload = function (files) {
        if (files && files.length) {
            $scope.uploadInProgress = true;
            for (var i = 0; i < files.length; i++) {
                var file = files[i];
                $scope.uploadInProgress = true;
                Upload.upload({
                    url: stwoGlobal.fileServerURL+ 'upload.php',
                    fields: {
                        'username': username
                    },
                    file: file
                }).progress(function (evt) {
                    var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
                    $scope.uploadProgress = progressPercentage;
                    $scope.log = 'progress: ' + progressPercentage + '% ' +
                                evt.config.file.name + '\n' + $scope.log;
                }).success(function (data, status, headers, config) {
                    $scope.log = 'file ' + config.file.name + 'uploaded. Response: ' + JSON.stringify(data) + '\n' + $scope.log;
                   // $scope.$apply();
                    $scope.fetchData();
                    console.log("data: " ) ;
                    if(data.indexOf("to big") > 0) {
                        $scope.errorFeedback = "Upload failed. Check file size";
                    } else  $scope.errorFeedback = "";
                    $scope.uploadInProgress = false;
                    $scope.uploadProgress = 0;
                });
            }
        }
    };

});
