var assetApp = angular.module('stwo.settings', ["stwo.learn", "stwo.core",'ui.bootstrap','angular-google-gapi','ngFileUpload']).config(function($provide,$stateProvider, 
  $urlRouterProvider, moduleStoreProvider, $translateProvider) {
    
    moduleStoreProvider.registerModule({
            name : "settings",
            links : [{
                    name : "ASSETS_NAVIGATION",
                    category : "navigation",
                    sref : "secure.content.asset.settings",
                    access: ["asset", "get"],
                    icon : "fa fa-map-marker",
                    controllers: ["UserController"],
            sort: 5,
            color: "success"
            }]
    });

    $stateProvider

            .state("secure.content.asset.details", {
                            url: "/setting:id",
                            templateUrl: "modules/settings/user.html",
                            controller: "UserController",
                    })            
            .state("secure.content.asset.settings",
                    {
                            url : "/setting-list/",
                            templateUrl : "aktive-spor/dashboard/dashboard.html",
                            controller: "UserListController",
                    });

}) 




angular.module('stwo.settings').controller('UserListController', function ($scope, $state, $controller, smarttrackerService,pushService, contentCacheService) {
   $controller('BaseListContentController', {
        $scope: $scope
    });

    $scope.super({
        clazz: 'asset',
        downloadUrl: '/asset?select=name+tags+type+tracked+image+icon+lastValidPosition&sort=name&order=asc'
    });

    $scope.assetClicked = function(asset) {
        $state.go("secure.content.asset.details", {
            id: asset.id
        });
    }

    $scope.$watch("items.length", function() {
        if ($scope.items && $scope.items.length == 1) {
            $state.go("secure.content.asset.details", {
                id: $scope.items[0].id
            });
        }
    });
    console.log("----------------",$scope.items);
  
});

angular.module('stwo.settings').controller('UserController', function (LS,$scope, $timeout,$controller,$stateParams,$rootScope,contentCacheService,smarttrackerService,themeService,$state, mapService,$http, moduleStore,angularMomentConfig,Upload) {
    $controller('BaseDetailContentController', {$scope: $scope});
    $scope.properties={};
    $scope.asset = {};
    $scope.query = "";
    $scope.learn = {
        user:"",
        language:"",
        query:[{value:"1",name:"Number of Undesirable Events"},{value:"2",name: "Journey Time"}],
        window:[{value:"d",name:"Since yesterday"},{value:"w",name:"Since last week"},
            {value:"m",name:"Since last month"}]
    };
    $scope.learn.select_q = {value:""};
    $scope.learn.select_w = {value:""};
    $scope.weatherData = [];
    $scope.runQuery=function(){
        var user = smarttrackerService.getUsers();
        console.log("user:",$scope.learn.user,
        ",query:",$scope.learn.select_q,
        ",widow:",$scope.learn.select_w,",language:",$scope.learn.language,
        ",route:",$scope.learn.select_r);
        LS.runQuery($scope.learn.user,$scope.learn.select_q!==null?$scope.learn.select_q.value:"",
        $scope.learn.select_w!==null?$scope.learn.select_w.value:"",
        $scope.learn.language,$scope.learn.select_r).then(function(response){
            
            if(response !== undefined && response !== ""){
                $scope.query="data:image/jpg;base64,"+response;
//            console.log($scope.query);
        } else {
            console.log(response);
            $scope.no_query = true;
            $timeout(function(){$scope.no_query = false;},1000);
        }
            
        });
    };
    //-----------------  merged from personalise  -----------------

//    $scope.webTheme = [{code:"default",language:"Poseidon",en:"Poseidon",de:"Poseidon",no:"Poseidon"},{code:"webtheme1",language:"theme1",en:"theme1",de:"theme1",no:"theme1"}];
    $scope.webTheme = ["default","webtheme1"];
    $scope.loadWebThemes  = function (){
        var _themes=themeService.getAvailableThemes();
        $scope.webTheme.splice(0,$scope.webTheme.length);
        
        angular.forEach(_themes,function(value){
           
            $scope.webTheme.push(value);
        });
     
    
    }
    $scope.loadWebThemes();
    $scope.ftheme = [{code:"HIGH_CONTRAST",language:"High contrast",en:"High contrast",de:"hoher Kontrast",no:"Høykontrast"},
        {code:"POSEIDON",language:"Poseidon",en:"Poseidon",de:"Poseidon",no:"Poseidon"}];
    $scope.phone={number:""};
    $scope.option ={sTheme:"",wTheme:""};
    $scope.putMap = function(){
        var data = [{"properties":[{"value":$scope.selectedMapProvider,
                        "typePropertyIdentifier": "1e979d73-969a-430b-bd13-f95d6f94768b",
                        "propertyTypeIdentifier": "8aa44c2f-0de5-4809-aa97-507a2fb2b93f"}]}];

        var sts = smarttrackerService.authPut(smarttrackerService.getCustomerId()+"/asset/"+$scope.asset.id,data);
        sts.then(function (response){

        },function(res){
  
        });        
    };

    $scope.putTheme = function(){
        var data = [{"properties":[{"value":"",
                        "typePropertyIdentifier": "0935c2f7-f853-4742-86b0-24ac3291ab45",
                        "propertyTypeIdentifier": "72831ff6-8d37-4fc0-9d7f-170c04d4bfdb"}]}];
        if ($scope.option.sTheme === $scope.ftheme[0]){

            data[0].properties[0].value = "hc";
        } else if($scope.option.sTheme === $scope.ftheme[1]){ 
      
            data[0].properties[0].value = "pos";
        }
        var sts = smarttrackerService.authPut(smarttrackerService.getCustomerId()+"/asset/"+$scope.asset.id,data);
        sts.then(function (response){

        },function(res){

        });
    }
    $scope.putalarmInsistent = function(){
//        $scope.properties.alarmInsistent = document.getElementById('alarmInsistent').checked?true:false;
        var data = [{"properties":[{"value":$scope.properties.alarmInsistent,
                        "typePropertyIdentifier": "affbaae9-4d4f-4b81-a9df-79c30092a2f8",
                        "propertyTypeIdentifier": "d0f5d889-c5e8-48e3-b543-7a8ce90d22b8"}]}];
        var sts = smarttrackerService.authPut(smarttrackerService.getCustomerId()+"/asset/"+$scope.asset.id,data);
        sts.then(function (response){
            console.log("set alarmInsistent",$scope.properties.alarmInsistent);
        },function(res){

        });        
    }
    $scope.putalarmOnStart = function(){
//        $scope.properties.alarmOnStart = document.getElementById('alarmOnStart').checked?true:false;
        var data = [{"properties":[{"value":$scope.properties.alarmOnStart,
                        "typePropertyIdentifier": "c0b8bc97-acd1-4fe0-b925-0d486dd507b1",
                        "propertyTypeIdentifier": "da852545-7ab8-412b-abd1-ccdce52738d0"}]}];
        var sts = smarttrackerService.authPut(smarttrackerService.getCustomerId()+"/asset/"+$scope.asset.id,data);
        sts.then(function (response){
            console.log("set alarmOnStart",$scope.properties.alarmOnStart);
        },function(res){

        });        
    }    
    $scope.putmobileStreaming = function(){
//        $scope.mobileStreaming = document.getElementById('mobileStreaming').checked?true:false;
        var data = [{"properties":[{"value":$scope.properties.mobileStreaming,
                        "typePropertyIdentifier": "5dc15be4-9e1f-4366-bace-6b5f07c4ca31",
                        "propertyTypeIdentifier": "f4597f3c-2d6a-43b2-872d-36f7237867b7"}]}];
        var sts = smarttrackerService.authPut(smarttrackerService.getCustomerId()+"/asset/"+$scope.asset.id,data);
        sts.then(function (response){
            console.log("set mobileStreaming",$scope.properties.mobileStreaming);
        },function(res){

        });        
    }    
    $scope.$watch("posInterval",function(){
        console.log("posIntervalChanged",$scope.posIntervalChanged);
        $scope.posIntervalChanged = true;
    });
    $scope.$watch("phone.number",function(){
        console.log("phone number changed:",$scope.phone.number);
        $scope.phone.numChanged = true;
    });    
    $scope.putWebTheme = function(){
        console.log("put web theme",$scope.option.wTheme);
        themeService.setTheme($scope.option.wTheme);
       
        if($scope.asset){
        var data =  [{"properties":[{"value":$scope.option.wTheme.code,
                        "typePropertyIdentifier": "dfc6abd0-857f-4aa4-ae50-42e41604bf0e",
                        "propertyTypeIdentifier": "45e78f1b-6f20-49c2-bed6-9ce155497f5e"}]}];
       
        smarttrackerService.authPut(smarttrackerService.getCustomerId()+"/asset/"+$scope.asset.id,data).then(function (response){   
            console.log(" save de web theme code:",$scope.option.wTheme.code);
        },function(res){
        });
       }        
    };
    $scope.putPhone= function(){
        if($scope.asset){
        var data =  [{"properties":[{"value":$scope.phone.number,"typePropertyIdentifier": "40f06fad-4267-4381-8792-5774d57ec6c8","propertyTypeIdentifier": "0b97a726-96c6-4410-b2d9-6792a439fafa"}]}];
        var sts = smarttrackerService.authPut(smarttrackerService.getCustomerId()+"/asset/"+$scope.asset.id,data);
        sts.then(function (response){
            $scope.phone.numChanged =false;

        },function(res){
    
        });
       }
    };
    $scope.posIntervalChanged =true;
    $scope.putposInterval= function(){


        
        if($scope.asset){
        var data =  [{"properties":[{"value":$scope.posInterval*60,"typePropertyIdentifier": "cd04e963-ac7e-4d4f-8108-547861f26e71","propertyTypeIdentifier": "de555066-6ffb-43f7-8ea7-ea13d0a6b550"}]}];
        var sts = smarttrackerService.authPut(smarttrackerService.getCustomerId()+"/asset/"+$scope.asset.id,data);
        sts.then(function (response){
            $scope.posIntervalChanged =false;
        },function(res){
        });
       }
    };    
    $scope.$watch("option.wTheme",function(){
        console.log("option.wTheme",$scope.option.wTheme);
        $scope.putWebTheme();
    });

    
    //-----------------  end  -----------------
    $scope.availableCustomers = smarttrackerService.getAvailableCustomers();
    $scope.availableProviders = smarttrackerService.getAvailableProviders();

    $scope.availableLanguages = [{code: 'en', label: "English"}, {code: 'no', label: "Norsk"},{code:'de',label:"Deutsch"}];
    
    $scope.availableZones = [{code: 'London', label: "Europe/London"}, {code: 'Oslo', label: "Europe/Oslo"},{code:'Berlin',label:"Europe/Berlin"}];

    $scope.availableMapProviders = mapService.getAvailableLayers();
    $scope.availableNavs = [{label:"calendar"},{label:"Personalize"},{label:"Monitor"}];
    $scope.getCurrentCustomerId = function() {
        return smarttrackerService.getCustomerId();
    }
    $scope.getCurrentCustomerName = function() {
        if (smarttrackerService.getCustomerId()) {
            for (var n = 0; n < $scope.availableCustomers.length; n++) {
                if ($scope.availableCustomers[n].id === smarttrackerService.getCustomerId()) {
                    return $scope.availableCustomers[n].name;
                }
            }
            return null;
        } else {
            return null;
        }
    }
    $scope.selectedZone = $scope.availableZones[0];
    $scope.$watch("selectedZone", function() {
        if($scope.selectedZone.code === "London"){
            angularMomentConfig.timezone  = "Europe/London";
        }else if($scope.selectedZone.code === "Oslo"){
            angularMomentConfig.timezone = "Europe/Oslo";
        }else if ($scope.selectedzone.code === "Berlin"){
            angularMomentConfig.timezone = "Europe/Berlin";
        }
        console.log(angularMomentConfig.timezone);
    });
    $scope.selectedNav = $scope.availableNavs[0];
//    $scope.$watch("selectedNav",function (){
//        if($scope.selectedNav.label ===  $scope.availableNavs[0].label){
//            $state.go("secure.content.asset.calendar", {
//                id: asset.id
//            });
//        }else if ($scope.selectedNav.label ===  $scope.availableNavs[1].label){
//            $state.go("secure.content.personalize", {
//                id: asset.id
//            });
//        }else if ($scope.selectedNav.label ===  $scope.availableNavs[2].label){
//            $state.go("secure.content.asset", {
//                id: asset.id
//            });
//        }
//    });
    $scope.getCurrentProviderId = function() {
        return smarttrackerService.getProviderId();
    }
        
    $scope.getCurrentProviderName = function() {
        if (smarttrackerService.getProviderId()) {
            for (var n = 0; n < $scope.availableProviders.length; n++) {
                if ($scope.availableProviders[n].id === smarttrackerService.getProviderId()) {
                    return $scope.availableProviders[n].name;
                }
            }
            return null;
        } else {
            return null;
        }
    }
	

    $scope.chooseCustomer = function(customerId) {
        smarttrackerService.changeCustomer(customerId);
    }
    $scope.chooseProvider = function(providerId) {
        smarttrackerService.changeProvider(providerId);
    }
    $scope.putLanguage = function(languageCode){
        var data = [{"properties":[{"value":languageCode,
                        "typePropertyIdentifier": "82ed4071-0e3d-48f0-88a1-815f2ccee57f",
                        "propertyTypeIdentifier": "a1f3783d-fa4a-4a34-a46a-28f8a445dece"}]}];

        var sts = smarttrackerService.authPut(smarttrackerService.getCustomerId()+"/asset/"+$scope.asset.id,data);
        sts.then(function (response){

        },function(res){
  
        });        
    };
    $scope.$watch("selectedLanguage", function() {
        if($scope.selectedLanguage){
        smarttrackerService.language($scope.selectedLanguage.code);
        $scope.learn.language=$scope.selectedLanguage.code;
        $scope.putLanguage($scope.selectedLanguage.code);
        console.log("saved language",$scope.selectedLanguage);
        console.log("timestampFormatted",$scope.asset.lastValidPosition);
        angularMomentConfig.language = $scope.selectedLanguage.code;
    }
        if($scope.selectedLanguage && $scope.selectedLanguage.code ==="no"){     
            angular.forEach($scope.ftheme,function(value){
                value.language=value.no;
            });
        $scope.learn.query = [{value:"1",name:"Antall avvik fra rute"},{value:"2",name: "Reisetid"}];
     
            $scope.learn.window=[{value:"d",name:"Siden dagen før"},
                {value:"w",name:"Siden forrige uke"},
                {value:"m",name:"Siden forrige måned"}];
        }
    if($scope.selectedLanguage && $scope.selectedLanguage.code ==="de"){
            angular.forEach($scope.ftheme,function(value){
                value.language=value.de;
            });    
        $scope.learn.query =[{value:"1",name:"Anzahl der unerwünschten Ereignisse"},{value:"2",name: "Reisezeit"}];
     
            $scope.learn.window=[{value:"d",name:"Seit gestern"},
                {value:"w",name:"Seit letzter Woche"},
                {value:"m",name:"Seit letztem Monat"}];            
    }
    if($scope.selectedLanguage && $scope.selectedLanguage.code ==="en")     {
            angular.forEach($scope.ftheme,function(value){
                value.language=value.en;
            }); 
    $scope.learn.query=[{value:"1",name:"Number of Undesirable Events"},{value:"2",name: "Journey Time"}];
           

       $scope.learn.window=[{value:"d",name:"Since yesterday"},{value:"w",name:"Since last week"},{value:"m",name:"Since last month"}];  
   }
    });
    var username="";
    
    smarttrackerService.isLoggedInDelayed().then(function() {
        console.log("get smarttracker server data",smarttrackerService.getLoggedInUser().user.username);
        $scope.fetchRoute();
        $scope.learn.user = smarttrackerService.getLoggedInUser().user.username;
       
        smarttrackerService.authGet(smarttrackerService.getCustomerId() + '/asset/' + $stateParams.id + '?select=*').then(function(response) {
            $scope.asset = response.data.result[0];
            
            if ($scope.asset) {
                contentCacheService.put("asset", $scope.asset.id, $scope.asset);
            }
            username = $scope.asset.id;
                         
            if($scope.asset) {
            	
            for(var i = 0;i<$scope.asset.properties.length;i++){
                console.log("smart tracker property:",$scope.asset.properties[i]);
                if($scope.asset.properties[i].name === "theme"){
                    if( $scope.asset.properties[i].value === "pos"){
                        $scope.option.sTheme = $scope.ftheme[1];
                    } else if($scope.asset.properties[i].value === "hc"){
                        $scope.option.sTheme = $scope.ftheme[0];
                    }
                }
                if($scope.asset.properties[i].name === "phone")                
                    $scope.phone.number = $scope.asset.properties[i].value;
                if($scope.asset.properties[i].name === "language"){
                    smarttrackerService.language($scope.asset.properties[i].value );
                    angular.forEach($scope.availableLanguages,function(value){
                        if(value.code === $scope.asset.properties[i].value){
                            $scope.selectedLanguage = value;
                        }
                    })
    if($scope.selectedLanguage.code ==="no")                
        $scope.learn = {
            user:smarttrackerService.getLoggedInUser().user.username,
            query:[{value:"1",name:"Antall avvik fra rute"},{value:"2",name: "Reisetid"}],
            window:[{value:"d",name:"Siden dagen før"},
                {value:"w",name:"Siden forrige uke"},
                {value:"m",name:"Siden forrige måned"}]
        };
    if($scope.selectedLanguage.code ==="de")     
        $scope.learn = {
            user:smarttrackerService.getLoggedInUser().user.username,
            query:[{value:"1",name:"Anzahl der unerwünschten Ereignisse"},{value:"2",name: "Reisezeit"}],
            window:[{value:"d",name:"Seit gestern"},
                {value:"w",name:"Seit letzter Woche"},
                {value:"m",name:"Seit letztem Monat"}]
        };
                }                
                if($scope.asset.properties[i].name === "webTheme"){
                   console.log("web theme",$scope.asset.properties[i].name);
                    if( $scope.asset.properties[i].value === ""){
                        
                        $scope.option.wTheme = themeService.setTheme("Poseidon");
                    } else {
                        $scope.option.wTheme = themeService.setTheme($scope.asset.properties[i].value);
                    }
                }
                if($scope.asset.properties[i].name === "choosenMap"){
                    //put selected map
                }
                if($scope.asset.properties[i].name === "alarmInsistent"){
                    //boolean ("true"/"false"), default is "false". 
                    //Insistent alarms - whether the calendar event alarms on the phone should 
                    //sound constantly until ackonwledged, or just occasionally.
                    console.log("get alarmInsistent",$scope.asset.properties[i].value);
                    $scope.properties.alarmInsistent = $scope.asset.properties[i].value === "true"?true:false;
                }                
                if($scope.asset.properties[i].name === "alarmOnStart"){
                    //boolean ("true"/"false"), default is "true". Whether there should be an alarm on the event start time 
                    //(otherwise just on alarms set in the web calendar).
                    console.log("get alarmOnStart",$scope.asset.properties[i].value);
                    $scope.properties.alarmOnStart = $scope.asset.properties[i].value=== "true"?true:false;
                }   
                if($scope.asset.properties[i].name === "mobileStreaming"){
                    //boolean ("true"/"false"), default is "true". 
                    //Whether to stream YouTube video on mobile network connection (otherwise just WiFi).
                    console.log("get mobileStreaming",$scope.asset.properties[i].value);
                    $scope.properties.mobileStreaming = $scope.asset.properties[i].value=== "true"?true:false;
                }                 
                if($scope.asset.properties[i].name === "posInterval"){
                    //Numerical, default is 600. Tracking interval - how often to get a position when not in navigation, in seconds.
                    console.log("posInterval",$scope.asset.properties[i].value);
                    $scope.posInterval = parseInt($scope.asset.properties[i].value/60);
                }   
                else if($scope.asset.properties[i].name === "weatherMesCold" || 
                		$scope.asset.properties[i].name === "weatherMesHot" ||
                		$scope.asset.properties[i].name === "weatherMesRain" ||
                		$scope.asset.properties[i].name === "weatherMesRainCold") {
                	$scope.weatherData.push($scope.asset.properties[i]);
                	console.log("asset");
                	console.log($scope.asset.properties);
                }
            };
        }
        });    
        
        for (var n = 0; n < $scope.availableLanguages.length; n++) {
            if ($scope.availableLanguages[n].code === smarttrackerService.language()) {
                $scope.selectedLanguage = $scope.availableLanguages[n];
                angularMomentConfig.language = $scope.selectedLanguage.code;
            }
        }
        
        console.log("choosen layer",mapService.chosenLayer());
        $scope.selectedMapProvider = $scope.availableMapProviders[mapService.chosenLayer()];



        if(smarttrackerService.language() === "en"){
            $scope.ftheme[0].language = $scope.ftheme[0].en;
            $scope.learn.language="en";
//            angularLoad.loadScript('http://code.angularjs.org/1.0.8/i18n/angular-locale_en.js').then(function(){}).catch(function(){})            
            
        } else if (smarttrackerService.language() ==="de"){
            $scope.learn.language="de";
            $scope.ftheme[0].language = $scope.ftheme[0].de;
//            angularLoad.loadScript('http://code.angularjs.org/1.0.8/i18n/angular-locale_de.js').then(function(){}).catch(function(){})                 
        }else if (smarttrackerService.language() ==="no"){
            $scope.learn.language="no";
            $scope.ftheme[0].language = $scope.ftheme[0].no;
//            angularLoad.loadScript('http://code.angularjs.org/1.0.8/i18n/angular-locale_no.js').then(function(){}).catch(function(){})     
        }

      

        
    });
    var username = $stateParams.id;
    console.log("id is: " + username);

    console.log("here we go");
    $scope.sentCommands = null;
    $scope.markers = {};
    $scope.paths = {};
    $scope.mapData = {
            center : {
                    lat : 0,
                    lng : 0,
        zoom : 1            
            }
    };
    $scope.data = "fething";
    $scope.fetchData = function() {
    $http.get(stwoGlobal.fileServerURL + 'listRoutes.php?username='+username).
        success(function(data, status, headers, config) {
              $scope.data = data.result;
              console.log(data);
              console.log("Checking for data");
          });
      }
$scope.fetchData();
 $scope.$watch('files', function () {
        $scope.upload($scope.files);
    });
    $scope.log = '';
$scope.uploadInProgress = false;
$scope.uploadProgress = 0;

$scope.saveWeatherData = function() {
	console.info("Saving Weather Data");
	$scope.wdWorking = true;
	smarttrackerService.authPut(smarttrackerService.getCustomerId() + "/asset/" + $scope.asset.id, {"properties":$scope.weatherData}).then(function (response){
		$scope.wdWorking = false;
		console.info("Weather Data Saved");
	});
}

$scope.deleteFile = function(filename) {
    // $http.post("http://localhost/deleteFile.php", {'username':username, 'filename':filename}
    //     , {headers: {'Content-Type': 'application/json', "Access-Control-Allow-Origin":"*"}}).success(function (response, status, headers, config) {
    //             $scope.log=response;
    // });
console.log("username:" + username + " filename: " + filename);
    $http.post(stwoGlobal.fileServerURL + "deleteFile.php", {'username':username, 'filename':filename}).success(function (response){
        $scope.feedback = response;
        console.log("feedback",response);
        $scope.fetchData();
    }).
    error(function(response) {
        $scope.errorMsg = response;
    });
}
 $scope.fetchRoute = function (){
        $http.get("https://ri.smarttracker.no/files/resource.php?type=route",{
                        headers: {
                "X-Auth-Token": smarttrackerService.getToken()
            }
        }).then(function (response) {
            console.log("fetch route",response);

            $scope.routes = [];
            for (var r =0;r<response.data.length;r++) {
                $http.get("https://ri.smarttracker.no/files/resource.php?type=route&resourceID="+response.data[r].resourceID,{
                        headers: {
                "X-Auth-Token": smarttrackerService.getToken()
                    }
                }).then(function(res){
                    console.log(res);
                    var fn = res.data.meta.title;
                    $scope.routes.push(fn);                    
                });

            }
        });
 }
 $scope.upload = function (files) {
        if (files && files.length) {
            $scope.uploadInProgress = true;
            for (var i = 0; i < files.length; i++) {
                var file = files[i];
                $scope.uploadInProgress = true;
                Upload.upload({
                    url: stwoGlobal.fileServerURL+ 'upload.php',
                    fields: {
                        'username': username
                    },
                    file: file
                }).progress(function (evt) {
                    var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
                    $scope.uploadProgress = progressPercentage;
                    $scope.log = 'progress: ' + progressPercentage + '% ' +
                                evt.config.file.name + '\n' + $scope.log;
                }).success(function (data, status, headers, config) {
                    $scope.log = 'file ' + config.file.name + 'uploaded. Response: ' + JSON.stringify(data) + '\n' + $scope.log;
                   // $scope.$apply();
                    $scope.feedback= "upload status:" +status;
                    $scope.fetchData();
                    console.log("data: " ) ;
                    if(data.indexOf("to big") > 0) {
                        $scope.errorFeedback = "Upload failed. Check file size";
                    } else  $scope.errorFeedback = "";
                    $scope.uploadInProgress = false;
                    $scope.uploadProgress = 0;
                });
            }
        }
    };
});