angular.module('stwo.shopping', ['ui.sortable', 'angularLoad', 'ngTagsInput', 'stwo.core', 'stwo.glue', 'angularMoment', 'ui.calendar', 'ui.bootstrap', 'ui.bootstrap.datepicker', 'ui.bootstrap.timepicker', 'angular-google-gapi', 'ngAudio', 'ngVideo', 'ngFileUpload']).config(function ($provide, $stateProvider, $urlRouterProvider, moduleStoreProvider, $translateProvider) {
    moduleStoreProvider.registerModule({
        name: "shopping",
        links: [{
                name: "SHOPPING.TITLE",
                category: "navigation",
                icon: "fa fa-shopping-cart",
                sref: "secure.content.asset.shopping",
                sort: 5,
                color: "success"
            }]
    });
    $stateProvider.state("secure.content.shopping", {
        url: "/shopping:id",
        templateUrl: "modules/shopping/shopping.html",
        controller: "ShoppingController"
    });

    $stateProvider.state("secure.content.asset.shopping", {
        url: "/asset-shopping",
        templateUrl: "aktive-spor/dashboard/dashboard.html",
        controller: "ListShoppingController"
    });
}).factory("fetchData", function (smarttrackerService) {
    var imageList = [];
    var f = {};
    var productListID = null;
    var fileServerURL = "https://ri.smarttracker.no/files/resource.php";
    /*
     * data, the updated infomation of the images, names, prices
     * callback  callback function
     */
    f.fileServerURL = function () {
        return fileServerURL;
    };
    f.getProductListID = function () {
        console.log(productListID);
        return productListID;
    }

    f.fetchData = function (id, callback) {
        var showAllProducts = {"assetID": id, "type": "products"};
        console.log("fetch data", id, "type:products");
        smarttrackerService.authGetFile(showAllProducts, true).then(function (response) {
            if (response.data.length === 0) {
                var productsData = [];
                var fd = new FormData();
                fd.append("type", "products");
                fd.append("assetID", id);
                var blob = new Blob([JSON.stringify({"assetID": id, "products": productsData}, null, 2)], {type: 'application/json'});
                fd.append("file", blob);

                smarttrackerService.authPostFile(fd, true).then(function (repons) {
                    console.log(repons);
                    productListID = repons.data.resourceID.toString();
                    callback(productListID);
                });
            } else {
                var getProducts = {"assetID": id, resourceID: response.data[0].resourceID, type: "products"};

                smarttrackerService.authGetFile(getProducts, true).then(function (success) {
                    productListID = response.data[0].resourceID.toString();
                    console.log("product list id", response.data[0].resourceID, "file", success.data);
                    if (success.data.products.length === 0) {
                        imageList = [];
                    } else
                        imageList = success.data.products;
                    console.log(success.data.products);
                    callback(productListID);
                });
            }
        })
    };

    f.getList = function () {
        console.log(imageList);
        return imageList;
    };
    f.deleteByID = function (id) {
        for (var i = 0; i < imageList.length; i++) {
            if (imageList[i].resourceID === id) {
                imageList.splice(i, 1);
            }
        }
    }
    f.updateList = function (item) {
        angular.forEach(imageList, function (value, index) {
            if (value.resourceID === item.resourceID) {
                imageList.splice(index, 1);
                imageList.push(item);
                return;
            }
        });
        if (imageList instanceof Array)
            imageList.push(item);
        else {
            imageList = new Array();
            imageList.push(item);
        }
        console.log(imageList);
    };
    return f;
});
angular.module('stwo.shopping').controller('ListShoppingController', function (fetchData, $scope, $controller, $state, notificationService, moduleStore) {
    $controller('BaseListContentController', {
        $scope: $scope
    });
    $scope.super({
        clazz: 'asset',
        downloadUrl: '/asset?select=name+tags+type+tracked+image+icon+lastValidPosition&sort=name&order=asc'
    });
    $scope.assetClicked = function (asset) {
        fetchData.fetchData(asset.id, function () {
            $state.go("secure.content.shopping", {
                id: asset.id
            });
        });
    }
    $scope.$watch("items.length", function () {
        if ($scope.items && $scope.items.length === 1) {
            console.log("go to shopping page", $scope.items[0].id);
            fetchData.fetchData($scope.items[0].id, function () {
                console.log("call back ", $scope.items[0].id);
                $state.go("secure.content.shopping", {
                    id: $scope.items[0].id
                });
            });

        }
    });
})
angular.module('stwo.shopping').controller('ShoppingController', function (image,fetchData, angularLoad, demoMode, Upload, smarttrackerService, themeService, contentCacheService, $rootScope, $state, $scope, $modal, GAuth, GApi, $controller, $stateParams, $compile, uiCalendarConfig, ef, angularMomentConfig, $http, $timeout, $document) {
    themeService.loadWebTheme(themeService.chosenTheme());
    if (fetchData.getProductListID() === null || !fetchData.getProductListID()) {
        $state.go("secure.content.asset.shopping");
    }
    $scope.isMobile = function(){
        return smarttrackerService.mobileCheck();
    }
    $scope.DELETED = false;
    $scope.SUBMITTED = false;
    $scope.ERROR = false;
    $scope.currency= function (){
                if(smarttrackerService.language() ==='en'){
                    return "£";
                } else if (smarttrackerService.language() === "no"){
                    return "kr";
                } else if (smarttrackerService.language() === "de"){
                    return "euro";
                }
    }
    $scope.product = {name: "", price: "", currency:$scope.currency(),files: null,resourceID:"", height: 0, width: 0};
    if ($scope.imageList && $scope.imageList.length > 0) {
        $scope.imageList.splice(0, $scope.imageList.length);
    }
    $scope.imageList = [];

    angular.forEach(fetchData.getList(), function (t) {
        var data = {resourceID: t.resourceID, price: t.price, currency:t.currency,height: t.height, width: t.width, name: t.name, selected: false,number:1};
        $scope.imageList.push(data);
        console.log(data);

    });
    console.log("image list", $scope.imageList);
    $scope.priceChange = function(){
        if($scope.product.currency==="pence" && $scope.product.price >=100){
            $scope.product.currency="£";
            $scope.product.price = parseFloat($scope.product.price/100);
        }
            
    };
    $scope.costChange = function(){
        if($scope.productSelected.currency==="pence" && $scope.extraCash >=100){
            $scope.productSelected.currency="£";
            $scope.extraCash = parseFloat($scope.extraCash/100);
        } else if($scope.productSelected.currency === "£" && $scope.extraCash <1){
            $scope.extraCash = $scope.extraCash*100;
            $scope.productSelected.currency = "pence";
        }
            
    }    
    $scope.$watch("extraCash",function(){
         if($scope.productSelected.currency==="pence" && $scope.extraCash >=100){
            $scope.productSelected.currency="£";
            $scope.extraCash = parseFloat($scope.extraCash/100);
        } else if($scope.productSelected.currency === "£" && $scope.extraCash <1){
            $scope.extraCash = $scope.extraCash*100;
            $scope.productSelected.currency = "pence";
        }       
    });
    $scope.re_edit = false;
    $scope.submitNewProduct = function () {
        // if the product does not have name, price, file, don't upload
        console.log("check before submit",$scope.product.name,$scope.product.price,$scope.product.files,$scope.product.resourceID,
        $scope.product.files || $scope.product.resourceID,
        !$scope.product.name ||!$scope.product.price || !($scope.product.files || $scope.product.resourceID));
        if (!$scope.product.name ||!$scope.product.price || !($scope.product.files || $scope.product.resourceID !=="")) {
            $scope.ERROR = true;
            $timeout(function () {
                $scope.ERROR = false;
            }, 3000);
            return;
        }
         if ($scope.product.files && $scope.product.name && $scope.product.price) {
            var fd = new FormData();
            fd.append("type", "images");
            fd.append("assetID", $stateParams.id);
            var file = $scope.product.files;
            fd.append("file", file);

            // upload the image file
            smarttrackerService.authPostFile(fd, true).then(function (response) {
                var updateProductsList = new FormData();
                updateProductsList.append("assetID", $stateParams.id);

                var item = {"resourceID": response.data.resourceID, "name": $scope.product.name
                    , "price": $scope.product.price,"currency":$scope.product.currency, "height": $scope.product.height, "width": $scope.product.width};
                var _list = angular.copy(fetchData.getList());
                _list.push(item);
                var produtsListFile = {products: _list, assetID: $stateParams.id};

                updateProductsList.append("file", new Blob([JSON.stringify(produtsListFile)], {type: 'application/json'}));
                updateProductsList.append("resourceID", fetchData.getProductListID());

                console.log("upload file and the response id ", response.data.resourceID, updateProductsList);

                // upload image file success, then update the all product informmation file
                smarttrackerService.authPostFile(updateProductsList).then(function (updateSuccess) {
                    _list = null;
                    console.log("udpate porduct list success", updateSuccess);
                    $scope.product.name = "";
                    $scope.product.price = 0;
                    $scope.product.files = null;
                    document.getElementById("imagePreview").innerHTML ="<img src='images/NoImage.jpg' style='margin-left:20px' width='100' height='100' />";
                    
                    fetchData.updateList(item);
                    if (item.selected) {
                        item.selected = undefined;
                    }
                    $scope.imageList.push({name:item.name,price: item.price,currency:item.currency, height: item.height, width: item.width, resourceID: item.resourceID, selected: false});
                    $scope.SUBMITTED = true;
                    $timeout(function () {
                        $scope.SUBMITTED = false;
                    }, 2000);
                });
            });
        } else if($scope.product.resourceID && $scope.product.name && $scope.product.price){
            console.log("re edit");
            $scope.re_edit=false;
            var updateProductsList = new FormData();
                updateProductsList.append("assetID", $stateParams.id);

                var item = {"resourceID": $scope.product.resourceID, "name": $scope.product.name
                    , "price": $scope.product.price,"currency":$scope.product.currency, "height": $scope.product.height, "width": $scope.product.width};
                var _list = angular.copy(fetchData.getList());
                _list.push(item);
                var produtsListFile = {products: _list, assetID: $stateParams.id};

                updateProductsList.append("file", new Blob([JSON.stringify(produtsListFile)], {type: 'application/json'}));
                updateProductsList.append("resourceID", fetchData.getProductListID());
                smarttrackerService.authPostFile(updateProductsList).then(function (updateSuccess) {
                    _list = null;
                    console.log("udpate porduct list success", updateSuccess);
                    $scope.product.name = "";
                    $scope.product.price = 0;
                    $scope.product.files = null;
                    document.getElementById("imagePreview").innerHTML ="<img src='images/NoImage.jpg' style='margin-left:20px' width='100' height='100' />";
                    
                    fetchData.updateList(item);
                    if (item.selected) {
                        item.selected = undefined;
                    }
                    $scope.imageList.push({name:item.name,price: item.price,currency:item.currency, height: item.height, width: item.width, resourceID: item.resourceID, selected: false});
                    $scope.SUBMITTED = true;
                    $timeout(function () {
                        $scope.SUBMITTED = false;
                    }, 2000);
                });            
        } 
    };
    var handleFile = function (resourceID) {
        if(resourceID === undefined){
        var imagePreview = document.getElementById("imagePreview");
        imagePreview.innerHTML = "";
        var dataURLReader = new FileReader();
        dataURLReader.onload = function (event) {
            var dataURL = event.target.result;
            var image = new Image();
            image.src = dataURL;
            image.onload = function () {
                console.log("Image width: " + this.width);
                console.log("Image height: " + this.height);
                $scope.product.width = this.width;
                $scope.product.height = this.height;
                if (this.width < this.height) {
                    this.width = (this.width / this.height) * 100;

                    this.height = 100;
                } else {
                    this.width = (this.height / this.width) * 100;
                    this.width = 100;
                }
                imagePreview.appendChild(this);
            };
        };
        dataURLReader.readAsDataURL($scope.product.files);
    } else if(resourceID !== undefined){
                var imagePreview = document.getElementById("imagePreview");
        imagePreview.innerHTML ="<img src='"+stwoGlobal.fileBaseUrl+"/files/resource.php?resourceID="+resourceID+"' style='margin-left:20px' width='100' height='100' />";
                    
    }
    };
    $scope.defaultImage = true;
    $scope.fileDropped = function (files,resourceID) {
        if(files !== undefined){
        console.log("files", files);
        console.log($scope.selectedLanguage);
        $scope.product.files = files;
        if (files) {
            $scope.defaultImage = false;
            handleFile();
        }
    } else if(resourceID !== undefined){
        console.log("editing product item",resourceID);
        $scope.product.resourceID = resourceID;
        handleFile(resourceID);
    }

    };
    $scope.LIST_CREATED = false;
    $scope.changed= function(){
        if($scope.currency === "pence"){
            return true;
        } else return false;
    }
    $scope.currency="";
//    $scope.showPence = function(price){
//
//        if(smarttrackerService.language() !=='en'){
//            return false;
//        } else if(parseFloat(price)<1){
//            return true;
//        }
//       
//    };
    $scope.productSelected = {name: "", totalCost: 0,currency:"", list: []};

    $scope.$watch("imageList", function () {
       
        var total = 0;
        var count =0;
        angular.forEach($scope.imageList, function (item) {
            if (item.selected) {
                count =count +1;
                if(item.currency === "pence"){
                    total = total + parseFloat(item.price/100)*parseInt(item.number);
           
                } else{
                    
                    total = total + parseFloat(item.price)*parseInt(item.number);
              
            }
            }
        });
        $scope.productSelected.totalCost = parseFloat(total.toFixed(2));
        if($scope.productSelected.totalCost <1 && smarttrackerService.language() ==="en"){
            $scope.productSelected.currency="pence";
            $scope.productSelected.totalCost = $scope.productSelected.totalCost*100;
        } else if ($scope.productSelected.totalCost >=1 && smarttrackerService.language() ==="en"){
            $scope.productSelected.currency="£";
           
        }
        if(count === 1){
            $scope.edit_item = true;
        } else if(count !== 1){
            $scope.edit_item = false;
        }
        console.log("watch imageList",$scope.edit_item);
    },true);
    $scope.addRemainder = function () {
        $state.go("secure.content.calendar", {
            id: $stateParams.id,
            money: $scope.extraCash,
            currency:$scope.productSelected.currency
        });
    };
    $scope.addWithExtra = function () {
        $state.go("secure.content.calendar", {
            id: $stateParams.id,
            money: $scope.extraCash,
            currency:$scope.productSelected.currency
        });
    };
    $scope.currency = "fa fa-gbp";
    $scope.setLang = function () {
        $scope.lang = smarttrackerService.language();
        if (smarttrackerService.language() === "en") {

            $scope.currency = "fa fa-gbp";
        } else if (smarttrackerService.language() === "no") {
            $scope.currency = "fa fa-kroner";


        } else if (smarttrackerService.language() === "de") {
            $scope.currency = "fa fa-eur";


        }
    };
    $scope.SHOPPING_LIST=true;
    $scope.fetchShoppingList =function (){
        var showList = {"assetID": $stateParams.id, "type": "list"};
        console.log("fetch data", $stateParams.id, "type:list");
        smarttrackerService.authGetFile(showList, true).then(function (response) {
            if (response.data.length === 0) {
             $scope.SHOPPING_LIST=false;
            } else {
                var getShoppingList = {"assetID": $stateParams.id, resourceID: response.data[0].resourceID, type: "list"};

                smarttrackerService.authGetFile(getShoppingList, true).then(function (success) {
                    productListID = response.data[0].resourceID.toString();
                    console.log("shopping list id", response.data[0].resourceID, "file", success.data);
                    $scope.oldShoppingList = {"name":success.data.listName,"list":success.data.list,"totalcost":success.data.cost,"currency":success.data.currency};        
                    console.log("old shopping list",$scope.oldShoppingList);
                });
            }
        })        
    }
    $scope.saveList = function () {
        $scope.extraCash = $scope.productSelected.totalCost;
        $scope.productSelected.list.splice(0,$scope.productSelected.list.length);
        angular.forEach($scope.imageList, function (value) {
            if (value.selected) {
                var _temp = {name: value.name, price: value.price, currency:value.currency,number:value.number,resourceID: value.resourceID, height: value.height, width: value.width};
                $scope.productSelected.list.push(_temp);
            }
        });
        var listData = {"cost": $scope.productSelected.totalCost, "currency":$scope.productSelected.currency,"list": $scope.productSelected.list, "listName": $scope.productSelected.name,
            "assetID": $stateParams.id};

        //handle multiple list, maybe the phone side app can just use the latest one or get the one with wantted name.
        smarttrackerService.authGetFile({"assetID": $stateParams.id, "type": "list"}).then(function (response) {
            var uploadForm = new FormData();
            uploadForm.append("type", "list");
            uploadForm.append("assetID", $stateParams.id);
            var uploadData = new File([JSON.stringify(listData)], "list.json");
            uploadForm.append("file", uploadData);

            if (response.data.length === 0) {
                smarttrackerService.authPostFile(uploadForm).then(function (response1) {
                    //popup dialog

                    $scope.SUBMITLIST = true;
                    console.log("upload list successfully.");
                });
            } else {
                uploadForm.append("resourceID", response.data[0].resourceID);
                smarttrackerService.authPostFile(uploadForm).then(function (response1) {
                    //popup dialog

                    $scope.SUBMITLIST = true;
                    $scope.LIST_CREATED = true;
                    console.log("upload list successfully.");
                        $timeout(function () {
                            $scope.LIST_CREATED = false;
                        }, 10000);
                });

            }
            $scope.fetchShoppingList();
        });


    }
    $scope.tab = 2;
    $scope.setTab = function (tabId) {
        if ($scope.tab !== tabId)
            $scope.productSelected.totalCost = 0;
        angular.forEach($scope.imageList, function (product) {
            product.selected = false;
        });
        $scope.tab = tabId;
    };
    $scope.isSet = function (tabId) {
        if ($scope.tab === tabId) {
            return true;
        }
        return false;
    };

    $scope.SUBMITLIST = false;
    $scope.extraCash = $scope.productSelected.totalCost;
    $scope.edit_item=false;
    // problems with deleting multiple items at the same time.


    $scope.deleteProduct = function (edit) {
        var deleteIDs = [];
        var deleteArray = [];
        var newArray = [];

        angular.forEach($scope.imageList, function (value) {
            if (value.selected) {
                deleteIDs.push(value.resourceID);
                deleteArray.push(value);
            } else
                newArray.push(value);
        });
        var a2 = 1;            
        if(edit === undefined)
        for (var i = 0; i < deleteIDs.length; i++) {
            console.log("to be deleted", deleteIDs[i]);
            var parameters = {assetID: $stateParams.id, resourceID: deleteIDs[i]};

            smarttrackerService.authDeleteFile(parameters).then(function (response) {
                console.log(a2, deleteIDs.length);
                if (a2 === deleteIDs.length) {
                    var updateProductsList = new FormData();
                    updateProductsList.append("assetID", $stateParams.id);


                    var _list = angular.copy(fetchData.getList());
                    angular.forEach(deleteIDs, function (delID) {
                        for (var i = 0; i < _list.length; i++) {
                            if (_list[i].resourceID === delID) {
                                _list.splice(i, 1);
                                return;
                            }
                        }
                        ;
                    });

                    var produtsListFile = {products: _list, assetID: $stateParams.id};

                    updateProductsList.append("file", new Blob([JSON.stringify(produtsListFile)], {type: 'application/json'}));
                    updateProductsList.append("resourceID", fetchData.getProductListID());

                    smarttrackerService.authPostFile(updateProductsList).then(function (success) {
                        _list = null;

                        angular.forEach(deleteIDs, function (id) {
                            fetchData.deleteByID(id);
                        });
                        $scope.imageList = newArray;
                        for (var j = 0; j < deleteIDs.length; j++) {
                            console.log("delete procut from list according to id", deleteIDs[j]);
                            //                            delete image list on the view
                            console.log($document.find("img#" + deleteIDs[j]));
                            angular.element($document.find("img#" + deleteIDs[j])[0]).parent().parent().remove();
                        }

                        $scope.DELETED = true;
                        $timeout(function () {
                            $scope.DELETED = false;
                        }, 2000);
                    });
                }
                a2 = a2 + 1;
            },function(){
                 console.log(a2, deleteIDs.length);
                if (a2 === deleteIDs.length) {
                    var updateProductsList = new FormData();
                    updateProductsList.append("assetID", $stateParams.id);


                    var _list = angular.copy(fetchData.getList());
                    angular.forEach(deleteIDs, function (delID) {
                        for (var i = 0; i < _list.length; i++) {
                            if (_list[i].resourceID === delID) {
                                _list.splice(i, 1);
                                return;
                            }
                        }
                        ;
                    });

                    var produtsListFile = {products: _list, assetID: $stateParams.id};

                    updateProductsList.append("file", new Blob([JSON.stringify(produtsListFile)], {type: 'application/json'}));
                    updateProductsList.append("resourceID", fetchData.getProductListID());

                    smarttrackerService.authPostFile(updateProductsList).then(function (success) {
                        _list = null;

                        angular.forEach(deleteIDs, function (id) {
                            fetchData.deleteByID(id);
                        });
                        $scope.imageList = newArray;
                        for (var j = 0; j < deleteIDs.length; j++) {
                            console.log("delete procut from list according to id", deleteIDs[j]);
                            //                            delete image list on the view
                            console.log($document.find("img#" + deleteIDs[j]));
                            angular.element($document.find("img#" + deleteIDs[j])[0]).parent().parent().remove();
                        }

                        $scope.DELETED = true;
                        $timeout(function () {
                            $scope.DELETED = false;
                        }, 2000);
                    });
                }
                a2 = a2 + 1;              
            });
        };
        
        /**
         * 
         * edit the deleted item
         */
        if(edit !== undefined){
                    $scope.re_edit=true;
            console.log("edit item",deleteArray);
            $scope.product.name=deleteArray[0].name;
            $scope.product.price=deleteArray[0].price;
            $scope.product.currency = deleteArray[0].currency;
            $scope.product.height= deleteArray[0].height, 
            $scope.product.width= deleteArray[0].width;   
            $scope.product.resourceID =deleteArray[0].resourceID;
            $scope.fileDropped(undefined,deleteArray[0].resourceID);
            
         

  
            console.log("to be deleted", deleteIDs[0]);
            var parameters = {assetID: $stateParams.id, resourceID: deleteIDs[0]};

  
0
                if (1 === deleteIDs.length) {
                    var updateProductsList = new FormData();
                    updateProductsList.append("assetID", $stateParams.id);


                    var _list = angular.copy(fetchData.getList());
                    angular.forEach(deleteIDs, function (delID) {
                        for (var i = 0; i < _list.length; i++) {
                            if (_list[i].resourceID === delID) {
                                _list.splice(i, 1);
                                return;
                            }
                        }
                        ;
                    });

                    var produtsListFile = {products: _list, assetID: $stateParams.id};

                    updateProductsList.append("file", new Blob([JSON.stringify(produtsListFile)], {type: 'application/json'}));
                    updateProductsList.append("resourceID", fetchData.getProductListID());

                    smarttrackerService.authPostFile(updateProductsList).then(function (success) {
                        _list = null;

                        angular.forEach(deleteIDs, function (id) {
                            fetchData.deleteByID(id);
                        });
                        $scope.imageList = newArray;
                        for (var j = 0; j < deleteIDs.length; j++) {
                            console.log("delete procut from list according to id", deleteIDs[j]);
                            //                            delete image list on the view
                            console.log($document.find("img#" + deleteIDs[j]));
                            angular.element($document.find("img#" + deleteIDs[j])[0]).parent().parent().remove();
                        }

                        $scope.DELETED = true;
                        $timeout(function () {
                            $scope.DELETED = false;
                        }, 2000);
                    });
                }


         
            
        }
    };
    $scope.cancelList = function () {
        $scope.SUBMITLIST = false;
        $scope.LIST_CREATED = false;
    }
    $scope.mouseOver = function (id) {
//        angular.element("img#" + id).css("width", "100%");
//        angular.element("img#" + id).css("height", "100%");
    var height = 40;
    var width = 40;
        angular.forEach($scope.imageList,function(item){
            if(item.resourceID === id){
                height = item.height;
                width= item.width;
            }
                
        });
        while(Math.max(height,width)>500){
                        height=parseInt(height/1.2);
                        width = parseInt(width/1.2);
                        console.log("height",height,"width",width);
                    } 
        //https://ri.smarttracker.no/files/resource.php?resourceID=3a061082-c2c0-41be-92e8-6f94fc790f5d
        image.showtrail("https://ri.smarttracker.no/files/resource.php?resourceID="+id,"",width,height);
    };
    $scope.mouseLeave = function (id) {
        console.log("mouseLeave called", angular.element("img#" + id));
//        angular.forEach($scope.imageList, function (value) {
//            if (id === value.resourceID) {
//                angular.element("img#" + id).css("height", "").css("width", "");
//            }
//        });
        image.hidetrail();
    };
    $scope.remove_loading = function(){
        image.remove_loading();
    }
    $scope.clicked = function (id) {
        console.log("clicked product", id);
        var totalCost = 0;
        for (var i = 0; i < $scope.imageList.length; i++) {
            if ($scope.imageList[i].resourceID === id) {

                if (!$scope.imageList[i].selected) {
                    $scope.imageList[i].selected = true;
                    angular.element("img#" + id).css("border", "3px solid");
                } else {
                    $scope.imageList[i].selected = false;
                    angular.element("img#" + id).css("border", "0px solid");
                }
                console.log($scope.imageList, "id", $scope.imageList[i].resourceID, id, $scope.imageList[i].selected);
            }
        }
        ;
        for (var i = 0; i < $scope.imageList.length; i++) {
            console.log("id", $scope.imageList[i].resourceID, id);
            if ($scope.imageList[i].selected) {
                if($scope.imageList[i].currency==="pence"){
                    totalCost = totalCost + parseFloat($scope.imageList[i].price/100)*parseInt($scope.imageList[i].number);
                    
                } else
                    totalCost = totalCost + parseFloat($scope.imageList[i].price)*parseInt($scope.imageList[i].number);
                
                console.log("value", $scope.imageList[i], parseInt($scope.imageList[i].price)*parseInt($scope.imageList[i].number));
            }
        };
        $scope.productSelected.totalCost = parseFloat(totalCost.toFixed(2));
        if($scope.productSelected.currency==="£" && parseFloat($scope.productSelected.totalCost)<1){
            $scope.productSelected.currency = "pence";
            $scope.productSelected.totalCost = $scope.productSelected.totalCost*100;
        } else if($scope.productSelected.currency==="pence" && parseFloat($scope.productSelected.totalCost)>100){   
            $scope.productSelected.currency = "£";
            $scope.productSelected.totalCost = $scope.productSelected.totalCost/100;
        }
    }   
    $scope.selectedLanguage = {};
        smarttrackerService.isLoggedInDelayed().then(function() {
        smarttrackerService.authGet(smarttrackerService.getCustomerId() + '/asset/' + $stateParams.id + '?select=*').then(function(response) {
            $scope.asset = response.data.result[0];
            for(var i = 0;i<$scope.asset.properties.length;i++){
                if($scope.asset.properties[i].name === "language"){
                    
                    smarttrackerService.language($scope.asset.properties[i].value );
                    if( smarttrackerService.language() === "en"){
                        $scope.productSelected.currency ="£";
                            $scope.currencys = ["£","pence"];
                        $scope.product.currency = "£";
                    } else if(smarttrackerService.language() ==="no"){
                            $scope.currencys = ["kr"];
                        console.log("currence setting to no", $scope.productSelected.curency);
                        $scope.productSelected.currency ="kr";
                         $scope.product.currency = "kr";
                    } else if (smarttrackerService.language() ==="de"){
                            $scope.currencys = ["euro"];
                        $scope.productSelected.currency="euro";
                        $scope.product.currency = "euro";
                    }
                    
                }                


            };
            $scope.selectedLanguage.code =     smarttrackerService.language();                    

        });     
        $scope.fetchShoppingList();
        });
});
angular.module('stwo.shopping').factory("image", function (smarttrackerService) {
            var i = {};
            var offsetfrommouse = [15, 25]; //image x,y offsets from cursor position in pixels. Enter 0,0 for no offset
            var displayduration = 0; //duration in seconds image should remain visible. 0 for always.

            var defaultimageheight = 40;	// maximum image size.
            var defaultimagewidth = 40;	// maximum image size.

            var timer;

            var gettrailobj = function() {
                if (document.getElementById)
                    return document.getElementById("preview_div").style
            }

             var gettrailobjnostyle=function() {
                if (document.getElementById)
                    return document.getElementById("preview_div")
            }


            var truebody =function() {
                return (!window.opera && document.compatMode && document.compatMode != "BackCompat") ? document.documentElement : document.body
            }


            i.hidetrail =function() {
                gettrailobj().display = "none";
                document.onmousemove = ""
                gettrailobj().left = "-500px"
                clearTimeout(timer);
            }

            i.showtrail = function(imagename, title, width, height) {
                i = imagename
                t = title
                w = width
                h = height
                timer = setTimeout(function(){
                    show(imagename,title,width,height);
                }, 200);
            }
            var show =function(imagename, title, width, height) {

                var docwidth = document.all ? truebody().scrollLeft + truebody().clientWidth : pageXOffset + window.innerWidth - offsetfrommouse[0]
                var docheight = document.all ? Math.min(truebody().scrollHeight, truebody().clientHeight) : Math.min(window.innerHeight)

                if ((navigator.userAgent.indexOf("Konqueror") == -1 || navigator.userAgent.indexOf("Firefox") != -1 || (navigator.userAgent.indexOf("Opera") == -1 && navigator.appVersion.indexOf("MSIE") != -1)) && (docwidth > 650 && docheight > 500)) {
                    (width == 0) ? width = defaultimagewidth : '';
                    (height == 0) ? height = defaultimageheight : '';

                    width += 30
                    height += 55
                    defaultimageheight = height
                    defaultimagewidth = width
                    
                    
                    document.onmousemove = followmouse;


                    newHTML = '<div class="border_preview" style="border:0px;width:' + width + 'px;height:' + height + 'px">';
                    newHTML = newHTML + '<h2 class="title_h2">' + ' ' + title + '</h2>'

                    newHTML = newHTML + '<div class="preview_temp_load"><img style="height:'+height+'px;width:'+width+'px" ng-onload="remove_loading();" src="' + imagename + '" border="0"></div>';
                    newHTML = newHTML + '</div>';

                    if (navigator.userAgent.indexOf("MSIE") != -1 && navigator.userAgent.indexOf("Opera") == -1) {
                        newHTML = newHTML + '<iframe src="about:blank" scrolling="no" frameborder="0" width="' + width + '" height="' + height + '"></iframe>';
                    }
                    console.log("newhtml",newHTML);
                    gettrailobjnostyle().innerHTML = newHTML;
                    gettrailobj().display = "block";
                }
            }

            var followmouse =function(e) {

                var xcoord = offsetfrommouse[0]
                var ycoord = offsetfrommouse[1]

                var docwidth = document.all ? truebody().scrollLeft + truebody().clientWidth : pageXOffset + window.innerWidth - 15
                var docheight = document.all ? Math.min(truebody().scrollHeight, truebody().clientHeight) : Math.min(window.innerHeight)

                if (typeof e != "undefined") {
                    if (docwidth - e.pageX < defaultimagewidth + 2 * offsetfrommouse[0]) {
                        xcoord = e.pageX - xcoord - defaultimagewidth; // Move to the left side of the cursor
                    } else {
                        xcoord += e.pageX;
                    }
                    if (docheight - e.pageY < defaultimageheight + 2 * offsetfrommouse[1]) {
                        ycoord += e.pageY - Math.max(0, (2 * offsetfrommouse[1] + defaultimageheight + e.pageY - docheight - truebody().scrollTop));
                    } else {
                        ycoord += e.pageY;
                    }

                } else if (typeof window.event != "undefined") {
                    if (docwidth - event.clientX < defaultimagewidth + 2 * offsetfrommouse[0]) {
                        xcoord = event.clientX + truebody().scrollLeft - xcoord - defaultimagewidth; // Move to the left side of the cursor
                    } else {
                        xcoord += truebody().scrollLeft + event.clientX
                    }
                    if (docheight - event.clientY < (defaultimageheight + 2 * offsetfrommouse[1])) {
                        ycoord += event.clientY + truebody().scrollTop - Math.max(0, (2 * offsetfrommouse[1] + defaultimageheight + event.clientY - docheight));
                    } else {
                        ycoord += truebody().scrollTop + event.clientY;
                    }
                }
                gettrailobj().left = xcoord + "px"
                gettrailobj().top = ycoord + "px"

            }

            /* alt.js */

            var timerId = null
            var obj = new Array()

            var prepareShowAlt =function(event) {
                idd = this.id
                if (idd.search("title_") == 0) {
                    idd = idd.substring(6)
                    if ((typeof titles != "undefined") && (typeof titles[idd] != "undefined") && titles[idd].length > 0) {
                        text = titles[idd]
                    } else {
                        return;
                    }
                } else {
                    return
                }

                x = 0;
                y = 0;
                oX = 0;
                if (document.all) {
                    x = window.event.clientX
                    y = window.event.clientY + document.body.scrollTop
                } else {
                    x = event.clientX - oX
                    y = event.clientY + window.scrollY
                }
                x += Math.round(xs[idd])
                y += Math.round(ys[idd])

                obj = new Array()
                obj[0] = text
                obj[1] = x
                obj[2] = y

                timerId = setTimeout("showAlt()", 500);
            }

            var showAlt =function() {
                text = obj[0]
                x = obj[1]
                y = obj[2]
                altd = document.getElementById('altDiv')
                altd.innerHTML = "<table cellpadding=3 cellspacing=0 style='background-color: #EEF6FF; border: solid #6A91B4 1px; font-family: tahoma;" + (text.length > 30 ? "width: 200px;" : "") + "'><tr><td style='color: #414041; font-size: 11px;'>" + text + "</td></tr></table>"
                altd.style.left = Math.min(x + 10, document.body.clientWidth - 201)
                altd.style.top = y
                altd.style.display = 'inline'
            }

            var hideAlt =function() {
                obj = new Array()
                clearTimeout(timerId)
                altd = document.getElementById('altDiv')
                altd.innerHTML = ""
                altd.style.left = -100
                altd.style.top = -100
                altd.style.display = 'none'
            }

            var initAlts =function() {
                arr = document.getElementsByName('title')
                titles = new Array()
                xs = new Array()
                ys = new Array()
                for (i = 0; i < arr.length; i++) {
                    itemm = arr.item(i)
                    itemm.onmouseover = prepareShowAlt
                    itemm.onmouseout = hideAlt
                    itemm.id = "title_" + i
                    titles[i] = itemm.title
                    xs[i] = (typeof itemm.xs == 'undefined' ? 0 : itemm.xs)
                    ys[i] = (typeof itemm.ys == 'undefined' ? 0 : itemm.ys)
                    itemm.title = ""
                }
            }

            /* loader.js */

            var t_id = setInterval(animate, 20);
            var pos = 0;
            var dir = 2;
            var len = 0;

            var animate =function()
            {
                var elem = document.getElementById('progress');
                if (elem != null) {
                    if (pos == 0)
                        len += dir;
                    if (len > 32 || pos > 79)
                        pos += dir;
                    if (pos > 79)
                        len -= dir;
                    if (pos > 79 && len == 0)
                        pos = 0;
                    elem.style.left = pos;
                    elem.style.width = len;
                }
            }

            i.remove_loading =function() {
                this.clearInterval(t_id);
                var targelem = document.getElementById('loader_container');
                targelem.style.display = 'none';
                targelem.style.visibility = 'hidden';
                var t_id = setInterval(animate, 60);
            }
            return i;
       });
