angular.module('stwo.shopping', ['ui.sortable', 'angularLoad', 'ngTagsInput', 'stwo.core', 'stwo.glue', 'angularMoment', 'ui.calendar', 'ui.bootstrap', 'ui.bootstrap.datepicker', 'ui.bootstrap.timepicker', 'angular-google-gapi', 'ngAudio', 'ngVideo', 'ngFileUpload']).config(function ($provide, $stateProvider, $urlRouterProvider, moduleStoreProvider, $translateProvider) {
    moduleStoreProvider.registerModule({
        name: "shopping",
        links: [{
                name: "SHOPPING.TITLE",
                category: "navigation",
                icon: "fa fa-shopping-cart",
                sref: "secure.content.asset.shopping",
                sort: 5,
                color: "success"
            }]
    });
    $stateProvider.state("secure.content.shopping", {
        url: "/shopping:id",
        templateUrl: "modules/shopping/shopping.html",
        controller: "ShoppingController"
    });

    $stateProvider.state("secure.content.asset.shopping", {
        url: "/asset-shopping:id",
        templateUrl: "aktive-spor/dashboard/dashboard.html",
        controller: "ListShoppingController"
    });
}).factory("fetchData", function (smarttrackerService) {
    var imageList = [];
    var f = {};
    var productListID= null;
    var fileServerURL = "https://ri.smarttracker.no/files/resource.php";
    /*
     * data, the updated infomation of the images, names, prices
     * callback  callback function
     */
    f.fileServerURL=function(){
        return fileServerURL;
    };
    f.getProductListID=function(id,callback){
        if(productListID === null){
            this.fetchData(id,callback);
        } else return productListID;
    }
    f.fetchData = function (id, callback) {
        var showAllProducts = {"assetID": id, "type": "products"};
        var count = 0;
        console.log("fetch data",id,"type:products");
        smarttrackerService.authGetFile(showAllProducts).then(function (response) {
            if(response.data.length===0){
                var productsData = [];
                var fd = new FormData();
                fd.append("type", "products");
                fd.append("assetID", id);
                var blob = new Blob([JSON.stringify({"assetID":id,"products":  productsData}, null, 2)], {type: 'application/json'});
                fd.append("file", blob);
                
                smarttrackerService.authPostFile(fd).then(function(repons){
                    console.log(repons.resourceID);
                    productListID = repons.resourceID.toString();
                    callback(productListID); 
                });
            } else {
                productListID =response.data[0].resourceID.toString();
                imageList = JSON.parse(response.data[0].products);
                
                callback(productListID);
            }
//            for (var i = 0; i < response.data.length; i++) {
//                var _params = {"resourceID": response.data[i].resourceID, "assetID": id, "type": "images"};
//                smarttrackerService.authGetFile(_params).success(function (prodResponse) {
//                    var resourceID = response.data[count].resourceID;
//                        var data = prodResponse.image.toString();
//                        var name= prodResponse.name.toString();
//                        var price = prodResponse.price.toString();
//                        var serverItem = {image: data, id: resourceID, width:prodResponse.width,height:prodResponse.height,name: name, price: price, selected: false};
//                        imageList.push(serverItem);
//                        if (count+1 === response.data.length) {
//                            callback();
//                        }
//                        console.log("server item",serverItem);
//                        count = count + 1;
//                });
//            };
          
        })
    };

    f.getList = function () {
        return imageList;
    };
    f.updateList = function(item){
        angular.forEach(imageList,function(value){
            if(value.resourceID === item.resourceID){
                value = item;
                return;
            }
        });
        imageList.push(item);
    } 
    return f;
});
angular.module('stwo.shopping').controller('ListShoppingController', function (fetchData, $scope, $controller, $state, notificationService, moduleStore) {
    $controller('BaseListContentController', {
        $scope: $scope
    });
    $scope.super({
        clazz: 'asset',
        downloadUrl: '/asset?select=name+tags+type+tracked+image+icon+lastValidPosition&sort=name&order=asc'
    });
    $scope.assetClicked = function (asset) {
        fetchData.fetchData(asset.id, function () {
            $state.go("secure.content.shopping", {
                id: asset.id
            });
        });
    }
    $scope.$watch("items.length", function () {
        if ($scope.items && $scope.items.length === 1) {
            console.log("go to shopping page",$scope.items[0].id);
            fetchData.fetchData($scope.items[0].id, function () {
                console.log("call back ",$scope.items[0].id);
                $state.go("secure.content.shopping", {
                    id: $scope.items[0].id
                });
            });

        }
    });
})
angular.module('stwo.shopping').controller('ShoppingController', function (fetchData, angularLoad, demoMode, Upload, smarttrackerService, themeService, contentCacheService, $rootScope, $state, $scope, $modal, GAuth, GApi, $controller, $stateParams, $compile, uiCalendarConfig, ef, angularMomentConfig, $http, $timeout, $document) {
    themeService.loadWebTheme(themeService.chosenTheme());
//    var convertTobase64 = function (file, callback) {
//        var img = new Image();
//        img.crossOrigin = 'Anonymous';
//        img.onload = function () {
//            var canvas = document.createElement('CANVAS');
//            var ctx = canvas.getContext('2d');
//            var dataURL;
//            canvas.height = this.height;
//            canvas.width = this.width;
//            ctx.drawImage(this, 0, 0);
//            dataURL = canvas.toDataURL();
//            canvas = null;
//            callback(dataURL);
//
//        };
//        try {
//            img.src = URL.createObjectURL(file);
//        } catch (e) {
//        };
//    };
    $scope.DELETED = false;
    $scope.SUBMITTED = false;
    $scope.ERROR = false;
    $scope.product = {name: "", price: "", files: null,height:0,width:0};
    $scope.submitNewProduct = function () {
        if (!$scope.product.name || !$scope.product.price || !$scope.product.files) {
            $scope.ERROR = true;
            $timeout(function () {
                $scope.ERROR = false;
            }, 3000);
            return;
        }
        if ($scope.product.files[0] && $scope.product.name && $scope.product.price) {
            var fd = new FormData();
            fd.append("type", "images");
            fd.append("assetID", $stateParams.id);
            var file = $scope.product.files[0];
            fd.append("file", file);
            
                smarttrackerService.authPostFile(fd,true).then(function (response) {
//                    {image: data, id: resourceID, width:prodResponse.width,height:prodResponse.height,name: name, price: price, selected: false};
                    var updateProductsList = new FormData();
                    updateProductsList.append("assetID",$stateParams.id);
                    var item ={"resourceID":response.data.resourceID,"name": $scope.product.name 
                        ,"price":  $scope.product.price,"height":$scope.product.height,"width":$scope.product.width};
                    fetchData.updateList (item);
                    updateProductsList.append("file",fetchData.getList());
                    updateProductsList.append("resourceID",fetchData.getProductListID(function(id){return id;}));

                    smarttrackerService.authPostFile(updateProductsList,true).then(function(updateSuccess){
                        var image = {"id":response.data.resourceID,"name": $scope.product.name 
                            ,"price":  $scope.product.price,"height":$scope.product.height,"width":$scope.product.width};    
                        $scope.imageList = fetchData.getList();
                        
                            $scope.SUBMITTED = true;
                            $timeout(function () {
                                $scope.SUBMITTED = false;
                            }, 2000);  
                            console.log("submitted response",response);
                            console.log("submitted new product",{"id":response.data.resourceID,"name": $scope.product.name 
                                ,"price":  $scope.product.price,"height":$scope.product.height,"width":$scope.product.width});
                        });   
                });
        }
    };
    var handleFile = function () {
        var imagePreview = document.getElementById("imagePreview");
        imagePreview.innerHTML = "";
        var dataURLReader = new FileReader();
        dataURLReader.onload = function (event) {
            var dataURL = event.target.result;
            var image = new Image();
            image.src = dataURL;
            image.onload = function () {
                console.log("Image width: " + this.width);
                console.log("Image height: " + this.height);
                $scope.product.width=this.width;
                $scope.product.height = this.height;
                if (this.width < this.height) {
                    this.width = (this.width / this.height) * 100;
                    
                    this.height = 100;
                } else {
                    this.width = (this.height / this.width) * 100;
                    this.width = 100;
                }
                imagePreview.appendChild(this);
            };
        };
        dataURLReader.readAsDataURL($scope.product.files[0]);
    };
    $scope.defaultImage = true;
    $scope.fileDropped = function () {
        if ($scope.product.files && $scope.product.files[0]) {
            $scope.defaultImage = false;
            handleFile();
        }

    };
    $scope.imageList = fetchData.getList();
    $scope.showProducts = function () {
        angular.forEach($scope.imageList, function (value) {
            if (value.selected) {
                value.selected = false;
            }
        });
    };
    $scope.productSelected = {name: "", totalCost: 0, list: []};
    $scope.$watch("imageList", function () {
        console.log($scope.imageList);
        var total = 0;
        angular.forEach($scope.imageList,function(item){
           if(item.selected){
               total = total +parseInt(item.price);
               
           } 
        });
        $scope.productSelected.totalCost = total;        
    });

    $scope.listFileResourceID = "";
    $scope.saveList = function () {

        angular.forEach($scope.imageList, function (value) {
            if (value.selected) {
                var _temp = {name: value.name, price: value.price, imageID: value.id};
                $scope.productSelected.list.push(_temp);
            }
        });
        
        //handle multiple list, maybe the phone side app can just use the latest one or get the one with wantted name.
//        smarttrackerService.authGetFile({"assetID":$stateParams.id,"type":"list"}).then(function (response) {
//            if(response.data.length>1){
//                
//            }
//        });        
        var uploadForm = new FormData();
        uploadForm.append("type", "list");
        uploadForm.append("assetID", $stateParams.id);
        var uploadData = new File([$scope.list], "filename");
        uploadForm.append("file", uploadData);
        smarttrackerService.authPostFile(uploadForm).then(function (response) {
            //popup dialog
            console.log("upload list successfully.");
        });

    }
    $scope.tab = 3;
    $scope.setTab = function(tabId){
        $scope.tab = tabId;
    };
    $scope.isSet = function (tabId){
        if($scope.tab === tabId){
            angular.forEach($scope.imageList,function(product){
                product.selected = false;
            });       
            return true;
        }
        return false;

    };

    $scope.SUBMITLIST =false;
    $scope.deleted = [];
    // problems with deleting multiple items at the same time.
    $scope.deleteProduct = function () {
        var deleteIDs = [];
        var newArray = [];
        angular.forEach($scope.imageList, function (value) {
            if (value.selected) {
                deleteIDs.push(value.id);
            } else newArray.push(value);
        });
        var a2 = 1;
        for (var i = 0; i < deleteIDs.length; i++) {
            console.log(deleteIDs[i]);
            var parameters = {assetID: $stateParams.id, resourceID: deleteIDs[i]};
            smarttrackerService.authDeleteFile(parameters).then(function (response) {
                console.log(a2,deleteIDs.length);
                if (a2 === deleteIDs.length) {
                    $scope.deleted = deleteIDs;
                    $scope.imageList = newArray;
                    for (var j = 0; j < deleteIDs.length; j++) {
                        console.log("delete procut from list according to id",deleteIDs[j]);                         
//                            delete image list on the view
                            console.log($document.find("img#" + deleteIDs[j]));
                            angular.element($document.find("img#" + deleteIDs[j])[0]).parent().parent().remove();
                    }

                    $scope.DELETED = true;
                    $timeout(function () {
                        $scope.DELETED = false;
                    }, 2000);
                }
                a2 = a2 + 1;
            });
        };
    };
    $scope.cancelList = function(){
        $scope.SUBMITLIST = false;        
    }
            $scope.mouseOver =function(id){
                angular.element("img#" + id).css("width", "100%");
                angular.element("img#" + id).css("height", "100%");
            };
            $scope.mouseLeave =function(id){
                console.log("mouseLeave called",angular.element("img#"+id));
                angular.forEach($scope.imageList,function(value){
                    if(id === value.id){
                        angular.element("img#"+id).css("height","").css("width","");
                    }
                });                   
            };      
            $scope.clicked = function (id) {   
                var totalCost= 0;
                angular.forEach($scope.imageList, function (value) {
                    console.log("id",value.id,id);
                    if (value.id === id) {
                        value.selected = !value.selected;
                        if (value.selected) {
                            angular.element("img#" + id).css("border", "3px solid");
                        } else{
                            angular.element("img#" + id).css("border", "0px solid");
                        }
                    }
                });
                angular.forEach($scope.imageList, function (value) {
                    console.log("id",value.id,id);
                        if (value.selected) {
                            totalCost=totalCost+parseInt(value.price);
                            console.log("value",value,parseInt(value.price));
                        } 
                });                
                $scope.productSelected.totalCost = totalCost;
                          
            }            

})
//        .directive('imageList', function () {
//    return {
//        restrict: 'A',
//        scope: {
//            list: "=",
//            selected : "=",
//            deleteItems:"="
//        },
//        controller: "ShoppingController",
//        templateUrl: "modules/shopping/imagelist.html",
//        link: function (scope, element, attrs) {
//            angular.forEach(scope.list,function(value){
//                if(!value.width||!value.height){
//                    element.find("img#" + value.id).css("width","100");
//                    element.find("img#" + value.id).css("height","100");
//                }
//                if(value.width>value.height){
//                    element.find("img#" + value.id).css("width","100");
//                    element.find("img#" + value.id).css("height","");
//                } else {element.find("img#"+value.id).css("height","100");
//                    element.find("img#" + value.id).css("width","");
//                };
//            });
//            scope.$watch("list",function(){  
//                console.log(scope.deleteItems);
//                angular.forEach(scope.deleteItems ,function(d){
//                    console.log(d);
//                    element.find("img#" + d).parent().parent().remove();
//                });
////                console.log(element.find("img.product"));
////                for(var i= 0;i<$document.element.find("img.product").length;i++){
////                    console.log(element.find("img.product")[i]);
////                    var _img = element.find("img.product")[i];
////                    
////                    var index=_img.indexOf("id=\"");
////                    console.log(_img,index,_img.substring(index,_img.length));
////                   
////                    var id= angular.element(element.find("img.product")[i]).data('id');
////                   
////                    if(notIn(id)){
////                        element.find("img#" + id).parent().parent().remove();
////                        console.log("product with id ",id," removed");
////                        }
////                };
//
//                
//            });
//            var notIn = function(id){
//                for(var i = 0;i<scope.list.length;i++){
//                    if(id === scope.list[i].id){
//                        return false;
//                    }
//                }
//                return true;
//            }
//            scope.mouseOver =function(id){
//                element.find("img#" + id).css("width", "100%");
//                element.find("img#" + id).css("height", "100%");
//            };
//            scope.mouseLeave =function(id){
//                console.log("mouseLeave called",element.find("img#"+id));
//                angular.forEach(scope.list,function(value){
//                    if(id === value.id){
//                        element.find("img#"+id).css("height","").css("width","");
//                    }
//                });                   
//            };            
//            scope.clicked = function (id) {   
//                var totalCost= 0;
//                angular.forEach(scope.list, function (value) {
//                    console.log("id",value.id,id);
//                    if (value.id === id) {
//                        value.selected = !value.selected;
//                        if (value.selected) {
//                            element.find("img#" + id).css("border", "3px solid");
//                        } else{
//                            element.find("img#" + id).css("border", "0px solid");
//                        }
//                    }
//                });
//                angular.forEach(scope.list, function (value) {
//                    console.log("id",value.id,id);
//      
//             
//                        if (value.selected) {
//                            totalCost=totalCost+parseInt(value.price);
//                            console.log("value",value,parseInt(value.price));
//                        } 
//                });                
//                scope.selected.totalCost = totalCost;
//                console.log(scope.selected.totalCost,totalCost );                
//            }
//        }
//    };
//});