var assetApp = angular.module('stwo.videos', ["stwo.core", 'ui.bootstrap', 'ui.calendar', 'angular-google-gapi', 'ngFileUpload', 'angular.css.injector'])
        .config(function ($provide, $stateProvider,
                $urlRouterProvider, moduleStoreProvider, $translateProvider) {
            moduleStoreProvider.registerModule({
                name: "video",
                links: [{
                        name: "VIDEO.TITLE",
                        category: "navigation",
                        icon: "fa fa-video-camera",
                        sref: "secure.content.asset.video",
                        sort: 7,
                        color: "success"
                    }]
            });
            $stateProvider.state("secure.content.asset.videodetail", {
                url: "/video:id/:resourceID",
                templateUrl: "modules/video/videos.html",
                controller: "VideoDetailController"
            });

            $stateProvider.state("secure.content.asset.video", {
                url: "/asset-video",
                templateUrl: "aktive-spor/dashboard/dashboard.html",
                controller: "ListVideoController"
            });

        })
        .factory("get", function (smarttrackerService) {
            var i = {};
            i.get = function (assetId, callback) {
                var data = {type: "videolist", assetId: assetId};
                smarttrackerService.authGetFile(data, true).then(function (res) {
                    console.info(res);
                    if (res.data.length === 0) {
                        var resourceID = "";
                        callback(resourceID);
                    } else {
                        callback(res.data[0].resourceID);
                    }

                });
            };
            return i;
        });

angular.module('stwo.videos').controller('ListVideoController', function (get, $scope, $controller, $state, notificationService, moduleStore) {
    $controller('BaseListContentController', {
        $scope: $scope
    });
    $scope.super({
        clazz: 'asset',
        downloadUrl: '/asset?select=name+tags+type+tracked+image+icon+lastValidPosition&sort=name&order=asc'
    });
    $scope.assetClicked = function (asset) {
        get.get(asset.id, function (resourceID) {
            $state.go("secure.content.asset.videodetail", {
                id: asset.id,
                resourceID: resourceID
            });
        });


    }
    $scope.$watch("items.length", function () {
        if ($scope.items && $scope.items.length === 1) {
            console.log("listing");
            get.get($scope.items[0].id, function (resourceID) {
                $state.go("secure.content.asset.videodetail", {
                    id: $scope.items[0].id,
                    resourceID: resourceID
                });
            });

        }
    });
})
angular.module('stwo.videos').controller('VideoDetailController', function (get, $timeout, youtubeEmbedUtils, angularLoad, demoMode, Upload, smarttrackerService, themeService, contentCacheService, $rootScope, $state, $scope, $stateParams, $compile, uiCalendarConfig, ef, angularMomentConfig, $document) {
    themeService.loadWebTheme(themeService.chosenTheme());
    $scope.videos = [];
    $scope.video = "";
    console.log($stateParams);
    if ($stateParams.resourceID && $stateParams.resourceID !== "") {
        $scope.videosResourceID = $stateParams.resourceID;
        var getVideoList = {resourceID: $stateParams.resourceID};
        smarttrackerService.authGetFile(getVideoList, true).then(function (response) {
            console.log(response);
            var videoList = response.data;
            angular.forEach(videoList.videos, function (video) {
                $scope.videos.push(video);
                var width = "350px";
                $timeout(function () {
                    document.getElementById(video.id).innerHTML = '<video id="video" width="' + width + '" height="302px" controls>' +
                            '<source src="' + "https://ri.smarttracker.no/files/resource.php?resourceID=" + video.id + '" type="video/mp4">' +
                            '</video>';
                }, 3000);
            });
        });
    } else {

        console.log("create new list");
        var fd = new FormData();
        fd.append("type", "videolist");

        var blob = new Blob([JSON.stringify({"assetID": $stateParams.id, "videos": []}, null, 2)], {type: 'application/json'});
        fd.append("file", blob);
        smarttrackerService.authPostFile(fd, true).then(function (res) {
            $scope.videosResourceID = res.data.resourceID;
            console.info(res);
        });
    }
    $scope.fileDropped = function (files) {
        if (files === null || files === undefined || files.length < 1) {
            return;
        }
        console.log("fileDropped called", files);
        var type = "";

        console.log("upload type", type);
        if (files && files.length > 0) {
            $scope.uploadMediaFile(files, type);
        }
    };
    $scope.uploadMediaFile = function (files) {

        if (files && files.length > 0) {
            $scope.uploadInProgress = true;
            for (var i = 0; i < files.length; i++) {
                var file = files[i];
                console.log(file);
                $scope.uploadInProgress = true;
                var fd = new FormData();
                fd.append("file", file);

                var type = "video";

                return Upload.upload({
                    method: "POST",
                    headers: {"X-Auth-Token": smarttrackerService.getToken(),
                        "Content-Type": undefined,
                        "Access-Control-Allow-Origin": "*"},
                    url: stwoGlobal.fileBaseUrl + stwoGlobal.fileUploadPostFix,
                    data: {file: files[i], type: type}
                }).progress(function (evt) {
                    var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
                    $scope.uploadProgress = progressPercentage;
                    $scope.log = 'progress: ' + progressPercentage + '% \n' + $scope.log;
                }).success(function (data, status, headers, config) {
                    console.log("uploaded File success", data, type);
                    var _video = {type: "fileServer", id: data.resourceID};


                    var submitList = angular.copy($scope.videos);
                    try {
                        submitList.push(_video);
                    }
                    catch (response) {
                        console.error(response);
                    }
                    ;
                    console.log(submitList);
                    var fd = new FormData();
                    fd.append("type", "videolist");
                    fd.append("assetID", $stateParams.id);
                    fd.append("resourceID", $scope.videosResourceID);
//        fd.append("file",submitList);
                    var blob = new Blob([JSON.stringify({"assetID": $stateParams.id, "videos": submitList}, null, 2)], {type: 'application/json'});
                    fd.append("file", blob);
                    smarttrackerService.authPostFile(fd, true).then(function (response1) {
                        console.log(response1);
                        $scope.videos.push(_video);
                        var width = "300px";
                        $timeout(function () {
                            document.getElementById(_video.id).innerHTML = '<video id="video" width="' + width + '" height="302px" controls>' +
                                    '<source src="' + "https://ri.smarttracker.no/files/resource.php?resourceID=" + _video.id + '" type="video/mp4">' +
                                    '</video>';
                        }, 3000);
                    });
                    $scope.log = 'file uploaded. Response: ' + JSON.stringify(data) + '\n' + $scope.log;

//                    if (data.indexOf("to big") > 0) {
//                        $scope.errorFeedback = "Upload failed. Check file size";
//                    } else 
                    $scope.errorFeedback = "";
                    $scope.uploadInProgress = false;
                    $scope.uploadProgress = 0;
                });
            }
        }
    };
    $scope.deleteClicked = function (id) {
//        var data = {type: "videolist", "url": $scope.videosResourceID};

        var videoData = angular.copy($scope.videos);
        for (var index = 0; index < videoData.length; index++) {
            if (id === videoData[index].id) {
                videoData.splice(index, 1);
                console.log("video list after delete", videoData);
            }
        }
        var fd = new FormData();
        fd.append("type", "videolist");
        fd.append("assetID", $stateParams.id);
        fd.append("resourceID", $scope.videosResourceID);
        var blob = new Blob([JSON.stringify({"assetID": $stateParams.id, "videos": videoData}, null, 2)], {type: 'application/json'});
        fd.append("file", blob);
        smarttrackerService.authPostFile(fd, true).then(function (res) {
            for (var index = 0; index < $scope.videos.length; index++) {
                if (id === $scope.videos[index].id) {
                    $scope.videos.splice(index, 1);
                    console.log("video list after delete", $scope.videos);
                }
            }
            console.info(res);
        });
    }
    
    $scope.editTitleClicked = function (item) {
    	$scope.editTitleId = item.id;
    	item.editTitleValue = item.name;
    }
    $scope.saveTitle = function() {
    	console.info("Edit Title");
    	
    	for(var i in $scope.videos){
    		var _video = $scope.videos[i];
    		if(_video.id == $scope.editTitleId) {
    			_video.name = _video.editTitleValue;
    			break;
    		}
    	}
    	$scope.editTitleWorking = $scope.editTitleId;
    	 var fd = new FormData();
         fd.append("type", "videolist");
         fd.append("assetID", $stateParams.id);
         fd.append("resourceID", $scope.videosResourceID);
//         fd.append("file",submitList);
         var blob = new Blob([JSON.stringify({"assetID": $stateParams.id, "videos": $scope.videos}, null, 2)], {type: 'application/json'});
         fd.append("file", blob);
         $scope.editTitleId = "";
         smarttrackerService.authPostFile(fd, true).then(function (response1) {
             console.log(response1);
           
            
            $scope.editTitleWorking = "";
         });
    	
    }
//    $scope.validURL = function (str) {
//  var pattern = new RegExp('^(https?:\\/\\/)?((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.)+[a-z]{2,}|((\\d{1,3}\\.){3}\\d{1,3}))(\\?[;&a-z\\d%_.~+=-]*)?(\\#[-a-z\\d_]*)?$','i'); // fragment locater
//  if(!pattern.test(str)) 
//  {
//    return false;
//    //return false;
//  } 
//  else
//  {
//    return true;
//    //return true;
//  }
//    }
    
   
    $scope.addClicked = function () {
//        $scope.validURL($scope.video);
        console.info("add video");
        var _video = {type: "youtube", id: youtubeEmbedUtils.getIdFromURL($scope.video), url: $scope.video, name: ""};
        $scope.video = "";
//        var videoList = {"resourceID": $scope.videosResourceID};
        var submitList = angular.copy($scope.videos);
        try {
            submitList.push(_video);
        }
        catch (response) {
            console.error(response);
        }
        ;
        console.log(submitList);
        var fd = new FormData();
        fd.append("type", "videolist");
        fd.append("assetID", $stateParams.id);
        fd.append("resourceID", $scope.videosResourceID);
//        fd.append("file",submitList);
        var blob = new Blob([JSON.stringify({"assetID": $stateParams.id, "videos": submitList}, null, 2)], {type: 'application/json'});
        fd.append("file", blob);
        smarttrackerService.authPostFile(fd, true).then(function (response1) {
            console.log(response1);
            $scope.videos.push(_video);
        });
    };
    $scope.selectedLanguage ={};
                        
    smarttrackerService.isLoggedInDelayed().then(function () {
        smarttrackerService.authGet(smarttrackerService.getCustomerId() + '/asset/' + $stateParams.id + '?select=*').then(function (response) {
            $scope.asset = response.data.result[0];
            for (var i = 0; i < $scope.asset.properties.length; i++) {
                if ($scope.asset.properties[i].name === "language") {
                    smarttrackerService.language($scope.asset.properties[i].value);
                    $scope.language = smarttrackerService.language();
                    if ($scope.language === "no") {
                        $scope.selectedLanguage.code ="no";
                        $scope.event_youtube_link = "Lim inn YouTube-link her";
                    }
                    if (smarttrackerService.language() === "en") {
                        $scope.selectedLanguage.code ="en";
                        $scope.event_youtube_link = "Paste YouTube link here.";
                    }
                    ;
                    if (smarttrackerService.language() === "de") {
                        $scope.selectedLanguage.code ="de";
                        $scope.event_youtube_link = "Einfügen YouTube Link hier.";
                    }
                }


            }
            ;
        });
    });
});

